/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 5.9.6
 * @date    2020-05-21T07:27:40.628Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t=t||self).vis=t.vis||{})}(this,(function(t){"use strict";var e=function(t){try{return!!t()}catch(t){return!0}},n={}.toString,r=function(t){return n.call(t).slice(8,-1)},i="".split,o=e((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==r(t)?i.call(t,""):Object(t)}:Object,a=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},s=function(t){return o(a(t))},u={},l="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function h(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function c(t,e){return t(e={exports:{}},e.exports),e.exports}function f(t){return t&&t.default||t}var d=function(t){return t&&t.Math==Math&&t},p=d("object"==typeof globalThis&&globalThis)||d("object"==typeof window&&window)||d("object"==typeof self&&self)||d("object"==typeof l&&l)||Function("return this")(),v=!e((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),m=function(t){return"object"==typeof t?null!==t:"function"==typeof t},y=p.document,g=m(y)&&m(y.createElement),_=function(t){return g?y.createElement(t):{}},w=!v&&!e((function(){return 7!=Object.defineProperty(_("div"),"a",{get:function(){return 7}}).a})),b=function(t){if(!m(t))throw TypeError(String(t)+" is not an object");return t},x=function(t,e){if(!m(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!m(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!m(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!m(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")},S=Object.defineProperty,k={f:v?S:function(t,e,n){if(b(t),e=x(e,!0),b(n),w)try{return S(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(t[e]=n.value),t}},D=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},T=v?function(t,e,n){return k.f(t,e,D(1,n))}:function(t,e,n){return t[e]=n,t},O=p["__core-js_shared__"]||function(t,e){try{T(p,t,e)}catch(n){p[t]=e}return e}("__core-js_shared__",{}),M=Function.toString;"function"!=typeof O.inspectSource&&(O.inspectSource=function(t){return M.call(t)});var E,C,A,P=O.inspectSource,L=p.WeakMap,R="function"==typeof L&&/native code/.test(P(L)),Y={}.hasOwnProperty,N=function(t,e){return Y.call(t,e)},I=c((function(t){(t.exports=function(t,e){return O[t]||(O[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),j=0,z=Math.random(),W=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++j+z).toString(36)},F=I("keys"),G=function(t){return F[t]||(F[t]=W(t))},V={},U=p.WeakMap;if(R){var B=new U,H=B.get,Z=B.has,X=B.set;E=function(t,e){return X.call(B,t,e),e},C=function(t){return H.call(B,t)||{}},A=function(t){return Z.call(B,t)}}else{var q=G("state");V[q]=!0,E=function(t,e){return T(t,q,e),e},C=function(t){return N(t,q)?t[q]:{}},A=function(t){return N(t,q)}}var $,Q,J,K={set:E,get:C,has:A,enforce:function(t){return A(t)?C(t):E(t,{})},getterFor:function(t){return function(e){var n;if(!m(e)||(n=C(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return n}}},tt={}.propertyIsEnumerable,et=Object.getOwnPropertyDescriptor,nt={f:et&&!tt.call({1:2},1)?function(t){var e=et(this,t);return!!e&&e.enumerable}:tt},rt=Object.getOwnPropertyDescriptor,it={f:v?rt:function(t,e){if(t=s(t),e=x(e,!0),w)try{return rt(t,e)}catch(t){}if(N(t,e))return D(!nt.f.call(t,e),t[e])}},ot=/#|\.prototype\./,at=function(t,n){var r=ut[st(t)];return r==ht||r!=lt&&("function"==typeof n?e(n):!!n)},st=at.normalize=function(t){return String(t).replace(ot,".").toLowerCase()},ut=at.data={},lt=at.NATIVE="N",ht=at.POLYFILL="P",ct=at,ft={},dt=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},pt=function(t,e,n){if(dt(t),void 0===e)return t;switch(n){case 0:return function(){return t.call(e)};case 1:return function(n){return t.call(e,n)};case 2:return function(n,r){return t.call(e,n,r)};case 3:return function(n,r,i){return t.call(e,n,r,i)}}return function(){return t.apply(e,arguments)}},vt=it.f,mt=function(t){var e=function(e,n,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},yt=function(t,e){var n,r,i,o,a,s,u,l,h=t.target,c=t.global,f=t.stat,d=t.proto,v=c?p:f?p[h]:(p[h]||{}).prototype,m=c?ft:ft[h]||(ft[h]={}),y=m.prototype;for(i in e)n=!ct(c?i:h+(f?".":"#")+i,t.forced)&&v&&N(v,i),a=m[i],n&&(s=t.noTargetGet?(l=vt(v,i))&&l.value:v[i]),o=n&&s?s:e[i],n&&typeof a==typeof o||(u=t.bind&&n?pt(o,p):t.wrap&&n?mt(o):d&&"function"==typeof o?pt(Function.call,o):o,(t.sham||o&&o.sham||a&&a.sham)&&T(u,"sham",!0),m[i]=u,d&&(N(ft,r=h+"Prototype")||T(ft,r,{}),ft[r][i]=o,t.real&&y&&!y[i]&&T(y,i,o)))},gt=function(t){return Object(a(t))},_t=!e((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),wt=G("IE_PROTO"),bt=Object.prototype,xt=_t?Object.getPrototypeOf:function(t){return t=gt(t),N(t,wt)?t[wt]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?bt:null},St=!!Object.getOwnPropertySymbols&&!e((function(){return!String(Symbol())})),kt=St&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Dt=I("wks"),Tt=p.Symbol,Ot=kt?Tt:Tt&&Tt.withoutSetter||W,Mt=function(t){return N(Dt,t)||(St&&N(Tt,t)?Dt[t]=Tt[t]:Dt[t]=Ot("Symbol."+t)),Dt[t]},Et=(Mt("iterator"),!1);[].keys&&("next"in(J=[].keys())?(Q=xt(xt(J)))!==Object.prototype&&($=Q):Et=!0),null==$&&($={});var Ct,At={IteratorPrototype:$,BUGGY_SAFARI_ITERATORS:Et},Pt=Math.ceil,Lt=Math.floor,Rt=function(t){return isNaN(t=+t)?0:(t>0?Lt:Pt)(t)},Yt=Math.min,Nt=function(t){return t>0?Yt(Rt(t),9007199254740991):0},It=Math.max,jt=Math.min,zt=function(t,e){var n=Rt(t);return n<0?It(n+e,0):jt(n,e)},Wt=function(t){return function(e,n,r){var i,o=s(e),a=Nt(o.length),u=zt(r,a);if(t&&n!=n){for(;a>u;)if((i=o[u++])!=i)return!0}else for(;a>u;u++)if((t||u in o)&&o[u]===n)return t||u||0;return!t&&-1}},Ft={includes:Wt(!0),indexOf:Wt(!1)},Gt=Ft.indexOf,Vt=function(t,e){var n,r=s(t),i=0,o=[];for(n in r)!N(V,n)&&N(r,n)&&o.push(n);for(;e.length>i;)N(r,n=e[i++])&&(~Gt(o,n)||o.push(n));return o},Ut=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Bt=Object.keys||function(t){return Vt(t,Ut)},Ht=v?Object.defineProperties:function(t,e){b(t);for(var n,r=Bt(e),i=r.length,o=0;i>o;)k.f(t,n=r[o++],e[n]);return t},Zt=function(t){return"function"==typeof t?t:void 0},Xt=function(t,e){return arguments.length<2?Zt(ft[t])||Zt(p[t]):ft[t]&&ft[t][e]||p[t]&&p[t][e]},qt=Xt("document","documentElement"),$t=G("IE_PROTO"),Qt=function(){},Jt=function(t){return"<script>"+t+"<\/script>"},Kt=function(){try{Ct=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Kt=Ct?function(t){t.write(Jt("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Ct):((e=_("iframe")).style.display="none",qt.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(Jt("document.F=Object")),t.close(),t.F);for(var n=Ut.length;n--;)delete Kt.prototype[Ut[n]];return Kt()};V[$t]=!0;var te=Object.create||function(t,e){var n;return null!==t?(Qt.prototype=b(t),n=new Qt,Qt.prototype=null,n[$t]=t):n=Kt(),void 0===e?n:Ht(n,e)},ee={};ee[Mt("toStringTag")]="z";var ne="[object z]"===String(ee),re=Mt("toStringTag"),ie="Arguments"==r(function(){return arguments}()),oe=ne?r:function(t){var e,n,i;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),re))?n:ie?r(e):"Object"==(i=r(e))&&"function"==typeof e.callee?"Arguments":i},ae=ne?{}.toString:function(){return"[object "+oe(this)+"]"},se=k.f,ue=Mt("toStringTag"),le=function(t,e,n,r){if(t){var i=n?t:t.prototype;N(i,ue)||se(i,ue,{configurable:!0,value:e}),r&&!ne&&T(i,"toString",ae)}},he=At.IteratorPrototype,ce=function(){return this},fe=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,n={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),e=n instanceof Array}catch(t){}return function(n,r){return b(n),function(t){if(!m(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(r),e?t.call(n,r):n.__proto__=r,n}}():void 0),de=function(t,e,n,r){r&&r.enumerable?t[e]=n:T(t,e,n)},pe=At.IteratorPrototype,ve=At.BUGGY_SAFARI_ITERATORS,me=Mt("iterator"),ye=function(){return this},ge=function(t,e,n,r,i,o,a){!function(t,e,n){var r=e+" Iterator";t.prototype=te(he,{next:D(1,n)}),le(t,r,!1,!0),u[r]=ce}(n,e,r);var s,l,h,c=function(t){if(t===i&&m)return m;if(!ve&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new n(this,t)}}return function(){return new n(this)}},f=e+" Iterator",d=!1,p=t.prototype,v=p[me]||p["@@iterator"]||i&&p[i],m=!ve&&v||c(i),y="Array"==e&&p.entries||v;if(y&&(s=xt(y.call(new t)),pe!==Object.prototype&&s.next&&(le(s,f,!0,!0),u[f]=ye)),"values"==i&&v&&"values"!==v.name&&(d=!0,m=function(){return v.call(this)}),a&&p[me]!==m&&T(p,me,m),u[e]=m,i)if(l={values:c("values"),keys:o?m:c("keys"),entries:c("entries")},a)for(h in l)(ve||d||!(h in p))&&de(p,h,l[h]);else yt({target:e,proto:!0,forced:ve||d},l);return l},_e=K.set,we=K.getterFor("Array Iterator");ge(Array,"Array",(function(t,e){_e(this,{type:"Array Iterator",target:s(t),index:0,kind:e})}),(function(){var t=we(this),e=t.target,n=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:r,done:!1}:"values"==n?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");u.Arguments=u.Array;var be=Mt("toStringTag");for(var xe in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Se=p[xe],ke=Se&&Se.prototype;ke&&oe(ke)!==be&&T(ke,be,xe),u[xe]=u.Array}var De=function(t){return function(e,n){var r,i,o=String(a(e)),s=Rt(n),u=o.length;return s<0||s>=u?t?"":void 0:(r=o.charCodeAt(s))<55296||r>56319||s+1===u||(i=o.charCodeAt(s+1))<56320||i>57343?t?o.charAt(s):r:t?o.slice(s,s+2):i-56320+(r-55296<<10)+65536}},Te={codeAt:De(!1),charAt:De(!0)}.charAt,Oe=K.set,Me=K.getterFor("String Iterator");ge(String,"String",(function(t){Oe(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Me(this),n=e.string,r=e.index;return r>=n.length?{value:void 0,done:!0}:(t=Te(n,r),e.index+=t.length,{value:t,done:!1})}));var Ee,Ce,Ae=Mt("iterator"),Pe=function(t){if(null!=t)return t[Ae]||t["@@iterator"]||u[oe(t)]},Le=function(t){var e=Pe(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return b(e.call(t))},Re=Pe,Ye=Array.isArray||function(t){return"Array"==r(t)},Ne=function(t,e,n){var r=x(e);r in t?k.f(t,r,D(0,n)):t[r]=n},Ie=Mt("species"),je=function(t,e){var n;return Ye(t)&&("function"!=typeof(n=t.constructor)||n!==Array&&!Ye(n.prototype)?m(n)&&null===(n=n[Ie])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===e?0:e)},ze=Xt("navigator","userAgent")||"",We=p.process,Fe=We&&We.versions,Ge=Fe&&Fe.v8;Ge?Ce=(Ee=Ge.split("."))[0]+Ee[1]:ze&&(!(Ee=ze.match(/Edge\/(\d+)/))||Ee[1]>=74)&&(Ee=ze.match(/Chrome\/(\d+)/))&&(Ce=Ee[1]);var Ve=Ce&&+Ce,Ue=Mt("species"),Be=function(t){return Ve>=51||!e((function(){var e=[];return(e.constructor={})[Ue]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},He=Mt("isConcatSpreadable"),Ze=Ve>=51||!e((function(){var t=[];return t[He]=!1,t.concat()[0]!==t})),Xe=Be("concat"),qe=function(t){if(!m(t))return!1;var e=t[He];return void 0!==e?!!e:Ye(t)};yt({target:"Array",proto:!0,forced:!Ze||!Xe},{concat:function(t){var e,n,r,i,o,a=gt(this),s=je(a,0),u=0;for(e=-1,r=arguments.length;e<r;e++)if(o=-1===e?a:arguments[e],qe(o)){if(u+(i=Nt(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(n=0;n<i;n++,u++)n in o&&Ne(s,u,o[n])}else{if(u>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Ne(s,u++,o)}return s.length=u,s}});var $e=Object.freeze({__proto__:null}),Qe=Ut.concat("length","prototype"),Je={f:Object.getOwnPropertyNames||function(t){return Vt(t,Qe)}},Ke=Je.f,tn={}.toString,en="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],nn={f:function(t){return en&&"[object Window]"==tn.call(t)?function(t){try{return Ke(t)}catch(t){return en.slice()}}(t):Ke(s(t))}},rn={f:Object.getOwnPropertySymbols},on={f:Mt},an=k.f,sn=function(t){var e=ft.Symbol||(ft.Symbol={});N(e,t)||an(e,t,{value:on.f(t)})},un=[].push,ln=function(t){var e=1==t,n=2==t,r=3==t,i=4==t,a=6==t,s=5==t||a;return function(u,l,h,c){for(var f,d,p=gt(u),v=o(p),m=pt(l,h,3),y=Nt(v.length),g=0,_=c||je,w=e?_(u,y):n?_(u,0):void 0;y>g;g++)if((s||g in v)&&(d=m(f=v[g],g,p),t))if(e)w[g]=d;else if(d)switch(t){case 3:return!0;case 5:return f;case 6:return g;case 2:un.call(w,f)}else if(i)return!1;return a?-1:r||i?i:w}},hn={forEach:ln(0),map:ln(1),filter:ln(2),some:ln(3),every:ln(4),find:ln(5),findIndex:ln(6)},cn=hn.forEach,fn=G("hidden"),dn=Mt("toPrimitive"),pn=K.set,vn=K.getterFor("Symbol"),mn=Object.prototype,yn=p.Symbol,gn=Xt("JSON","stringify"),_n=it.f,wn=k.f,bn=nn.f,xn=nt.f,Sn=I("symbols"),kn=I("op-symbols"),Dn=I("string-to-symbol-registry"),Tn=I("symbol-to-string-registry"),On=I("wks"),Mn=p.QObject,En=!Mn||!Mn.prototype||!Mn.prototype.findChild,Cn=v&&e((function(){return 7!=te(wn({},"a",{get:function(){return wn(this,"a",{value:7}).a}})).a}))?function(t,e,n){var r=_n(mn,e);r&&delete mn[e],wn(t,e,n),r&&t!==mn&&wn(mn,e,r)}:wn,An=function(t,e){var n=Sn[t]=te(yn.prototype);return pn(n,{type:"Symbol",tag:t,description:e}),v||(n.description=e),n},Pn=kt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof yn},Ln=function(t,e,n){t===mn&&Ln(kn,e,n),b(t);var r=x(e,!0);return b(n),N(Sn,r)?(n.enumerable?(N(t,fn)&&t[fn][r]&&(t[fn][r]=!1),n=te(n,{enumerable:D(0,!1)})):(N(t,fn)||wn(t,fn,D(1,{})),t[fn][r]=!0),Cn(t,r,n)):wn(t,r,n)},Rn=function(t,e){b(t);var n=s(e),r=Bt(n).concat(jn(n));return cn(r,(function(e){v&&!Yn.call(n,e)||Ln(t,e,n[e])})),t},Yn=function(t){var e=x(t,!0),n=xn.call(this,e);return!(this===mn&&N(Sn,e)&&!N(kn,e))&&(!(n||!N(this,e)||!N(Sn,e)||N(this,fn)&&this[fn][e])||n)},Nn=function(t,e){var n=s(t),r=x(e,!0);if(n!==mn||!N(Sn,r)||N(kn,r)){var i=_n(n,r);return!i||!N(Sn,r)||N(n,fn)&&n[fn][r]||(i.enumerable=!0),i}},In=function(t){var e=bn(s(t)),n=[];return cn(e,(function(t){N(Sn,t)||N(V,t)||n.push(t)})),n},jn=function(t){var e=t===mn,n=bn(e?kn:s(t)),r=[];return cn(n,(function(t){!N(Sn,t)||e&&!N(mn,t)||r.push(Sn[t])})),r};if(St||(de((yn=function(){if(this instanceof yn)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=W(t),n=function(t){this===mn&&n.call(kn,t),N(this,fn)&&N(this[fn],e)&&(this[fn][e]=!1),Cn(this,e,D(1,t))};return v&&En&&Cn(mn,e,{configurable:!0,set:n}),An(e,t)}).prototype,"toString",(function(){return vn(this).tag})),de(yn,"withoutSetter",(function(t){return An(W(t),t)})),nt.f=Yn,k.f=Ln,it.f=Nn,Je.f=nn.f=In,rn.f=jn,on.f=function(t){return An(Mt(t),t)},v&&wn(yn.prototype,"description",{configurable:!0,get:function(){return vn(this).description}})),yt({global:!0,wrap:!0,forced:!St,sham:!St},{Symbol:yn}),cn(Bt(On),(function(t){sn(t)})),yt({target:"Symbol",stat:!0,forced:!St},{for:function(t){var e=String(t);if(N(Dn,e))return Dn[e];var n=yn(e);return Dn[e]=n,Tn[n]=e,n},keyFor:function(t){if(!Pn(t))throw TypeError(t+" is not a symbol");if(N(Tn,t))return Tn[t]},useSetter:function(){En=!0},useSimple:function(){En=!1}}),yt({target:"Object",stat:!0,forced:!St,sham:!v},{create:function(t,e){return void 0===e?te(t):Rn(te(t),e)},defineProperty:Ln,defineProperties:Rn,getOwnPropertyDescriptor:Nn}),yt({target:"Object",stat:!0,forced:!St},{getOwnPropertyNames:In,getOwnPropertySymbols:jn}),yt({target:"Object",stat:!0,forced:e((function(){rn.f(1)}))},{getOwnPropertySymbols:function(t){return rn.f(gt(t))}}),gn){var zn=!St||e((function(){var t=yn();return"[null]"!=gn([t])||"{}"!=gn({a:t})||"{}"!=gn(Object(t))}));yt({target:"JSON",stat:!0,forced:zn},{stringify:function(t,e,n){for(var r,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(r=e,(m(e)||void 0!==t)&&!Pn(t))return Ye(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!Pn(e))return e}),i[1]=e,gn.apply(null,i)}})}yn.prototype[dn]||T(yn.prototype,dn,yn.prototype.valueOf),le(yn,"Symbol"),V[fn]=!0,sn("asyncIterator");var Wn=Object.freeze({__proto__:null});sn("hasInstance"),sn("isConcatSpreadable"),sn("iterator"),sn("match"),sn("matchAll"),sn("replace"),sn("search"),sn("species"),sn("split"),sn("toPrimitive"),sn("toStringTag"),sn("unscopables"),le(Math,"Math",!0),le(p.JSON,"JSON",!0),f($e),f(Wn);var Fn=ft.Symbol,Gn=Fn,Vn=function(t,e,n,r){try{return r?e(b(n)[0],n[1]):e(n)}catch(e){var i=t.return;throw void 0!==i&&b(i.call(t)),e}},Un=Mt("iterator"),Bn=Array.prototype,Hn=function(t){return void 0!==t&&(u.Array===t||Bn[Un]===t)},Zn=Mt("iterator"),Xn=!1;try{var qn=0,$n={next:function(){return{done:!!qn++}},return:function(){Xn=!0}};$n[Zn]=function(){return this},Array.from($n,(function(){throw 2}))}catch(t){}var Qn=!function(t,e){if(!e&&!Xn)return!1;var n=!1;try{var r={};r[Zn]=function(){return{next:function(){return{done:n=!0}}}},t(r)}catch(t){}return n}((function(t){Array.from(t)}));yt({target:"Array",stat:!0,forced:Qn},{from:function(t){var e,n,r,i,o,a,s=gt(t),u="function"==typeof this?this:Array,l=arguments.length,h=l>1?arguments[1]:void 0,c=void 0!==h,f=Pe(s),d=0;if(c&&(h=pt(h,l>2?arguments[2]:void 0,2)),null==f||u==Array&&Hn(f))for(n=new u(e=Nt(s.length));e>d;d++)a=c?h(s[d],d):s[d],Ne(n,d,a);else for(o=(i=f.call(s)).next,n=new u;!(r=o.call(i)).done;d++)a=c?Vn(i,h,[r.value,d],!0):r.value,Ne(n,d,a);return n.length=d,n}});var Jn=ft.Array.from,Kn=Jn;yt({target:"Object",stat:!0,forced:!v,sham:!v},{defineProperty:k.f});var tr=c((function(t){var e=ft.Object,n=t.exports=function(t,n,r){return e.defineProperty(t,n,r)};e.defineProperty.sham&&(n.sham=!0)})),er=tr;yt({target:"Object",stat:!0,forced:!v,sham:!v},{defineProperties:Ht});var nr=c((function(t){var e=ft.Object,n=t.exports=function(t,n){return e.defineProperties(t,n)};e.defineProperties.sham&&(n.sham=!0)})),rr=Xt("Reflect","ownKeys")||function(t){var e=Je.f(b(t)),n=rn.f;return n?e.concat(n(t)):e};yt({target:"Object",stat:!0,sham:!v},{getOwnPropertyDescriptors:function(t){for(var e,n,r=s(t),i=it.f,o=rr(r),a={},u=0;o.length>u;)void 0!==(n=i(r,e=o[u++]))&&Ne(a,e,n);return a}});var ir=ft.Object.getOwnPropertyDescriptors,or=it.f,ar=e((function(){or(1)}));yt({target:"Object",stat:!0,forced:!v||ar,sham:!v},{getOwnPropertyDescriptor:function(t,e){return or(s(t),e)}});var sr=c((function(t){var e=ft.Object,n=t.exports=function(t,n){return e.getOwnPropertyDescriptor(t,n)};e.getOwnPropertyDescriptor.sham&&(n.sham=!0)})),ur=ft.Object.getOwnPropertySymbols;yt({target:"Object",stat:!0,sham:!v},{create:te});var lr=ft.Object,hr=function(t,e){return lr.create(t,e)},cr=hr,fr=tr;var dr=function(t,e,n){return e in t?fr(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}):t[e]=n,t},pr=e((function(){Bt(1)}));yt({target:"Object",stat:!0,forced:pr},{keys:function(t){return Bt(gt(t))}});var vr,mr=ft.Object.keys,yr="\t\n\v\f\r                　\u2028\u2029\ufeff",gr="["+yr+"]",_r=RegExp("^"+gr+gr+"*"),wr=RegExp(gr+gr+"*$"),br=function(t){return function(e){var n=String(a(e));return 1&t&&(n=n.replace(_r,"")),2&t&&(n=n.replace(wr,"")),n}},xr={start:br(1),end:br(2),trim:br(3)},Sr=xr.trim;yt({target:"String",proto:!0,forced:(vr="trim",e((function(){return!!yr[vr]()||"​᠎"!="​᠎"[vr]()||yr[vr].name!==vr})))},{trim:function(){return Sr(this)}});var kr=function(t){return ft[t+"Prototype"]},Dr=kr("String").trim,Tr=String.prototype,Or=function(t){var e=t.trim;return"string"==typeof t||t===Tr||t instanceof String&&e===Tr.trim?Dr:e},Mr=function(t,n){var r=[][t];return!!r&&e((function(){r.call(null,n||function(){throw 1},1)}))},Er=Object.defineProperty,Cr={},Ar=function(t){throw t},Pr=function(t,n){if(N(Cr,t))return Cr[t];n||(n={});var r=[][t],i=!!N(n,"ACCESSORS")&&n.ACCESSORS,o=N(n,0)?n[0]:Ar,a=N(n,1)?n[1]:void 0;return Cr[t]=!!r&&!e((function(){if(i&&!v)return!0;var t={length:-1};i?Er(t,1,{enumerable:!0,get:Ar}):t[1]=1,r.call(t,o,a)}))},Lr=hn.forEach,Rr=Mr("forEach"),Yr=Pr("forEach"),Nr=Rr&&Yr?[].forEach:function(t){return Lr(this,t,arguments.length>1?arguments[1]:void 0)};yt({target:"Array",proto:!0,forced:[].forEach!=Nr},{forEach:Nr});var Ir=kr("Array").forEach,jr=Array.prototype,zr={DOMTokenList:!0,NodeList:!0},Wr=function(t){var e=t.forEach;return t===jr||t instanceof Array&&e===jr.forEach||zr.hasOwnProperty(oe(t))?Ir:e},Fr=hn.map,Gr=Be("map"),Vr=Pr("map");yt({target:"Array",proto:!0,forced:!Gr||!Vr},{map:function(t){return Fr(this,t,arguments.length>1?arguments[1]:void 0)}});var Ur=kr("Array").map,Br=Array.prototype,Hr=function(t){var e=t.map;return t===Br||t instanceof Array&&e===Br.map?Ur:e},Zr=xr.trim,Xr=p.parseInt,qr=/^[+-]?0[Xx]/,$r=8!==Xr(yr+"08")||22!==Xr(yr+"0x16")?function(t,e){var n=Zr(String(t));return Xr(n,e>>>0||(qr.test(n)?16:10))}:Xr;yt({global:!0,forced:parseInt!=$r},{parseInt:$r});var Qr=ft.parseInt,Jr=nt.f,Kr=function(t){return function(e){for(var n,r=s(e),i=Bt(r),o=i.length,a=0,u=[];o>a;)n=i[a++],v&&!Jr.call(r,n)||u.push(t?[n,r[n]]:r[n]);return u}},ti={entries:Kr(!0),values:Kr(!1)}.values;yt({target:"Object",stat:!0},{values:function(t){return ti(t)}});var ei=ft.Object.values,ni=hn.filter,ri=Be("filter"),ii=Pr("filter");yt({target:"Array",proto:!0,forced:!ri||!ii},{filter:function(t){return ni(this,t,arguments.length>1?arguments[1]:void 0)}});var oi=kr("Array").filter,ai=Array.prototype,si=function(t){var e=t.filter;return t===ai||t instanceof Array&&e===ai.filter?oi:e},ui=kr("Array").concat,li=Array.prototype,hi=function(t){var e=t.concat;return t===li||t instanceof Array&&e===li.concat?ui:e};yt({target:"Array",stat:!0},{isArray:Ye});var ci=ft.Array.isArray,fi=ci;var di=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r};var pi=function(t){if(fi(t))return di(t)},vi=Jn,mi=Mt("iterator"),yi=function(t){var e=Object(t);return void 0!==e[mi]||"@@iterator"in e||u.hasOwnProperty(oe(e))};sn("asyncDispose"),sn("dispose"),sn("observable"),sn("patternMatch"),sn("replaceAll");var gi=Fn;var _i=function(t){if(void 0!==gi&&yi(Object(t)))return vi(t)},wi=Be("slice"),bi=Pr("slice",{ACCESSORS:!0,0:0,1:2}),xi=Mt("species"),Si=[].slice,ki=Math.max;yt({target:"Array",proto:!0,forced:!wi||!bi},{slice:function(t,e){var n,r,i,o=s(this),a=Nt(o.length),u=zt(t,a),l=zt(void 0===e?a:e,a);if(Ye(o)&&("function"!=typeof(n=o.constructor)||n!==Array&&!Ye(n.prototype)?m(n)&&null===(n=n[xi])&&(n=void 0):n=void 0,n===Array||void 0===n))return Si.call(o,u,l);for(r=new(void 0===n?Array:n)(ki(l-u,0)),i=0;u<l;u++,i++)u in o&&Ne(r,i,o[u]);return r.length=i,r}});var Di=kr("Array").slice,Ti=Array.prototype,Oi=function(t){var e=t.slice;return t===Ti||t instanceof Array&&e===Ti.slice?Di:e},Mi=Oi;var Ei=function(t,e){var n;if(t){if("string"==typeof t)return di(t,e);var r=Mi(n=Object.prototype.toString.call(t)).call(n,8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?vi(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?di(t,e):void 0}};var Ci=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Ai=function(t){return pi(t)||_i(t)||Ei(t)||Ci()},Pi=Oi,Li=e((function(){xt(1)}));yt({target:"Object",stat:!0,forced:Li,sham:!_t},{getPrototypeOf:function(t){return xt(gt(t))}});var Ri=ft.Object.getPrototypeOf,Yi=Ri,Ni=Ft.indexOf,Ii=[].indexOf,ji=!!Ii&&1/[1].indexOf(1,-0)<0,zi=Mr("indexOf"),Wi=Pr("indexOf",{ACCESSORS:!0,1:0});yt({target:"Array",proto:!0,forced:ji||!zi||!Wi},{indexOf:function(t){return ji?Ii.apply(this,arguments)||0:Ni(this,t,arguments.length>1?arguments[1]:void 0)}});var Fi=kr("Array").indexOf,Gi=Array.prototype,Vi=function(t){var e=t.indexOf;return t===Gi||t instanceof Array&&e===Gi.indexOf?Fi:e},Ui=ci,Bi=Object.assign,Hi=Object.defineProperty,Zi=!Bi||e((function(){if(v&&1!==Bi({b:1},Bi(Hi({},"a",{enumerable:!0,get:function(){Hi(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},n=Symbol();return t[n]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=Bi({},t)[n]||"abcdefghijklmnopqrst"!=Bt(Bi({},e)).join("")}))?function(t,e){for(var n=gt(t),r=arguments.length,i=1,a=rn.f,s=nt.f;r>i;)for(var u,l=o(arguments[i++]),h=a?Bt(l).concat(a(l)):Bt(l),c=h.length,f=0;c>f;)u=h[f++],v&&!s.call(l,u)||(n[u]=l[u]);return n}:Bi;yt({target:"Object",stat:!0,forced:Object.assign!==Zi},{assign:Zi});var Xi=ft.Object.assign,qi=on.f("iterator"),$i=qi,Qi=c((function(t){function e(n){return t.exports=e="function"==typeof gi&&"symbol"==typeof $i?function(t){return typeof t}:function(t){return t&&"function"==typeof gi&&t.constructor===gi&&t!==gi.prototype?"symbol":typeof t},e(n)}t.exports=e}));var Ji=function(t){if(fi(t))return t};var Ki=function(t,e){if(void 0!==gi&&yi(Object(t))){var n=[],r=!0,i=!1,o=void 0;try{for(var a,s=Le(t);!(r=(a=s.next()).done)&&(n.push(a.value),!e||n.length!==e);r=!0);}catch(t){i=!0,o=t}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return n}};var to=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var eo=function(t,e){return Ji(t)||Ki(t,e)||Ei(t,e)||to()};yt({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});var no=ft.Date.now;function ro(t){if(void 0===Gn||null==Re(t)){if(Ui(t)||(t=function(t,e){var n;if(!t)return;if("string"==typeof t)return io(t,e);var r=Pi(n=Object.prototype.toString.call(t)).call(n,8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Kn(t);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return io(t,e)}(t))){var e=0,n=function(){};return{s:n,n:function(){return e>=t.length?{done:!0}:{done:!1,value:t[e++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,i,o=!0,a=!1;return{s:function(){r=Le(t)},n:function(){var t=r.next();return o=t.done,t},e:function(t){a=!0,i=t},f:function(){try{o||null==r.return||r.return()}finally{if(a)throw i}}}}function io(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r}function oo(t,e){var n=mr(t);if(ur){var r=ur(t);e&&(r=si(r).call(r,(function(e){return sr(t,e).enumerable}))),n.push.apply(n,r)}return n}function ao(t){for(var e=1;e<arguments.length;e++){var n,r=null!=arguments[e]?arguments[e]:{};if(e%2)Wr(n=oo(Object(r),!0)).call(n,(function(e){dr(t,e,r[e])}));else if(ir)nr(t,ir(r));else{var i;Wr(i=oo(Object(r))).call(i,(function(e){er(t,e,sr(r,e))}))}}return t}
/**
   * vis-util
   * https://github.com/visjs/vis-util
   *
   * utilitie collection for visjs
   *
   * @version 4.0.2
   * @date    2020-05-17T17:33:03.726Z
   *
   * @copyright (c) 2011-2017 Almende B.V, http://almende.com
   * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
   *
   * @license
   * vis.js is dual licensed under both
   *
   *   1. The Apache 2.0 License
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   *   and
   *
   *   2. The MIT License
   *      http://opensource.org/licenses/MIT
   *
   * vis.js may be distributed under either license.
   */function so(t){var e=function(){for(var t=uo(),e=t(" "),n=t(" "),r=t(" "),i=0;i<arguments.length;i++)(e-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(e+=1),(n-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(n+=1),(r-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(r+=1);return[e,n,r]}(t),n=eo(e,3),r=n[0],i=n[1],o=n[2],a=1,s=function(){var t=2091639*r+2.3283064365386963e-10*a;return r=i,i=o,o=t-(a=0|t)};return s.uint32=function(){return 4294967296*s()},s.fract53=function(){return s()+11102230246251565e-32*(2097152*s()|0)},s.algorithm="Alea",s.seed=t,s.version="0.9",s}function uo(){var t=4022871197;return function(e){for(var n=e.toString(),r=0;r<n.length;r++){var i=.02519603282416938*(t+=n.charCodeAt(r));i-=t=i>>>0,t=(i*=t)>>>0,t+=4294967296*(i-=t)}return 2.3283064365386963e-10*(t>>>0)}}var lo=/^\/?Date\((-?\d+)/i,ho=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,co=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,fo=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,po=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function vo(t){return t instanceof Number||"number"==typeof t}function mo(t){return t instanceof String||"string"==typeof t}function yo(t){return"object"===Qi(t)&&null!==t}function go(t,e,n,r){var i=!1;!0===r&&(i=null===e[n]&&void 0!==t[n]),i?delete t[n]:t[n]=e[n]}var _o=Xi;function wo(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Ui(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(n,o))if(n[o]&&n[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?bo(e[o],n[o],!1,r):go(e,n,o,r);else{if(Ui(n[o]))throw new TypeError("Arrays are not supported by deepExtend");go(e,n,o,r)}}return e}function bo(t,e){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===n)if("object"===Qi(e[i])&&null!==e[i]&&Yi(e[i])===Object.prototype)void 0===t[i]?t[i]=bo({},e[i],n):"object"===Qi(t[i])&&null!==t[i]&&Yi(t[i])===Object.prototype?bo(t[i],e[i],n):go(t,e,i,r);else if(Ui(e[i])){var o;t[i]=Pi(o=e[i]).call(o)}else go(t,e,i,r);return t}function xo(t){var e=Qi(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Ui(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function So(t,e){var n;return hi(n=[]).call(n,Ai(t),[e])}function ko(t){return Pi(t).call(t)}var Do=ei;function To(t,e,n,r){var i;t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Vi(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,n,r)):t.attachEvent("on"+e,n)}function Oo(t,e,n,r){var i;t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Vi(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,n,r)):t.detachEvent("on"+e,n)}function Mo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}var Eo={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),mo(t)?t:vo(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function Co(t){var e;switch(t.length){case 3:case 4:return(e=co.exec(t))?{r:Qr(e[1]+e[1],16),g:Qr(e[2]+e[2],16),b:Qr(e[3]+e[3],16)}:null;case 6:case 7:return(e=ho.exec(t))?{r:Qr(e[1],16),g:Qr(e[2],16),b:Qr(e[3],16)}:null;default:return null}}function Ao(t,e,n){var r;return"#"+Pi(r=((1<<24)+(t<<16)+(e<<8)+n).toString(16)).call(r,1)}function Po(t,e,n){t/=255,e/=255,n/=255;var r=Math.min(t,Math.min(e,n)),i=Math.max(t,Math.max(e,n));return r===i?{h:0,s:0,v:r}:{h:60*((t===r?3:n===r?1:5)-(t===r?e-n:n===r?t-e:n-t)/(i-r))/360,s:(i-r)/i,v:i}}var Lo=function(t){var e,n={};return Wr(e=t.split(";")).call(e,(function(t){if(""!=Or(t).call(t)){var e,r,i=t.split(":"),o=Or(e=i[0]).call(e),a=Or(r=i[1]).call(r);n[o]=a}})),n},Ro=function(t){var e;return Hr(e=mr(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")};function Yo(t,e,n){var r,i,o,a=Math.floor(6*t),s=6*t-a,u=n*(1-e),l=n*(1-s*e),h=n*(1-(1-s)*e);switch(a%6){case 0:r=n,i=h,o=u;break;case 1:r=l,i=n,o=u;break;case 2:r=u,i=n,o=h;break;case 3:r=u,i=l,o=n;break;case 4:r=h,i=u,o=n;break;case 5:r=n,i=u,o=l}return{r:Math.floor(255*r),g:Math.floor(255*i),b:Math.floor(255*o)}}function No(t,e,n){var r=Yo(t,e,n);return Ao(r.r,r.g,r.b)}function Io(t){var e=Co(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return Po(e.r,e.g,e.b)}function jo(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function zo(t){return fo.test(t)}function Wo(t){if(null===t||"object"!==Qi(t))return null;if(t instanceof Element)return t;var e=cr(t);for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&"object"==Qi(t[n])&&(e[n]=Wo(t[n]));return e}var Fo=Object.freeze({__proto__:null,Alea:function(){for(var t=arguments.length,e=new Array(t),n=0;n<t;n++)e[n]=arguments[n];return so(e.length?e:[no()])},HSVToHex:No,HSVToRGB:Yo,RGBToHSV:Po,RGBToHex:Ao,addClassName:function(t,e){var n=t.className.split(" "),r=e.split(" ");n=hi(n).call(n,si(r).call(r,(function(t){return Vi(n).call(n,t)<0}))),t.className=n.join(" ")},addCssText:function(t,e){var n=Lo(t.style.cssText),r=Lo(e),i=ao(ao({},n),r);t.style.cssText=Ro(i)},addEventListener:To,binarySearchCustom:function(t,e,n,r){for(var i=0,o=0,a=t.length-1;o<=a&&i<1e4;){var s=Math.floor((o+a)/2),u=t[s],l=e(void 0===r?u[n]:u[n][r]);if(0==l)return s;-1==l?o=s+1:a=s-1,i++}return-1},binarySearchValue:function(t,e,n,r,i){var o,a,s,u,l=0,h=0,c=t.length-1;for(i=null!=i?i:function(t,e){return t==e?0:t<e?-1:1};h<=c&&l<1e4;){if(u=Math.floor(.5*(c+h)),o=t[Math.max(0,u-1)][n],a=t[u][n],s=t[Math.min(t.length-1,u+1)][n],0==i(a,e))return u;if(i(o,e)<0&&i(a,e)>0)return"before"==r?Math.max(0,u-1):u;if(i(a,e)<0&&i(s,e)>0)return"before"==r?u:Math.min(t.length-1,u+1);i(a,e)<0?h=u+1:c=u-1,l++}return-1},bridgeObject:Wo,copyAndExtendArray:So,copyArray:ko,deepExtend:bo,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var n=0,r=t.length;n<r;n++)if(t[n]!=e[n])return!1;return!0},extend:_o,fillIfDefined:function t(e,n){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var i in e)if(void 0!==n[i])if(null===n[i]||"object"!==Qi(n[i]))go(e,n,i,r);else{var o=e[i],a=n[i];yo(o)&&yo(a)&&t(o,a,r)}},forEach:function(t,e){if(Ui(t))for(var n=t.length,r=0;r<n;r++)e(t[r],r,t);else for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&e(t[i],i,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var n=t.offsetWidth;e.style.overflow="scroll";var r=t.offsetWidth;return n==r&&(r=e.clientWidth),document.body.removeChild(e),n-r},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:xo,hasParent:function(t,e){for(var n=t;n;){if(n===e)return!0;if(!n.parentNode)return!1;n=n.parentNode}return!1},hexToHSV:Io,hexToRGB:Co,insertSort:function(t,e){for(var n=0;n<t.length;n++){var r=t[n],i=void 0;for(i=n;i>0&&e(r,t[i-1])<0;i--)t[i]=t[i-1];t[i]=r}return t},isDate:function(t){if(t instanceof Date)return!0;if(mo(t)){if(lo.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:vo,isObject:yo,isString:mo,isValidHex:jo,isValidRGB:zo,isValidRGBA:function(t){return po.test(t)},mergeOptions:function(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},i=function(t){return null!=t},o=function(t){return null!==t&&"object"===Qi(t)},a=function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!i(n))throw new Error("Parameter option must have a value");if(!o(r))throw new Error("Parameter globalOptions must be an object");var s=function(t,e,n){o(t[n])||(t[n]={});var r=e[n],i=t[n];for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(i[a]=r[a])},u=e[n],l=o(r)&&!a(r),h=l?r[n]:void 0,c=h?h.enabled:void 0;if(void 0!==u){if("boolean"==typeof u)return o(t[n])||(t[n]={}),void(t[n].enabled=u);if(null===u&&!o(t[n])){if(!i(h))return;t[n]=cr(h)}if(o(u)){var f=!0;void 0!==u.enabled?f=u.enabled:void 0!==c&&(f=h.enabled),s(t,e,n),t[n].enabled=f}}},option:Eo,overrideOpacity:function(t,e){if(-1!==Vi(t).call(t,"rgba"))return t;if(-1!==Vi(t).call(t,"rgb")){var n=t.substr(Vi(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+n[0]+","+n[1]+","+n[2]+","+e+")"}var r=Co(t);return null==r?t:"rgba("+r.r+","+r.g+","+r.b+","+e+")"},parseColor:function(t,e){if(mo(t)){var n=t;if(zo(n)){var r,i=Hr(r=n.substr(4).substr(0,n.length-5).split(",")).call(r,(function(t){return Qr(t)}));n=Ao(i[0],i[1],i[2])}if(!0===jo(n)){var o=Io(n),a={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},s={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},u=No(s.h,s.s,s.v),l=No(a.h,a.s,a.v);return{background:n,border:u,highlight:{background:l,border:u},hover:{background:l,border:u}}}return{background:n,border:n,highlight:{background:n,border:n},hover:{background:n,border:n}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:mo(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:mo(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:mo(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:mo(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:Mo,recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var n=e.firstChild;n&&(t(n),e.removeChild(n))}},removeClassName:function(t,e){var n=t.className.split(" "),r=e.split(" ");n=si(n).call(n,(function(t){return Vi(r).call(r,t)<0})),t.className=n.join(" ")},removeCssText:function(t,e){var n=Lo(t.style.cssText),r=Lo(e);for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&delete n[i];t.style.cssText=Ro(n)},removeEventListener:Oo,selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Qi(e)){for(var n=cr(e),r=0;r<t.length;r++)Object.prototype.hasOwnProperty.call(e,t[r])&&"object"==Qi(e[t[r]])&&(n[t[r]]=Wo(e[t[r]]));return n}return null},selectiveDeepExtend:wo,selectiveExtend:function(t,e){if(!Ui(t))throw new Error("Array with property names expected as first argument");for(var n=arguments.length,r=new Array(n>2?n-2:0),i=2;i<n;i++)r[i-2]=arguments[i];for(var o=0,a=r;o<a.length;o++)for(var s=a[o],u=0;u<t.length;u++){var l=t[u];s&&Object.prototype.hasOwnProperty.call(s,l)&&(e[l]=s[l])}return e},selectiveNotDeepExtend:function(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Ui(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i in n)if(Object.prototype.hasOwnProperty.call(n,i)&&-1===Vi(t).call(t,i))if(n[i]&&n[i].constructor===Object)void 0===e[i]&&(e[i]={}),e[i].constructor===Object?bo(e[i],n[i]):go(e,n,i,r);else if(Ui(n[i])){e[i]=[];for(var o=0;o<n[i].length;o++)e[i].push(n[i][o])}else go(e,n,i,r);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Do,topMost:function(t,e){var n;Ui(e)||(e=[e]);var r,i=ro(t);try{for(i.s();!(r=i.n()).done;){var o=r.value;if(o){n=o[e[0]];for(var a=1;a<e.length;a++)n&&(n=n[e[a]]);if(void 0!==n)break}}}catch(t){i.e(t)}finally{i.f()}return n},updateProperty:function(t,e,n){return t[e]!==n&&(t[e]=n,!0)}}),Go=c((function(t,e){e.prepareElements=function(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])},e.cleanupElements=function(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var n=0;n<t[e].redundant.length;n++)t[e].redundant[n].parentNode.removeChild(t[e].redundant[n]);t[e].redundant=[]}},e.resetElements=function(t){e.prepareElements(t),e.cleanupElements(t),e.prepareElements(t)},e.getSVGElement=function(t,e,n){var r;return e.hasOwnProperty(t)?e[t].redundant.length>0?(r=e[t].redundant[0],e[t].redundant.shift()):(r=document.createElementNS("http://www.w3.org/2000/svg",t),n.appendChild(r)):(r=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},n.appendChild(r)),e[t].used.push(r),r},e.getDOMElement=function(t,e,n,r){var i;return e.hasOwnProperty(t)?e[t].redundant.length>0?(i=e[t].redundant[0],e[t].redundant.shift()):(i=document.createElement(t),void 0!==r?n.insertBefore(i,r):n.appendChild(i)):(i=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==r?n.insertBefore(i,r):n.appendChild(i)),e[t].used.push(i),i},e.drawPoint=function(t,n,r,i,o,a){var s;if("circle"==r.style?((s=e.getSVGElement("circle",i,o)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",n),s.setAttributeNS(null,"r",.5*r.size)):((s=e.getSVGElement("rect",i,o)).setAttributeNS(null,"x",t-.5*r.size),s.setAttributeNS(null,"y",n-.5*r.size),s.setAttributeNS(null,"width",r.size),s.setAttributeNS(null,"height",r.size)),void 0!==r.styles&&s.setAttributeNS(null,"style",r.styles),s.setAttributeNS(null,"class",r.className+" vis-point"),a){var u=e.getSVGElement("text",i,o);a.xOffset&&(t+=a.xOffset),a.yOffset&&(n+=a.yOffset),a.content&&(u.textContent=a.content),a.className&&u.setAttributeNS(null,"class",a.className+" vis-label"),u.setAttributeNS(null,"x",t),u.setAttributeNS(null,"y",n)}return s},e.drawBar=function(t,n,r,i,o,a,s,u){if(0!=i){i<0&&(n-=i*=-1);var l=e.getSVGElement("rect",a,s);l.setAttributeNS(null,"x",t-.5*r),l.setAttributeNS(null,"y",n),l.setAttributeNS(null,"width",r),l.setAttributeNS(null,"height",i),l.setAttributeNS(null,"class",o),u&&l.setAttributeNS(null,"style",u)}}}));Go.prepareElements,Go.cleanupElements,Go.resetElements,Go.getSVGElement,Go.getDOMElement,Go.drawPoint,Go.drawBar;var Vo=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t},Uo=[].slice,Bo={},Ho=function(t,e,n){if(!(e in Bo)){for(var r=[],i=0;i<e;i++)r[i]="a["+i+"]";Bo[e]=Function("C,a","return new C("+r.join(",")+")")}return Bo[e](t,n)},Zo=Function.bind||function(t){var e=dt(this),n=Uo.call(arguments,1),r=function(){var i=n.concat(Uo.call(arguments));return this instanceof r?Ho(e,i.length,i):e.apply(t,i)};return m(e.prototype)&&(r.prototype=e.prototype),r},Xo=Xt("Reflect","construct"),qo=e((function(){function t(){}return!(Xo((function(){}),[],t)instanceof t)})),$o=!e((function(){Xo((function(){}))})),Qo=qo||$o;yt({target:"Reflect",stat:!0,forced:Qo,sham:Qo},{construct:function(t,e){dt(t),b(e);var n=arguments.length<3?t:dt(arguments[2]);if($o&&!qo)return Xo(t,e,n);if(t==n){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var r=[null];return r.push.apply(r,e),new(Zo.apply(t,r))}var i=n.prototype,o=te(m(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return m(a)?a:o}});var Jo=ft.Reflect.construct,Ko=kr("Array").entries,ta=Array.prototype,ea={DOMTokenList:!0,NodeList:!0},na=function(t){var e=t.entries;return t===ta||t instanceof Array&&e===ta.entries||ea.hasOwnProperty(oe(t))?Ko:e},ra=Xt("JSON","stringify"),ia=/[\uD800-\uDFFF]/g,oa=/^[\uD800-\uDBFF]$/,aa=/^[\uDC00-\uDFFF]$/,sa=function(t,e,n){var r=n.charAt(e-1),i=n.charAt(e+1);return oa.test(t)&&!aa.test(i)||aa.test(t)&&!oa.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},ua=e((function(){return'"\\udf06\\ud834"'!==ra("\udf06\ud834")||'"\\udead"'!==ra("\udead")}));ra&&yt({target:"JSON",stat:!0,forced:ua},{stringify:function(t,e,n){var r=ra.apply(null,arguments);return"string"==typeof r?r.replace(ia,sa):r}}),ft.JSON||(ft.JSON={stringify:JSON.stringify});var la=function(t,e,n){return ft.JSON.stringify.apply(null,arguments)},ha=kr("Array").values,ca=Array.prototype,fa={DOMTokenList:!0,NodeList:!0},da=function(t){var e=t.values;return t===ca||t instanceof Array&&e===ca.values||fa.hasOwnProperty(oe(t))?ha:e},pa=kr("Array").keys,va=Array.prototype,ma={DOMTokenList:!0,NodeList:!0},ya=function(t){var e=t.keys;return t===va||t instanceof Array&&e===va.keys||ma.hasOwnProperty(oe(t))?pa:e},ga=hn.some,_a=Mr("some"),wa=Pr("some");yt({target:"Array",proto:!0,forced:!_a||!wa},{some:function(t){return ga(this,t,arguments.length>1?arguments[1]:void 0)}});var ba=kr("Array").some,xa=Array.prototype,Sa=function(t){var e=t.some;return t===xa||t instanceof Array&&e===xa.some?ba:e},ka=hr;yt({target:"Object",stat:!0},{setPrototypeOf:fe});var Da=ft.Object.setPrototypeOf,Ta=c((function(t){function e(n,r){return t.exports=e=Da||function(t,e){return t.__proto__=e,t},e(n,r)}t.exports=e}));var Oa=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=ka(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Ta(t,e)};var Ma=function(t,e){return!e||"object"!==Qi(e)&&"function"!=typeof e?Vo(t):e},Ea=Ri,Ca=c((function(t){function e(n){return t.exports=e=Da?Ea:function(t){return t.__proto__||Ea(t)},e(n)}t.exports=e})),Aa=[],Pa=Aa.sort,La=e((function(){Aa.sort(void 0)})),Ra=e((function(){Aa.sort(null)})),Ya=Mr("sort");yt({target:"Array",proto:!0,forced:La||!Ra||!Ya},{sort:function(t){return void 0===t?Pa.call(gt(this)):Pa.call(gt(this),dt(t))}});var Na=kr("Array").sort,Ia=Array.prototype,ja=function(t){var e=t.sort;return t===Ia||t instanceof Array&&e===Ia.sort?Na:e},za=!e((function(){return Object.isExtensible(Object.preventExtensions({}))})),Wa=c((function(t){var e=k.f,n=W("meta"),r=0,i=Object.isExtensible||function(){return!0},o=function(t){e(t,n,{value:{objectID:"O"+ ++r,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!m(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!N(t,n)){if(!i(t))return"F";if(!e)return"E";o(t)}return t[n].objectID},getWeakData:function(t,e){if(!N(t,n)){if(!i(t))return!0;if(!e)return!1;o(t)}return t[n].weakData},onFreeze:function(t){return za&&a.REQUIRED&&i(t)&&!N(t,n)&&o(t),t}};V[n]=!0})),Fa=(Wa.REQUIRED,Wa.fastKey,Wa.getWeakData,Wa.onFreeze,c((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,n,r,i,o){var a,s,u,l,h,c,f,d=pt(n,r,i?2:1);if(o)a=t;else{if("function"!=typeof(s=Pe(t)))throw TypeError("Target is not iterable");if(Hn(s)){for(u=0,l=Nt(t.length);l>u;u++)if((h=i?d(b(f=t[u])[0],f[1]):d(t[u]))&&h instanceof e)return h;return new e(!1)}a=s.call(t)}for(c=a.next;!(f=c.call(a)).done;)if("object"==typeof(h=Vn(a,d,f.value,i))&&h&&h instanceof e)return h;return new e(!1)}).stop=function(t){return new e(!0,t)}}))),Ga=function(t,e,n){if(!(t instanceof e))throw TypeError("Incorrect "+(n?n+" ":"")+"invocation");return t},Va=k.f,Ua=hn.forEach,Ba=K.set,Ha=K.getterFor,Za=function(t,n,r){var i,o=-1!==t.indexOf("Map"),a=-1!==t.indexOf("Weak"),s=o?"set":"add",u=p[t],l=u&&u.prototype,h={};if(v&&"function"==typeof u&&(a||l.forEach&&!e((function(){(new u).entries().next()})))){i=n((function(e,n){Ba(Ga(e,i,t),{type:t,collection:new u}),null!=n&&Fa(n,e[s],e,o)}));var c=Ha(t);Ua(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in l)||a&&"clear"==t||T(i.prototype,t,(function(n,r){var i=c(this).collection;if(!e&&a&&!m(n))return"get"==t&&void 0;var o=i[t](0===n?0:n,r);return e?this:o}))})),a||Va(i.prototype,"size",{configurable:!0,get:function(){return c(this).collection.size}})}else i=r.getConstructor(n,t,o,s),Wa.REQUIRED=!0;return le(i,t,!1,!0),h[t]=i,yt({global:!0,forced:!0},h),a||r.setStrong(i,t,o),i},Xa=function(t,e,n){for(var r in e)n&&n.unsafe&&t[r]?t[r]=e[r]:de(t,r,e[r],n);return t},qa=Mt("species"),$a=k.f,Qa=Wa.fastKey,Ja=K.set,Ka=K.getterFor,ts={getConstructor:function(t,e,n,r){var i=t((function(t,o){Ga(t,i,e),Ja(t,{type:e,index:te(null),first:void 0,last:void 0,size:0}),v||(t.size=0),null!=o&&Fa(o,t[r],t,n)})),o=Ka(e),a=function(t,e,n){var r,i,a=o(t),u=s(t,e);return u?u.value=n:(a.last=u={index:i=Qa(e,!0),key:e,value:n,previous:r=a.last,next:void 0,removed:!1},a.first||(a.first=u),r&&(r.next=u),v?a.size++:t.size++,"F"!==i&&(a.index[i]=u)),t},s=function(t,e){var n,r=o(t),i=Qa(e);if("F"!==i)return r.index[i];for(n=r.first;n;n=n.next)if(n.key==e)return n};return Xa(i.prototype,{clear:function(){for(var t=o(this),e=t.index,n=t.first;n;)n.removed=!0,n.previous&&(n.previous=n.previous.next=void 0),delete e[n.index],n=n.next;t.first=t.last=void 0,v?t.size=0:this.size=0},delete:function(t){var e=o(this),n=s(this,t);if(n){var r=n.next,i=n.previous;delete e.index[n.index],n.removed=!0,i&&(i.next=r),r&&(r.previous=i),e.first==n&&(e.first=r),e.last==n&&(e.last=i),v?e.size--:this.size--}return!!n},forEach:function(t){for(var e,n=o(this),r=pt(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:n.first;)for(r(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),Xa(i.prototype,n?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),v&&$a(i.prototype,"size",{get:function(){return o(this).size}}),i},setStrong:function(t,e,n){var r=e+" Iterator",i=Ka(e),o=Ka(r);ge(t,e,(function(t,e){Ja(this,{type:r,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,n=t.last;n&&n.removed;)n=n.previous;return t.target&&(t.last=n=n?n.next:t.state.first)?"keys"==e?{value:n.key,done:!1}:"values"==e?{value:n.value,done:!1}:{value:[n.key,n.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),n?"entries":"values",!n,!0),function(t){var e=Xt(t),n=k.f;v&&e&&!e[qa]&&n(e,qa,{configurable:!0,get:function(){return this}})}(e)}},es=(Za("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ts),ft.Set),ns=(Za("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ts),ft.Map),rs=c((function(t){var e=function(t){var e=Object.prototype,n=e.hasOwnProperty,r="function"==typeof Symbol?Symbol:{},i=r.iterator||"@@iterator",o=r.asyncIterator||"@@asyncIterator",a=r.toStringTag||"@@toStringTag";function s(t,e,n,r){var i=e&&e.prototype instanceof h?e:h,o=Object.create(i.prototype),a=new x(r||[]);return o._invoke=function(t,e,n){var r="suspendedStart";return function(i,o){if("executing"===r)throw new Error("Generator is already running");if("completed"===r){if("throw"===i)throw o;return k()}for(n.method=i,n.arg=o;;){var a=n.delegate;if(a){var s=_(a,n);if(s){if(s===l)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if("suspendedStart"===r)throw r="completed",n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r="executing";var h=u(t,e,n);if("normal"===h.type){if(r=n.done?"completed":"suspendedYield",h.arg===l)continue;return{value:h.arg,done:n.done}}"throw"===h.type&&(r="completed",n.method="throw",n.arg=h.arg)}}}(t,n,a),o}function u(t,e,n){try{return{type:"normal",arg:t.call(e,n)}}catch(t){return{type:"throw",arg:t}}}t.wrap=s;var l={};function h(){}function c(){}function f(){}var d={};d[i]=function(){return this};var p=Object.getPrototypeOf,v=p&&p(p(S([])));v&&v!==e&&n.call(v,i)&&(d=v);var m=f.prototype=h.prototype=Object.create(d);function y(t){["next","throw","return"].forEach((function(e){t[e]=function(t){return this._invoke(e,t)}}))}function g(t,e){var r;this._invoke=function(i,o){function a(){return new e((function(r,a){!function r(i,o,a,s){var l=u(t[i],t,o);if("throw"!==l.type){var h=l.arg,c=h.value;return c&&"object"==typeof c&&n.call(c,"__await")?e.resolve(c.__await).then((function(t){r("next",t,a,s)}),(function(t){r("throw",t,a,s)})):e.resolve(c).then((function(t){h.value=t,a(h)}),(function(t){return r("throw",t,a,s)}))}s(l.arg)}(i,o,r,a)}))}return r=r?r.then(a,a):a()}}function _(t,e){var n=t.iterator[e.method];if(void 0===n){if(e.delegate=null,"throw"===e.method){if(t.iterator.return&&(e.method="return",e.arg=void 0,_(t,e),"throw"===e.method))return l;e.method="throw",e.arg=new TypeError("The iterator does not provide a 'throw' method")}return l}var r=u(n,t.iterator,e.arg);if("throw"===r.type)return e.method="throw",e.arg=r.arg,e.delegate=null,l;var i=r.arg;return i?i.done?(e[t.resultName]=i.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,l):i:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,l)}function w(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function b(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function x(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(w,this),this.reset(!0)}function S(t){if(t){var e=t[i];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,o=function e(){for(;++r<t.length;)if(n.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return o.next=o}}return{next:k}}function k(){return{value:void 0,done:!0}}return c.prototype=m.constructor=f,f.constructor=c,f[a]=c.displayName="GeneratorFunction",t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===c||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,f):(t.__proto__=f,a in t||(t[a]="GeneratorFunction")),t.prototype=Object.create(m),t},t.awrap=function(t){return{__await:t}},y(g.prototype),g.prototype[o]=function(){return this},t.AsyncIterator=g,t.async=function(e,n,r,i,o){void 0===o&&(o=Promise);var a=new g(s(e,n,r,i),o);return t.isGeneratorFunction(n)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},y(m),m[a]="Generator",m[i]=function(){return this},m.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var n in t)e.push(n);return e.reverse(),function n(){for(;e.length;){var r=e.pop();if(r in t)return n.value=r,n.done=!1,n}return n.done=!0,n}},t.values=S,x.prototype={constructor:x,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,this.tryEntries.forEach(b),!t)for(var e in this)"t"===e.charAt(0)&&n.call(this,e)&&!isNaN(+e.slice(1))&&(this[e]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(n,r){return a.type="throw",a.arg=t,e.next=n,r&&(e.method="next",e.arg=void 0),!!r}for(var i=this.tryEntries.length-1;i>=0;--i){var o=this.tryEntries[i],a=o.completion;if("root"===o.tryLoc)return r("end");if(o.tryLoc<=this.prev){var s=n.call(o,"catchLoc"),u=n.call(o,"finallyLoc");if(s&&u){if(this.prev<o.catchLoc)return r(o.catchLoc,!0);if(this.prev<o.finallyLoc)return r(o.finallyLoc)}else if(s){if(this.prev<o.catchLoc)return r(o.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return r(o.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,l):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),l},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.finallyLoc===t)return this.complete(n.completion,n.afterLoc),b(n),l}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.tryLoc===t){var r=n.completion;if("throw"===r.type){var i=r.arg;b(n)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,n){return this.delegate={iterator:S(t),resultName:e,nextLoc:n},"next"===this.method&&(this.arg=void 0),l}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),is=qi,os=Be("splice"),as=Pr("splice",{ACCESSORS:!0,0:0,1:2}),ss=Math.max,us=Math.min;yt({target:"Array",proto:!0,forced:!os||!as},{splice:function(t,e){var n,r,i,o,a,s,u=gt(this),l=Nt(u.length),h=zt(t,l),c=arguments.length;if(0===c?n=r=0:1===c?(n=0,r=l-h):(n=c-2,r=us(ss(Rt(e),0),l-h)),l+n-r>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(i=je(u,r),o=0;o<r;o++)(a=h+o)in u&&Ne(i,o,u[a]);if(i.length=r,n<r){for(o=h;o<l-r;o++)s=o+n,(a=o+r)in u?u[s]=u[a]:delete u[s];for(o=l;o>l-r+n;o--)delete u[o-1]}else if(n>r)for(o=l-r;o>h;o--)s=o+n-1,(a=o+r-1)in u?u[s]=u[a]:delete u[s];for(o=0;o<n;o++)u[o+h]=arguments[o+2];return u.length=l-r+n,i}});var ls=kr("Array").splice,hs=Array.prototype,cs=function(t){var e=t.splice;return t===hs||t instanceof Array&&e===hs.splice?ls:e},fs=[].slice,ds=/MSIE .\./.test(ze),ps=function(t){return function(e,n){var r=arguments.length>2,i=r?fs.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,n)}};yt({global:!0,bind:!0,forced:ds},{setTimeout:ps(p.setTimeout),setInterval:ps(p.setInterval)});var vs=ft.setTimeout,ms=function(t,e,n,r,i,o,a,s){for(var u,l=i,h=0,c=!!a&&pt(a,s,3);h<r;){if(h in n){if(u=c?c(n[h],h,e):n[h],o>0&&Ye(u))l=ms(t,e,u,Nt(u.length),l,o-1)-1;else{if(l>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[l]=u}l++}h++}return l},ys=ms;yt({target:"Array",proto:!0},{flatMap:function(t){var e,n=gt(this),r=Nt(n.length);return dt(t),(e=je(n,0)).length=ys(e,n,n,r,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var gs=kr("Array").flatMap,_s=Array.prototype,ws=function(t){var e=t.flatMap;return t===_s||t instanceof Array&&e===_s.flatMap?gs:e},bs=function(t){return function(e,n,r,i){dt(n);var a=gt(e),s=o(a),u=Nt(a.length),l=t?u-1:0,h=t?-1:1;if(r<2)for(;;){if(l in s){i=s[l],l+=h;break}if(l+=h,t?l<0:u<=l)throw TypeError("Reduce of empty array with no initial value")}for(;t?l>=0:u>l;l+=h)l in s&&(i=n(i,s[l],l,a));return i}},xs={left:bs(!1),right:bs(!0)}.left,Ss=Mr("reduce"),ks=Pr("reduce",{1:0});yt({target:"Array",proto:!0,forced:!Ss||!ks},{reduce:function(t){return xs(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Ds=kr("Array").reduce,Ts=Array.prototype,Os=function(t){var e=t.reduce;return t===Ts||t instanceof Array&&e===Ts.reduce?Ds:e};yt({target:"Function",proto:!0},{bind:Zo});var Ms=kr("Function").bind,Es=Function.prototype,Cs=function(t){var e=t.bind;return t===Es||t instanceof Function&&e===Es.bind?Ms:e};var As=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Ps(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),fr(t,r.key,r)}}var Ls=function(t,e,n){return e&&Ps(t.prototype,e),n&&Ps(t,n),t},Rs="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),Ys=new Uint8Array(16);function Ns(){if(!Rs)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Rs(Ys)}for(var Is=[],js=0;js<256;++js)Is.push((js+256).toString(16).substr(1));function zs(t,e,n){"string"==typeof t&&(e="binary"===t?new Uint8Array(16):null,t=null);var r=(t=t||{}).random||(t.rng||Ns)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,e){for(var i=n||0,o=0;o<16;++o)e[i+o]=r[o];return e}return function(t,e){var n=e||0,r=Is;return(r[t[n+0]]+r[t[n+1]]+r[t[n+2]]+r[t[n+3]]+"-"+r[t[n+4]]+r[t[n+5]]+"-"+r[t[n+6]]+r[t[n+7]]+"-"+r[t[n+8]]+r[t[n+9]]+"-"+r[t[n+10]]+r[t[n+11]]+r[t[n+12]]+r[t[n+13]]+r[t[n+14]]+r[t[n+15]]).toLowerCase()}(r)}var Ws=c((function(t,e){t.exports=function(){var e,n;function r(){return e.apply(null,arguments)}function i(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function o(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function a(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function s(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(a(t,e))return!1;return!0}function u(t){return void 0===t}function l(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function c(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function f(t,e){var n,r=[];for(n=0;n<t.length;++n)r.push(e(t[n],n));return r}function d(t,e){for(var n in e)a(e,n)&&(t[n]=e[n]);return a(e,"toString")&&(t.toString=e.toString),a(e,"valueOf")&&(t.valueOf=e.valueOf),t}function p(t,e,n,r){return De(t,e,n,r,!0).utc()}function v(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function m(t){if(null==t._isValid){var e=v(t),r=n.call(e.parsedDateParts,(function(t){return null!=t})),i=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidEra&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&r);if(t._strict&&(i=i&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return i;t._isValid=i}return t._isValid}function y(t){var e=p(NaN);return null!=t?d(v(e),t):v(e).userInvalidated=!0,e}n=Array.prototype.some?Array.prototype.some:function(t){var e,n=Object(this),r=n.length>>>0;for(e=0;e<r;e++)if(e in n&&t.call(this,n[e],e,n))return!0;return!1};var g=r.momentProperties=[],_=!1;function w(t,e){var n,r,i;if(u(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),u(e._i)||(t._i=e._i),u(e._f)||(t._f=e._f),u(e._l)||(t._l=e._l),u(e._strict)||(t._strict=e._strict),u(e._tzm)||(t._tzm=e._tzm),u(e._isUTC)||(t._isUTC=e._isUTC),u(e._offset)||(t._offset=e._offset),u(e._pf)||(t._pf=v(e)),u(e._locale)||(t._locale=e._locale),g.length>0)for(n=0;n<g.length;n++)u(i=e[r=g[n]])||(t[r]=i);return t}function b(t){w(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===_&&(_=!0,r.updateOffset(this),_=!1)}function x(t){return t instanceof b||null!=t&&null!=t._isAMomentObject}function S(t){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function k(t,e){var n=!0;return d((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,t),n){var i,o,s,u=[];for(o=0;o<arguments.length;o++){if(i="","object"==typeof arguments[o]){for(s in i+="\n["+o+"] ",arguments[0])a(arguments[0],s)&&(i+=s+": "+arguments[0][s]+", ");i=i.slice(0,-2)}else i=arguments[o];u.push(i)}S(t+"\nArguments: "+Array.prototype.slice.call(u).join("")+"\n"+(new Error).stack),n=!1}return e.apply(this,arguments)}),e)}var D,T={};function O(t,e){null!=r.deprecationHandler&&r.deprecationHandler(t,e),T[t]||(S(e),T[t]=!0)}function M(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function E(t,e){var n,r=d({},t);for(n in e)a(e,n)&&(o(t[n])&&o(e[n])?(r[n]={},d(r[n],t[n]),d(r[n],e[n])):null!=e[n]?r[n]=e[n]:delete r[n]);for(n in t)a(t,n)&&!a(e,n)&&o(t[n])&&(r[n]=d({},r[n]));return r}function C(t){null!=t&&this.set(t)}function A(t,e,n){var r=""+Math.abs(t),i=e-r.length;return(t>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,i)).toString().substr(1)+r}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,D=Object.keys?Object.keys:function(t){var e,n=[];for(e in t)a(t,e)&&n.push(e);return n};var P=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,L=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,R={},Y={};function N(t,e,n,r){var i=r;"string"==typeof r&&(i=function(){return this[r]()}),t&&(Y[t]=i),e&&(Y[e[0]]=function(){return A(i.apply(this,arguments),e[1],e[2])}),n&&(Y[n]=function(){return this.localeData().ordinal(i.apply(this,arguments),t)})}function I(t,e){return t.isValid()?(e=j(e,t.localeData()),R[e]=R[e]||function(t){var e,n,r,i=t.match(P);for(e=0,n=i.length;e<n;e++)Y[i[e]]?i[e]=Y[i[e]]:i[e]=(r=i[e]).match(/\[[\s\S]/)?r.replace(/^\[|\]$/g,""):r.replace(/\\/g,"");return function(e){var r,o="";for(r=0;r<n;r++)o+=M(i[r])?i[r].call(e,t):i[r];return o}}(e),R[e](t)):t.localeData().invalidDate()}function j(t,e){var n=5;function r(t){return e.longDateFormat(t)||t}for(L.lastIndex=0;n>=0&&L.test(t);)t=t.replace(L,r),L.lastIndex=0,n-=1;return t}var z={};function W(t,e){var n=t.toLowerCase();z[n]=z[n+"s"]=z[e]=t}function F(t){return"string"==typeof t?z[t]||z[t.toLowerCase()]:void 0}function G(t){var e,n,r={};for(n in t)a(t,n)&&(e=F(n))&&(r[e]=t[n]);return r}var V={};function U(t,e){V[t]=e}function B(t){return t%4==0&&t%100!=0||t%400==0}function H(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function Z(t){var e=+t,n=0;return 0!==e&&isFinite(e)&&(n=H(e)),n}function X(t,e){return function(n){return null!=n?($(this,t,n),r.updateOffset(this,e),this):q(this,t)}}function q(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function $(t,e,n){t.isValid()&&!isNaN(n)&&("FullYear"===e&&B(t.year())&&1===t.month()&&29===t.date()?(n=Z(n),t._d["set"+(t._isUTC?"UTC":"")+e](n,t.month(),xt(n,t.month()))):t._d["set"+(t._isUTC?"UTC":"")+e](n))}var Q,J=/\d/,K=/\d\d/,tt=/\d{3}/,et=/\d{4}/,nt=/[+-]?\d{6}/,rt=/\d\d?/,it=/\d\d\d\d?/,ot=/\d\d\d\d\d\d?/,at=/\d{1,3}/,st=/\d{1,4}/,ut=/[+-]?\d{1,6}/,lt=/\d+/,ht=/[+-]?\d+/,ct=/Z|[+-]\d\d:?\d\d/gi,ft=/Z|[+-]\d\d(?::?\d\d)?/gi,dt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function pt(t,e,n){Q[t]=M(e)?e:function(t,r){return t&&n?n:e}}function vt(t,e){return a(Q,t)?Q[t](e._strict,e._locale):new RegExp(mt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,n,r,i){return e||n||r||i}))))}function mt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}Q={};var yt,gt={};function _t(t,e){var n,r=e;for("string"==typeof t&&(t=[t]),l(e)&&(r=function(t,n){n[e]=Z(t)}),n=0;n<t.length;n++)gt[t[n]]=r}function wt(t,e){_t(t,(function(t,n,r,i){r._w=r._w||{},e(t,r._w,r,i)}))}function bt(t,e,n){null!=e&&a(gt,t)&&gt[t](e,n._a,n,t)}function xt(t,e){if(isNaN(t)||isNaN(e))return NaN;var n,r=(e%(n=12)+n)%n;return t+=(e-r)/12,1===r?B(t)?29:28:31-r%7%2}yt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},N("M",["MM",2],"Mo",(function(){return this.month()+1})),N("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),N("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),W("month","M"),U("month",8),pt("M",rt),pt("MM",rt,K),pt("MMM",(function(t,e){return e.monthsShortRegex(t)})),pt("MMMM",(function(t,e){return e.monthsRegex(t)})),_t(["M","MM"],(function(t,e){e[1]=Z(t)-1})),_t(["MMM","MMMM"],(function(t,e,n,r){var i=n._locale.monthsParse(t,r,n._strict);null!=i?e[1]=i:v(n).invalidMonth=t}));var St="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),kt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),Dt=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Tt=dt,Ot=dt;function Mt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],r=0;r<12;++r)o=p([2e3,r]),this._shortMonthsParse[r]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[r]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===e?-1!==(i=yt.call(this._shortMonthsParse,a))?i:null:-1!==(i=yt.call(this._longMonthsParse,a))?i:null:"MMM"===e?-1!==(i=yt.call(this._shortMonthsParse,a))||-1!==(i=yt.call(this._longMonthsParse,a))?i:null:-1!==(i=yt.call(this._longMonthsParse,a))||-1!==(i=yt.call(this._shortMonthsParse,a))?i:null}function Et(t,e){var n;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=Z(e);else if(!l(e=t.localeData().monthsParse(e)))return t;return n=Math.min(t.date(),xt(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,n),t}function Ct(t){return null!=t?(Et(this,t),r.updateOffset(this,!0),this):q(this,"Month")}function At(){function t(t,e){return e.length-t.length}var e,n,r=[],i=[],o=[];for(e=0;e<12;e++)n=p([2e3,e]),r.push(this.monthsShort(n,"")),i.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(r.sort(t),i.sort(t),o.sort(t),e=0;e<12;e++)r[e]=mt(r[e]),i[e]=mt(i[e]);for(e=0;e<24;e++)o[e]=mt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+i.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+r.join("|")+")","i")}function Pt(t){return B(t)?366:365}N("Y",0,0,(function(){var t=this.year();return t<=9999?A(t,4):"+"+t})),N(0,["YY",2],0,(function(){return this.year()%100})),N(0,["YYYY",4],0,"year"),N(0,["YYYYY",5],0,"year"),N(0,["YYYYYY",6,!0],0,"year"),W("year","y"),U("year",1),pt("Y",ht),pt("YY",rt,K),pt("YYYY",st,et),pt("YYYYY",ut,nt),pt("YYYYYY",ut,nt),_t(["YYYYY","YYYYYY"],0),_t("YYYY",(function(t,e){e[0]=2===t.length?r.parseTwoDigitYear(t):Z(t)})),_t("YY",(function(t,e){e[0]=r.parseTwoDigitYear(t)})),_t("Y",(function(t,e){e[0]=parseInt(t,10)})),r.parseTwoDigitYear=function(t){return Z(t)+(Z(t)>68?1900:2e3)};var Lt=X("FullYear",!0);function Rt(t,e,n,r,i,o,a){var s;return t<100&&t>=0?(s=new Date(t+400,e,n,r,i,o,a),isFinite(s.getFullYear())&&s.setFullYear(t)):s=new Date(t,e,n,r,i,o,a),s}function Yt(t){var e,n;return t<100&&t>=0?((n=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,n)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function Nt(t,e,n){var r=7+e-n;return-(7+Yt(t,0,r).getUTCDay()-e)%7+r-1}function It(t,e,n,r,i){var o,a,s=1+7*(e-1)+(7+n-r)%7+Nt(t,r,i);return s<=0?a=Pt(o=t-1)+s:s>Pt(t)?(o=t+1,a=s-Pt(t)):(o=t,a=s),{year:o,dayOfYear:a}}function jt(t,e,n){var r,i,o=Nt(t.year(),e,n),a=Math.floor((t.dayOfYear()-o-1)/7)+1;return a<1?r=a+zt(i=t.year()-1,e,n):a>zt(t.year(),e,n)?(r=a-zt(t.year(),e,n),i=t.year()+1):(i=t.year(),r=a),{week:r,year:i}}function zt(t,e,n){var r=Nt(t,e,n),i=Nt(t+1,e,n);return(Pt(t)-r+i)/7}function Wt(t,e){return t.slice(e,7).concat(t.slice(0,e))}N("w",["ww",2],"wo","week"),N("W",["WW",2],"Wo","isoWeek"),W("week","w"),W("isoWeek","W"),U("week",5),U("isoWeek",5),pt("w",rt),pt("ww",rt,K),pt("W",rt),pt("WW",rt,K),wt(["w","ww","W","WW"],(function(t,e,n,r){e[r.substr(0,1)]=Z(t)})),N("d",0,"do","day"),N("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),N("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),N("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),N("e",0,0,"weekday"),N("E",0,0,"isoWeekday"),W("day","d"),W("weekday","e"),W("isoWeekday","E"),U("day",11),U("weekday",11),U("isoWeekday",11),pt("d",rt),pt("e",rt),pt("E",rt),pt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),pt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),pt("dddd",(function(t,e){return e.weekdaysRegex(t)})),wt(["dd","ddd","dddd"],(function(t,e,n,r){var i=n._locale.weekdaysParse(t,r,n._strict);null!=i?e.d=i:v(n).invalidWeekday=t})),wt(["d","e","E"],(function(t,e,n,r){e[r]=Z(t)}));var Ft="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Gt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Vt="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Ut=dt,Bt=dt,Ht=dt;function Zt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],r=0;r<7;++r)o=p([2e3,1]).day(r),this._minWeekdaysParse[r]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[r]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[r]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===e?-1!==(i=yt.call(this._weekdaysParse,a))?i:null:"ddd"===e?-1!==(i=yt.call(this._shortWeekdaysParse,a))?i:null:-1!==(i=yt.call(this._minWeekdaysParse,a))?i:null:"dddd"===e?-1!==(i=yt.call(this._weekdaysParse,a))||-1!==(i=yt.call(this._shortWeekdaysParse,a))||-1!==(i=yt.call(this._minWeekdaysParse,a))?i:null:"ddd"===e?-1!==(i=yt.call(this._shortWeekdaysParse,a))||-1!==(i=yt.call(this._weekdaysParse,a))||-1!==(i=yt.call(this._minWeekdaysParse,a))?i:null:-1!==(i=yt.call(this._minWeekdaysParse,a))||-1!==(i=yt.call(this._weekdaysParse,a))||-1!==(i=yt.call(this._shortWeekdaysParse,a))?i:null}function Xt(){function t(t,e){return e.length-t.length}var e,n,r,i,o,a=[],s=[],u=[],l=[];for(e=0;e<7;e++)n=p([2e3,1]).day(e),r=mt(this.weekdaysMin(n,"")),i=mt(this.weekdaysShort(n,"")),o=mt(this.weekdays(n,"")),a.push(r),s.push(i),u.push(o),l.push(r),l.push(i),l.push(o);a.sort(t),s.sort(t),u.sort(t),l.sort(t),this._weekdaysRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+u.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function qt(){return this.hours()%12||12}function $t(t,e){N(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function Qt(t,e){return e._meridiemParse}N("H",["HH",2],0,"hour"),N("h",["hh",2],0,qt),N("k",["kk",2],0,(function(){return this.hours()||24})),N("hmm",0,0,(function(){return""+qt.apply(this)+A(this.minutes(),2)})),N("hmmss",0,0,(function(){return""+qt.apply(this)+A(this.minutes(),2)+A(this.seconds(),2)})),N("Hmm",0,0,(function(){return""+this.hours()+A(this.minutes(),2)})),N("Hmmss",0,0,(function(){return""+this.hours()+A(this.minutes(),2)+A(this.seconds(),2)})),$t("a",!0),$t("A",!1),W("hour","h"),U("hour",13),pt("a",Qt),pt("A",Qt),pt("H",rt),pt("h",rt),pt("k",rt),pt("HH",rt,K),pt("hh",rt,K),pt("kk",rt,K),pt("hmm",it),pt("hmmss",ot),pt("Hmm",it),pt("Hmmss",ot),_t(["H","HH"],3),_t(["k","kk"],(function(t,e,n){var r=Z(t);e[3]=24===r?0:r})),_t(["a","A"],(function(t,e,n){n._isPm=n._locale.isPM(t),n._meridiem=t})),_t(["h","hh"],(function(t,e,n){e[3]=Z(t),v(n).bigHour=!0})),_t("hmm",(function(t,e,n){var r=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r)),v(n).bigHour=!0})),_t("hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r,2)),e[5]=Z(t.substr(i)),v(n).bigHour=!0})),_t("Hmm",(function(t,e,n){var r=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r))})),_t("Hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r,2)),e[5]=Z(t.substr(i))}));var Jt,Kt=X("Hours",!0),te={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:St,monthsShort:kt,week:{dow:0,doy:6},weekdays:Ft,weekdaysMin:Vt,weekdaysShort:Gt,meridiemParse:/[ap]\.?m?\.?/i},ee={},ne={};function re(t,e){var n,r=Math.min(t.length,e.length);for(n=0;n<r;n+=1)if(t[n]!==e[n])return n;return r}function ie(t){return t?t.toLowerCase().replace("_","-"):t}function oe(e){var n=null;if(void 0===ee[e]&&t&&t.exports)try{n=Jt._abbr,h(),ae(n)}catch(t){ee[e]=null}return ee[e]}function ae(t,e){var n;return t&&((n=u(e)?ue(t):se(t,e))?Jt=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),Jt._abbr}function se(t,e){if(null!==e){var n,r=te;if(e.abbr=t,null!=ee[t])O("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),r=ee[t]._config;else if(null!=e.parentLocale)if(null!=ee[e.parentLocale])r=ee[e.parentLocale]._config;else{if(null==(n=oe(e.parentLocale)))return ne[e.parentLocale]||(ne[e.parentLocale]=[]),ne[e.parentLocale].push({name:t,config:e}),null;r=n._config}return ee[t]=new C(E(r,e)),ne[t]&&ne[t].forEach((function(t){se(t.name,t.config)})),ae(t),ee[t]}return delete ee[t],null}function ue(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return Jt;if(!i(t)){if(e=oe(t))return e;t=[t]}return function(t){for(var e,n,r,i,o=0;o<t.length;){for(e=(i=ie(t[o]).split("-")).length,n=(n=ie(t[o+1]))?n.split("-"):null;e>0;){if(r=oe(i.slice(0,e).join("-")))return r;if(n&&n.length>=e&&re(i,n)>=e-1)break;e--}o++}return Jt}(t)}function le(t){var e,n=t._a;return n&&-2===v(t).overflow&&(e=n[1]<0||n[1]>11?1:n[2]<1||n[2]>xt(n[0],n[1])?2:n[3]<0||n[3]>24||24===n[3]&&(0!==n[4]||0!==n[5]||0!==n[6])?3:n[4]<0||n[4]>59?4:n[5]<0||n[5]>59?5:n[6]<0||n[6]>999?6:-1,v(t)._overflowDayOfYear&&(e<0||e>2)&&(e=2),v(t)._overflowWeeks&&-1===e&&(e=7),v(t)._overflowWeekday&&-1===e&&(e=8),v(t).overflow=e),t}var he=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ce=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,fe=/Z|[+-]\d\d(?::?\d\d)?/,de=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],pe=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],ve=/^\/?Date\((-?\d+)/i,me=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,ye={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function ge(t){var e,n,r,i,o,a,s=t._i,u=he.exec(s)||ce.exec(s);if(u){for(v(t).iso=!0,e=0,n=de.length;e<n;e++)if(de[e][1].exec(u[1])){i=de[e][0],r=!1!==de[e][2];break}if(null==i)return void(t._isValid=!1);if(u[3]){for(e=0,n=pe.length;e<n;e++)if(pe[e][1].exec(u[3])){o=(u[2]||" ")+pe[e][0];break}if(null==o)return void(t._isValid=!1)}if(!r&&null!=o)return void(t._isValid=!1);if(u[4]){if(!fe.exec(u[4]))return void(t._isValid=!1);a="Z"}t._f=i+(o||"")+(a||""),Se(t)}else t._isValid=!1}function _e(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function we(t){var e,n,r,i,o,a,s,u,l=me.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(l){if(n=l[4],r=l[3],i=l[2],o=l[5],a=l[6],s=l[7],u=[_e(n),kt.indexOf(r),parseInt(i,10),parseInt(o,10),parseInt(a,10)],s&&u.push(parseInt(s,10)),e=u,!function(t,e,n){return!t||Gt.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(v(n).weekdayMismatch=!0,n._isValid=!1,!1)}(l[1],e,t))return;t._a=e,t._tzm=function(t,e,n){if(t)return ye[t];if(e)return 0;var r=parseInt(n,10),i=r%100;return(r-i)/100*60+i}(l[8],l[9],l[10]),t._d=Yt.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),v(t).rfc2822=!0}else t._isValid=!1}function be(t,e,n){return null!=t?t:null!=e?e:n}function xe(t){var e,n,i,o,a,s=[];if(!t._d){for(i=function(t){var e=new Date(r.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[2]&&null==t._a[1]&&function(t){var e,n,r,i,o,a,s,u,l;null!=(e=t._w).GG||null!=e.W||null!=e.E?(o=1,a=4,n=be(e.GG,t._a[0],jt(Te(),1,4).year),r=be(e.W,1),((i=be(e.E,1))<1||i>7)&&(u=!0)):(o=t._locale._week.dow,a=t._locale._week.doy,l=jt(Te(),o,a),n=be(e.gg,t._a[0],l.year),r=be(e.w,l.week),null!=e.d?((i=e.d)<0||i>6)&&(u=!0):null!=e.e?(i=e.e+o,(e.e<0||e.e>6)&&(u=!0)):i=o),r<1||r>zt(n,o,a)?v(t)._overflowWeeks=!0:null!=u?v(t)._overflowWeekday=!0:(s=It(n,r,i,o,a),t._a[0]=s.year,t._dayOfYear=s.dayOfYear)}(t),null!=t._dayOfYear&&(a=be(t._a[0],i[0]),(t._dayOfYear>Pt(a)||0===t._dayOfYear)&&(v(t)._overflowDayOfYear=!0),n=Yt(a,0,t._dayOfYear),t._a[1]=n.getUTCMonth(),t._a[2]=n.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=i[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[3]&&0===t._a[4]&&0===t._a[5]&&0===t._a[6]&&(t._nextDay=!0,t._a[3]=0),t._d=(t._useUTC?Yt:Rt).apply(null,s),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[3]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(v(t).weekdayMismatch=!0)}}function Se(t){if(t._f!==r.ISO_8601)if(t._f!==r.RFC_2822){t._a=[],v(t).empty=!0;var e,n,i,o,a,s,u=""+t._i,l=u.length,h=0;for(i=j(t._f,t._locale).match(P)||[],e=0;e<i.length;e++)o=i[e],(n=(u.match(vt(o,t))||[])[0])&&((a=u.substr(0,u.indexOf(n))).length>0&&v(t).unusedInput.push(a),u=u.slice(u.indexOf(n)+n.length),h+=n.length),Y[o]?(n?v(t).empty=!1:v(t).unusedTokens.push(o),bt(o,n,t)):t._strict&&!n&&v(t).unusedTokens.push(o);v(t).charsLeftOver=l-h,u.length>0&&v(t).unusedInput.push(u),t._a[3]<=12&&!0===v(t).bigHour&&t._a[3]>0&&(v(t).bigHour=void 0),v(t).parsedDateParts=t._a.slice(0),v(t).meridiem=t._meridiem,t._a[3]=function(t,e,n){var r;return null==n?e:null!=t.meridiemHour?t.meridiemHour(e,n):null!=t.isPM?((r=t.isPM(n))&&e<12&&(e+=12),r||12!==e||(e=0),e):e}(t._locale,t._a[3],t._meridiem),null!==(s=v(t).era)&&(t._a[0]=t._locale.erasConvertYear(s,t._a[0])),xe(t),le(t)}else we(t);else ge(t)}function ke(t){var e=t._i,n=t._f;return t._locale=t._locale||ue(t._l),null===e||void 0===n&&""===e?y({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),x(e)?new b(le(e)):(c(e)?t._d=e:i(n)?function(t){var e,n,r,i,o,a,s=!1;if(0===t._f.length)return v(t).invalidFormat=!0,void(t._d=new Date(NaN));for(i=0;i<t._f.length;i++)o=0,a=!1,e=w({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[i],Se(e),m(e)&&(a=!0),o+=v(e).charsLeftOver,o+=10*v(e).unusedTokens.length,v(e).score=o,s?o<r&&(r=o,n=e):(null==r||o<r||a)&&(r=o,n=e,a&&(s=!0));d(t,n||e)}(t):n?Se(t):function(t){var e=t._i;u(e)?t._d=new Date(r.now()):c(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=ve.exec(t._i);null===e?(ge(t),!1===t._isValid&&(delete t._isValid,we(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:r.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):i(e)?(t._a=f(e.slice(0),(function(t){return parseInt(t,10)})),xe(t)):o(e)?function(t){if(!t._d){var e=G(t._i),n=void 0===e.day?e.date:e.day;t._a=f([e.year,e.month,n,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),xe(t)}}(t):l(e)?t._d=new Date(e):r.createFromInputFallback(t)}(t),m(t)||(t._d=null),t))}function De(t,e,n,r,a){var u,l={};return!0!==e&&!1!==e||(r=e,e=void 0),!0!==n&&!1!==n||(r=n,n=void 0),(o(t)&&s(t)||i(t)&&0===t.length)&&(t=void 0),l._isAMomentObject=!0,l._useUTC=l._isUTC=a,l._l=n,l._i=t,l._f=e,l._strict=r,(u=new b(le(ke(l))))._nextDay&&(u.add(1,"d"),u._nextDay=void 0),u}function Te(t,e,n,r){return De(t,e,n,r,!1)}r.createFromInputFallback=k("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Oe=k("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Te.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:y()})),Me=k("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Te.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:y()}));function Ee(t,e){var n,r;if(1===e.length&&i(e[0])&&(e=e[0]),!e.length)return Te();for(n=e[0],r=1;r<e.length;++r)e[r].isValid()&&!e[r][t](n)||(n=e[r]);return n}var Ce=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Ae(t){var e=G(t),n=e.year||0,r=e.quarter||0,i=e.month||0,o=e.week||e.isoWeek||0,s=e.day||0,u=e.hour||0,l=e.minute||0,h=e.second||0,c=e.millisecond||0;this._isValid=function(t){var e,n,r=!1;for(e in t)if(a(t,e)&&(-1===yt.call(Ce,e)||null!=t[e]&&isNaN(t[e])))return!1;for(n=0;n<Ce.length;++n)if(t[Ce[n]]){if(r)return!1;parseFloat(t[Ce[n]])!==Z(t[Ce[n]])&&(r=!0)}return!0}(e),this._milliseconds=+c+1e3*h+6e4*l+1e3*u*60*60,this._days=+s+7*o,this._months=+i+3*r+12*n,this._data={},this._locale=ue(),this._bubble()}function Pe(t){return t instanceof Ae}function Le(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function Re(t,e){N(t,0,0,(function(){var t=this.utcOffset(),n="+";return t<0&&(t=-t,n="-"),n+A(~~(t/60),2)+e+A(~~t%60,2)}))}Re("Z",":"),Re("ZZ",""),pt("Z",ft),pt("ZZ",ft),_t(["Z","ZZ"],(function(t,e,n){n._useUTC=!0,n._tzm=Ne(ft,t)}));var Ye=/([\+\-]|\d\d)/gi;function Ne(t,e){var n,r,i=(e||"").match(t);return null===i?null:0===(r=60*(n=((i[i.length-1]||[])+"").match(Ye)||["-",0,0])[1]+Z(n[2]))?0:"+"===n[0]?r:-r}function Ie(t,e){var n,i;return e._isUTC?(n=e.clone(),i=(x(t)||c(t)?t.valueOf():Te(t).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+i),r.updateOffset(n,!1),n):Te(t).local()}function je(t){return-Math.round(t._d.getTimezoneOffset())}function ze(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var We=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Fe=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Ge(t,e){var n,r,i,o,s,u,h=t,c=null;return Pe(t)?h={ms:t._milliseconds,d:t._days,M:t._months}:l(t)||!isNaN(+t)?(h={},e?h[e]=+t:h.milliseconds=+t):(c=We.exec(t))?(n="-"===c[1]?-1:1,h={y:0,d:Z(c[2])*n,h:Z(c[3])*n,m:Z(c[4])*n,s:Z(c[5])*n,ms:Z(Le(1e3*c[6]))*n}):(c=Fe.exec(t))?(n="-"===c[1]?-1:1,h={y:Ve(c[2],n),M:Ve(c[3],n),w:Ve(c[4],n),d:Ve(c[5],n),h:Ve(c[6],n),m:Ve(c[7],n),s:Ve(c[8],n)}):null==h?h={}:"object"==typeof h&&("from"in h||"to"in h)&&(o=Te(h.from),s=Te(h.to),i=o.isValid()&&s.isValid()?(s=Ie(s,o),o.isBefore(s)?u=Ue(o,s):((u=Ue(s,o)).milliseconds=-u.milliseconds,u.months=-u.months),u):{milliseconds:0,months:0},(h={}).ms=i.milliseconds,h.M=i.months),r=new Ae(h),Pe(t)&&a(t,"_locale")&&(r._locale=t._locale),Pe(t)&&a(t,"_isValid")&&(r._isValid=t._isValid),r}function Ve(t,e){var n=t&&parseFloat(t.replace(",","."));return(isNaN(n)?0:n)*e}function Ue(t,e){var n={};return n.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(n.months,"M").isAfter(e)&&--n.months,n.milliseconds=+e-+t.clone().add(n.months,"M"),n}function Be(t,e){return function(n,r){var i;return null===r||isNaN(+r)||(O(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),i=n,n=r,r=i),He(this,Ge(n,r),t),this}}function He(t,e,n,i){var o=e._milliseconds,a=Le(e._days),s=Le(e._months);t.isValid()&&(i=null==i||i,s&&Et(t,q(t,"Month")+s*n),a&&$(t,"Date",q(t,"Date")+a*n),o&&t._d.setTime(t._d.valueOf()+o*n),i&&r.updateOffset(t,a||s))}Ge.fn=Ae.prototype,Ge.invalid=function(){return Ge(NaN)};var Ze=Be(1,"add"),Xe=Be(-1,"subtract");function qe(t){return"string"==typeof t||t instanceof String}function $e(t){return x(t)||c(t)||qe(t)||l(t)||function(t){var e=i(t),n=!1;return e&&(n=0===t.filter((function(e){return!l(e)&&qe(t)})).length),e&&n}(t)||function(t){var e,n,r=o(t)&&!s(t),i=!1,u=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"];for(e=0;e<u.length;e+=1)n=u[e],i=i||a(t,n);return r&&i}(t)||null==t}function Qe(t){var e,n=o(t)&&!s(t),r=!1,i=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<i.length;e+=1)r=r||a(t,i[e]);return n&&r}function Je(t,e){if(t.date()<e.date())return-Je(e,t);var n=12*(e.year()-t.year())+(e.month()-t.month()),r=t.clone().add(n,"months");return-(n+(e-r<0?(e-r)/(r-t.clone().add(n-1,"months")):(e-r)/(t.clone().add(n+1,"months")-r)))||0}function Ke(t){var e;return void 0===t?this._locale._abbr:(null!=(e=ue(t))&&(this._locale=e),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var tn=k("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function en(){return this._locale}function nn(t,e){return(t%e+e)%e}function rn(t,e,n){return t<100&&t>=0?new Date(t+400,e,n)-126227808e5:new Date(t,e,n).valueOf()}function on(t,e,n){return t<100&&t>=0?Date.UTC(t+400,e,n)-126227808e5:Date.UTC(t,e,n)}function an(t,e){return e.erasAbbrRegex(t)}function sn(){var t,e,n=[],r=[],i=[],o=[],a=this.eras();for(t=0,e=a.length;t<e;++t)r.push(mt(a[t].name)),n.push(mt(a[t].abbr)),i.push(mt(a[t].narrow)),o.push(mt(a[t].name)),o.push(mt(a[t].abbr)),o.push(mt(a[t].narrow));this._erasRegex=new RegExp("^("+o.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+r.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+n.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+i.join("|")+")","i")}function un(t,e){N(0,[t,t.length],0,e)}function ln(t,e,n,r,i){var o;return null==t?jt(this,r,i).year:(e>(o=zt(t,r,i))&&(e=o),hn.call(this,t,e,n,r,i))}function hn(t,e,n,r,i){var o=It(t,e,n,r,i),a=Yt(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}N("N",0,0,"eraAbbr"),N("NN",0,0,"eraAbbr"),N("NNN",0,0,"eraAbbr"),N("NNNN",0,0,"eraName"),N("NNNNN",0,0,"eraNarrow"),N("y",["y",1],"yo","eraYear"),N("y",["yy",2],0,"eraYear"),N("y",["yyy",3],0,"eraYear"),N("y",["yyyy",4],0,"eraYear"),pt("N",an),pt("NN",an),pt("NNN",an),pt("NNNN",(function(t,e){return e.erasNameRegex(t)})),pt("NNNNN",(function(t,e){return e.erasNarrowRegex(t)})),_t(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,n,r){var i=n._locale.erasParse(t,r,n._strict);i?v(n).era=i:v(n).invalidEra=t})),pt("y",lt),pt("yy",lt),pt("yyy",lt),pt("yyyy",lt),pt("yo",(function(t,e){return e._eraYearOrdinalRegex||lt})),_t(["y","yy","yyy","yyyy"],0),_t(["yo"],(function(t,e,n,r){var i;n._locale._eraYearOrdinalRegex&&(i=t.match(n._locale._eraYearOrdinalRegex)),n._locale.eraYearOrdinalParse?e[0]=n._locale.eraYearOrdinalParse(t,i):e[0]=parseInt(t,10)})),N(0,["gg",2],0,(function(){return this.weekYear()%100})),N(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),un("gggg","weekYear"),un("ggggg","weekYear"),un("GGGG","isoWeekYear"),un("GGGGG","isoWeekYear"),W("weekYear","gg"),W("isoWeekYear","GG"),U("weekYear",1),U("isoWeekYear",1),pt("G",ht),pt("g",ht),pt("GG",rt,K),pt("gg",rt,K),pt("GGGG",st,et),pt("gggg",st,et),pt("GGGGG",ut,nt),pt("ggggg",ut,nt),wt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,n,r){e[r.substr(0,2)]=Z(t)})),wt(["gg","GG"],(function(t,e,n,i){e[i]=r.parseTwoDigitYear(t)})),N("Q",0,"Qo","quarter"),W("quarter","Q"),U("quarter",7),pt("Q",J),_t("Q",(function(t,e){e[1]=3*(Z(t)-1)})),N("D",["DD",2],"Do","date"),W("date","D"),U("date",9),pt("D",rt),pt("DD",rt,K),pt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),_t(["D","DD"],2),_t("Do",(function(t,e){e[2]=Z(t.match(rt)[0])}));var cn=X("Date",!0);N("DDD",["DDDD",3],"DDDo","dayOfYear"),W("dayOfYear","DDD"),U("dayOfYear",4),pt("DDD",at),pt("DDDD",tt),_t(["DDD","DDDD"],(function(t,e,n){n._dayOfYear=Z(t)})),N("m",["mm",2],0,"minute"),W("minute","m"),U("minute",14),pt("m",rt),pt("mm",rt,K),_t(["m","mm"],4);var fn=X("Minutes",!1);N("s",["ss",2],0,"second"),W("second","s"),U("second",15),pt("s",rt),pt("ss",rt,K),_t(["s","ss"],5);var dn,pn,vn=X("Seconds",!1);for(N("S",0,0,(function(){return~~(this.millisecond()/100)})),N(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),N(0,["SSS",3],0,"millisecond"),N(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),N(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),N(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),N(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),N(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),N(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),W("millisecond","ms"),U("millisecond",16),pt("S",at,J),pt("SS",at,K),pt("SSS",at,tt),dn="SSSS";dn.length<=9;dn+="S")pt(dn,lt);function mn(t,e){e[6]=Z(1e3*("0."+t))}for(dn="S";dn.length<=9;dn+="S")_t(dn,mn);pn=X("Milliseconds",!1),N("z",0,0,"zoneAbbr"),N("zz",0,0,"zoneName");var yn=b.prototype;function gn(t){return t}yn.add=Ze,yn.calendar=function(t,e){1===arguments.length&&($e(arguments[0])?(t=arguments[0],e=void 0):Qe(arguments[0])&&(e=arguments[0],t=void 0));var n=t||Te(),i=Ie(n,this).startOf("day"),o=r.calendarFormat(this,i)||"sameElse",a=e&&(M(e[o])?e[o].call(this,n):e[o]);return this.format(a||this.localeData().calendar(o,this,Te(n)))},yn.clone=function(){return new b(this)},yn.diff=function(t,e,n){var r,i,o;if(!this.isValid())return NaN;if(!(r=Ie(t,this)).isValid())return NaN;switch(i=6e4*(r.utcOffset()-this.utcOffset()),e=F(e)){case"year":o=Je(this,r)/12;break;case"month":o=Je(this,r);break;case"quarter":o=Je(this,r)/3;break;case"second":o=(this-r)/1e3;break;case"minute":o=(this-r)/6e4;break;case"hour":o=(this-r)/36e5;break;case"day":o=(this-r-i)/864e5;break;case"week":o=(this-r-i)/6048e5;break;default:o=this-r}return n?o:H(o)},yn.endOf=function(t){var e,n;if(void 0===(t=F(t))||"millisecond"===t||!this.isValid())return this;switch(n=this._isUTC?on:rn,t){case"year":e=n(this.year()+1,0,1)-1;break;case"quarter":e=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=n(this.year(),this.month()+1,1)-1;break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=36e5-nn(e+(this._isUTC?0:6e4*this.utcOffset()),36e5)-1;break;case"minute":e=this._d.valueOf(),e+=6e4-nn(e,6e4)-1;break;case"second":e=this._d.valueOf(),e+=1e3-nn(e,1e3)-1}return this._d.setTime(e),r.updateOffset(this,!0),this},yn.format=function(t){t||(t=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var e=I(this,t);return this.localeData().postformat(e)},yn.from=function(t,e){return this.isValid()&&(x(t)&&t.isValid()||Te(t).isValid())?Ge({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},yn.fromNow=function(t){return this.from(Te(),t)},yn.to=function(t,e){return this.isValid()&&(x(t)&&t.isValid()||Te(t).isValid())?Ge({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},yn.toNow=function(t){return this.to(Te(),t)},yn.get=function(t){return M(this[t=F(t)])?this[t]():this},yn.invalidAt=function(){return v(this).overflow},yn.isAfter=function(t,e){var n=x(t)?t:Te(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(e).valueOf())},yn.isBefore=function(t,e){var n=x(t)?t:Te(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(e).valueOf()<n.valueOf())},yn.isBetween=function(t,e,n,r){var i=x(t)?t:Te(t),o=x(e)?e:Te(e);return!!(this.isValid()&&i.isValid()&&o.isValid())&&(("("===(r=r||"()")[0]?this.isAfter(i,n):!this.isBefore(i,n))&&(")"===r[1]?this.isBefore(o,n):!this.isAfter(o,n)))},yn.isSame=function(t,e){var n,r=x(t)?t:Te(t);return!(!this.isValid()||!r.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()===r.valueOf():(n=r.valueOf(),this.clone().startOf(e).valueOf()<=n&&n<=this.clone().endOf(e).valueOf()))},yn.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},yn.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},yn.isValid=function(){return m(this)},yn.lang=tn,yn.locale=Ke,yn.localeData=en,yn.max=Me,yn.min=Oe,yn.parsingFlags=function(){return d({},v(this))},yn.set=function(t,e){if("object"==typeof t){var n,r=function(t){var e,n=[];for(e in t)a(t,e)&&n.push({unit:e,priority:V[e]});return n.sort((function(t,e){return t.priority-e.priority})),n}(t=G(t));for(n=0;n<r.length;n++)this[r[n].unit](t[r[n].unit])}else if(M(this[t=F(t)]))return this[t](e);return this},yn.startOf=function(t){var e,n;if(void 0===(t=F(t))||"millisecond"===t||!this.isValid())return this;switch(n=this._isUTC?on:rn,t){case"year":e=n(this.year(),0,1);break;case"quarter":e=n(this.year(),this.month()-this.month()%3,1);break;case"month":e=n(this.year(),this.month(),1);break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=n(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=nn(e+(this._isUTC?0:6e4*this.utcOffset()),36e5);break;case"minute":e=this._d.valueOf(),e-=nn(e,6e4);break;case"second":e=this._d.valueOf(),e-=nn(e,1e3)}return this._d.setTime(e),r.updateOffset(this,!0),this},yn.subtract=Xe,yn.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},yn.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},yn.toDate=function(){return new Date(this.valueOf())},yn.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,n=e?this.clone().utc():this;return n.year()<0||n.year()>9999?I(n,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):M(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",I(n,"Z")):I(n,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},yn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,n,r="moment",i="";return this.isLocal()||(r=0===this.utcOffset()?"moment.utc":"moment.parseZone",i="Z"),t="["+r+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",n=i+'[")]',this.format(t+e+"-MM-DD[T]HH:mm:ss.SSS"+n)},"undefined"!=typeof Symbol&&null!=Symbol.for&&(yn[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),yn.toJSON=function(){return this.isValid()?this.toISOString():null},yn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},yn.unix=function(){return Math.floor(this.valueOf()/1e3)},yn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},yn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},yn.eraName=function(){var t,e,n,r=this.localeData().eras();for(t=0,e=r.length;t<e;++t){if(n=this.startOf("day").valueOf(),r[t].since<=n&&n<=r[t].until)return r[t].name;if(r[t].until<=n&&n<=r[t].since)return r[t].name}return""},yn.eraNarrow=function(){var t,e,n,r=this.localeData().eras();for(t=0,e=r.length;t<e;++t){if(n=this.startOf("day").valueOf(),r[t].since<=n&&n<=r[t].until)return r[t].narrow;if(r[t].until<=n&&n<=r[t].since)return r[t].narrow}return""},yn.eraAbbr=function(){var t,e,n,r=this.localeData().eras();for(t=0,e=r.length;t<e;++t){if(n=this.startOf("day").valueOf(),r[t].since<=n&&n<=r[t].until)return r[t].abbr;if(r[t].until<=n&&n<=r[t].since)return r[t].abbr}return""},yn.eraYear=function(){var t,e,n,i,o=this.localeData().eras();for(t=0,e=o.length;t<e;++t)if(n=o[t].since<=o[t].until?1:-1,i=this.startOf("day").valueOf(),o[t].since<=i&&i<=o[t].until||o[t].until<=i&&i<=o[t].since)return(this.year()-r(o[t].since).year())*n+o[t].offset;return this.year()},yn.year=Lt,yn.isLeapYear=function(){return B(this.year())},yn.weekYear=function(t){return ln.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},yn.isoWeekYear=function(t){return ln.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},yn.quarter=yn.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},yn.month=Ct,yn.daysInMonth=function(){return xt(this.year(),this.month())},yn.week=yn.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},yn.isoWeek=yn.isoWeeks=function(t){var e=jt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},yn.weeksInYear=function(){var t=this.localeData()._week;return zt(this.year(),t.dow,t.doy)},yn.weeksInWeekYear=function(){var t=this.localeData()._week;return zt(this.weekYear(),t.dow,t.doy)},yn.isoWeeksInYear=function(){return zt(this.year(),1,4)},yn.isoWeeksInISOWeekYear=function(){return zt(this.isoWeekYear(),1,4)},yn.date=cn,yn.day=yn.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},yn.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},yn.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},yn.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},yn.hour=yn.hours=Kt,yn.minute=yn.minutes=fn,yn.second=yn.seconds=vn,yn.millisecond=yn.milliseconds=pn,yn.utcOffset=function(t,e,n){var i,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ne(ft,t)))return this}else Math.abs(t)<16&&!n&&(t*=60);return!this._isUTC&&e&&(i=je(this)),this._offset=t,this._isUTC=!0,null!=i&&this.add(i,"m"),o!==t&&(!e||this._changeInProgress?He(this,Ge(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:je(this)},yn.utc=function(t){return this.utcOffset(0,t)},yn.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(je(this),"m")),this},yn.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ne(ct,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},yn.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Te(t).utcOffset():0,(this.utcOffset()-t)%60==0)},yn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},yn.isLocal=function(){return!!this.isValid()&&!this._isUTC},yn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},yn.isUtc=ze,yn.isUTC=ze,yn.zoneAbbr=function(){return this._isUTC?"UTC":""},yn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},yn.dates=k("dates accessor is deprecated. Use date instead.",cn),yn.months=k("months accessor is deprecated. Use month instead",Ct),yn.years=k("years accessor is deprecated. Use year instead",Lt),yn.zone=k("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),yn.isDSTShifted=k("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!u(this._isDSTShifted))return this._isDSTShifted;var t,e={};return w(e,this),(e=ke(e))._a?(t=e._isUTC?p(e._a):Te(e._a),this._isDSTShifted=this.isValid()&&function(t,e,n){var r,i=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),a=0;for(r=0;r<i;r++)(n&&t[r]!==e[r]||!n&&Z(t[r])!==Z(e[r]))&&a++;return a+o}(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}));var _n=C.prototype;function wn(t,e,n,r){var i=ue(),o=p().set(r,e);return i[n](o,t)}function bn(t,e,n){if(l(t)&&(e=t,t=void 0),t=t||"",null!=e)return wn(t,e,n,"month");var r,i=[];for(r=0;r<12;r++)i[r]=wn(t,r,n,"month");return i}function xn(t,e,n,r){"boolean"==typeof t?(l(e)&&(n=e,e=void 0),e=e||""):(n=e=t,t=!1,l(e)&&(n=e,e=void 0),e=e||"");var i,o=ue(),a=t?o._week.dow:0,s=[];if(null!=n)return wn(e,(n+a)%7,r,"day");for(i=0;i<7;i++)s[i]=wn(e,(i+a)%7,r,"day");return s}_n.calendar=function(t,e,n){var r=this._calendar[t]||this._calendar.sameElse;return M(r)?r.call(e,n):r},_n.longDateFormat=function(t){var e=this._longDateFormat[t],n=this._longDateFormat[t.toUpperCase()];return e||!n?e:(this._longDateFormat[t]=n.match(P).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])},_n.invalidDate=function(){return this._invalidDate},_n.ordinal=function(t){return this._ordinal.replace("%d",t)},_n.preparse=gn,_n.postformat=gn,_n.relativeTime=function(t,e,n,r){var i=this._relativeTime[n];return M(i)?i(t,e,n,r):i.replace(/%d/i,t)},_n.pastFuture=function(t,e){var n=this._relativeTime[t>0?"future":"past"];return M(n)?n(e):n.replace(/%s/i,e)},_n.set=function(t){var e,n;for(n in t)a(t,n)&&(M(e=t[n])?this[n]=e:this["_"+n]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},_n.eras=function(t,e){var n,i,o,a=this._eras||ue("en")._eras;for(n=0,i=a.length;n<i;++n){switch(typeof a[n].since){case"string":o=r(a[n].since).startOf("day"),a[n].since=o.valueOf()}switch(typeof a[n].until){case"undefined":a[n].until=1/0;break;case"string":o=r(a[n].until).startOf("day").valueOf(),a[n].until=o.valueOf()}}return a},_n.erasParse=function(t,e,n){var r,i,o,a,s,u=this.eras();for(t=t.toUpperCase(),r=0,i=u.length;r<i;++r)if(o=u[r].name.toUpperCase(),a=u[r].abbr.toUpperCase(),s=u[r].narrow.toUpperCase(),n)switch(e){case"N":case"NN":case"NNN":if(a===t)return u[r];break;case"NNNN":if(o===t)return u[r];break;case"NNNNN":if(s===t)return u[r]}else if([o,a,s].indexOf(t)>=0)return u[r]},_n.erasConvertYear=function(t,e){var n=t.since<=t.until?1:-1;return void 0===e?r(t.since).year():r(t.since).year()+(e-t.offset)*n},_n.erasAbbrRegex=function(t){return a(this,"_erasAbbrRegex")||sn.call(this),t?this._erasAbbrRegex:this._erasRegex},_n.erasNameRegex=function(t){return a(this,"_erasNameRegex")||sn.call(this),t?this._erasNameRegex:this._erasRegex},_n.erasNarrowRegex=function(t){return a(this,"_erasNarrowRegex")||sn.call(this),t?this._erasNarrowRegex:this._erasRegex},_n.months=function(t,e){return t?i(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||Dt).test(e)?"format":"standalone"][t.month()]:i(this._months)?this._months:this._months.standalone},_n.monthsShort=function(t,e){return t?i(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[Dt.test(e)?"format":"standalone"][t.month()]:i(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},_n.monthsParse=function(t,e,n){var r,i,o;if(this._monthsParseExact)return Mt.call(this,t,e,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),r=0;r<12;r++){if(i=p([2e3,r]),n&&!this._longMonthsParse[r]&&(this._longMonthsParse[r]=new RegExp("^"+this.months(i,"").replace(".","")+"$","i"),this._shortMonthsParse[r]=new RegExp("^"+this.monthsShort(i,"").replace(".","")+"$","i")),n||this._monthsParse[r]||(o="^"+this.months(i,"")+"|^"+this.monthsShort(i,""),this._monthsParse[r]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===e&&this._longMonthsParse[r].test(t))return r;if(n&&"MMM"===e&&this._shortMonthsParse[r].test(t))return r;if(!n&&this._monthsParse[r].test(t))return r}},_n.monthsRegex=function(t){return this._monthsParseExact?(a(this,"_monthsRegex")||At.call(this),t?this._monthsStrictRegex:this._monthsRegex):(a(this,"_monthsRegex")||(this._monthsRegex=Ot),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},_n.monthsShortRegex=function(t){return this._monthsParseExact?(a(this,"_monthsRegex")||At.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(a(this,"_monthsShortRegex")||(this._monthsShortRegex=Tt),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},_n.week=function(t){return jt(t,this._week.dow,this._week.doy).week},_n.firstDayOfYear=function(){return this._week.doy},_n.firstDayOfWeek=function(){return this._week.dow},_n.weekdays=function(t,e){var n=i(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Wt(n,this._week.dow):t?n[t.day()]:n},_n.weekdaysMin=function(t){return!0===t?Wt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},_n.weekdaysShort=function(t){return!0===t?Wt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},_n.weekdaysParse=function(t,e,n){var r,i,o;if(this._weekdaysParseExact)return Zt.call(this,t,e,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),r=0;r<7;r++){if(i=p([2e3,1]).day(r),n&&!this._fullWeekdaysParse[r]&&(this._fullWeekdaysParse[r]=new RegExp("^"+this.weekdays(i,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[r]=new RegExp("^"+this.weekdaysShort(i,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[r]=new RegExp("^"+this.weekdaysMin(i,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[r]||(o="^"+this.weekdays(i,"")+"|^"+this.weekdaysShort(i,"")+"|^"+this.weekdaysMin(i,""),this._weekdaysParse[r]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===e&&this._fullWeekdaysParse[r].test(t))return r;if(n&&"ddd"===e&&this._shortWeekdaysParse[r].test(t))return r;if(n&&"dd"===e&&this._minWeekdaysParse[r].test(t))return r;if(!n&&this._weekdaysParse[r].test(t))return r}},_n.weekdaysRegex=function(t){return this._weekdaysParseExact?(a(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(a(this,"_weekdaysRegex")||(this._weekdaysRegex=Ut),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},_n.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(a(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(a(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Bt),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},_n.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(a(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(a(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Ht),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},_n.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},_n.meridiem=function(t,e,n){return t>11?n?"pm":"PM":n?"am":"AM"},ae("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===Z(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),r.lang=k("moment.lang is deprecated. Use moment.locale instead.",ae),r.langData=k("moment.langData is deprecated. Use moment.localeData instead.",ue);var Sn=Math.abs;function kn(t,e,n,r){var i=Ge(e,n);return t._milliseconds+=r*i._milliseconds,t._days+=r*i._days,t._months+=r*i._months,t._bubble()}function Dn(t){return t<0?Math.floor(t):Math.ceil(t)}function Tn(t){return 4800*t/146097}function On(t){return 146097*t/4800}function Mn(t){return function(){return this.as(t)}}var En=Mn("ms"),Cn=Mn("s"),An=Mn("m"),Pn=Mn("h"),Ln=Mn("d"),Rn=Mn("w"),Yn=Mn("M"),Nn=Mn("Q"),In=Mn("y");function jn(t){return function(){return this.isValid()?this._data[t]:NaN}}var zn=jn("milliseconds"),Wn=jn("seconds"),Fn=jn("minutes"),Gn=jn("hours"),Vn=jn("days"),Un=jn("months"),Bn=jn("years"),Hn=Math.round,Zn={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function Xn(t,e,n,r,i){return i.relativeTime(e||1,!!n,t,r)}var qn=Math.abs;function $n(t){return(t>0)-(t<0)||+t}function Qn(){if(!this.isValid())return this.localeData().invalidDate();var t,e,n,r,i,o,a,s,u=qn(this._milliseconds)/1e3,l=qn(this._days),h=qn(this._months),c=this.asSeconds();return c?(t=H(u/60),e=H(t/60),u%=60,t%=60,n=H(h/12),h%=12,r=u?u.toFixed(3).replace(/\.?0+$/,""):"",i=c<0?"-":"",o=$n(this._months)!==$n(c)?"-":"",a=$n(this._days)!==$n(c)?"-":"",s=$n(this._milliseconds)!==$n(c)?"-":"",i+"P"+(n?o+n+"Y":"")+(h?o+h+"M":"")+(l?a+l+"D":"")+(e||t||u?"T":"")+(e?s+e+"H":"")+(t?s+t+"M":"")+(u?s+r+"S":"")):"P0D"}var Jn=Ae.prototype;return Jn.isValid=function(){return this._isValid},Jn.abs=function(){var t=this._data;return this._milliseconds=Sn(this._milliseconds),this._days=Sn(this._days),this._months=Sn(this._months),t.milliseconds=Sn(t.milliseconds),t.seconds=Sn(t.seconds),t.minutes=Sn(t.minutes),t.hours=Sn(t.hours),t.months=Sn(t.months),t.years=Sn(t.years),this},Jn.add=function(t,e){return kn(this,t,e,1)},Jn.subtract=function(t,e){return kn(this,t,e,-1)},Jn.as=function(t){if(!this.isValid())return NaN;var e,n,r=this._milliseconds;if("month"===(t=F(t))||"quarter"===t||"year"===t)switch(e=this._days+r/864e5,n=this._months+Tn(e),t){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(e=this._days+Math.round(On(this._months)),t){case"week":return e/7+r/6048e5;case"day":return e+r/864e5;case"hour":return 24*e+r/36e5;case"minute":return 1440*e+r/6e4;case"second":return 86400*e+r/1e3;case"millisecond":return Math.floor(864e5*e)+r;default:throw new Error("Unknown unit "+t)}},Jn.asMilliseconds=En,Jn.asSeconds=Cn,Jn.asMinutes=An,Jn.asHours=Pn,Jn.asDays=Ln,Jn.asWeeks=Rn,Jn.asMonths=Yn,Jn.asQuarters=Nn,Jn.asYears=In,Jn.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*Z(this._months/12):NaN},Jn._bubble=function(){var t,e,n,r,i,o=this._milliseconds,a=this._days,s=this._months,u=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*Dn(On(s)+a),a=0,s=0),u.milliseconds=o%1e3,t=H(o/1e3),u.seconds=t%60,e=H(t/60),u.minutes=e%60,n=H(e/60),u.hours=n%24,a+=H(n/24),i=H(Tn(a)),s+=i,a-=Dn(On(i)),r=H(s/12),s%=12,u.days=a,u.months=s,u.years=r,this},Jn.clone=function(){return Ge(this)},Jn.get=function(t){return t=F(t),this.isValid()?this[t+"s"]():NaN},Jn.milliseconds=zn,Jn.seconds=Wn,Jn.minutes=Fn,Jn.hours=Gn,Jn.days=Vn,Jn.weeks=function(){return H(this.days()/7)},Jn.months=Un,Jn.years=Bn,Jn.humanize=function(t,e){if(!this.isValid())return this.localeData().invalidDate();var n,r,i=!1,o=Zn;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(i=t),"object"==typeof e&&(o=Object.assign({},Zn,e),null!=e.s&&null==e.ss&&(o.ss=e.s-1)),n=this.localeData(),r=function(t,e,n,r){var i=Ge(t).abs(),o=Hn(i.as("s")),a=Hn(i.as("m")),s=Hn(i.as("h")),u=Hn(i.as("d")),l=Hn(i.as("M")),h=Hn(i.as("w")),c=Hn(i.as("y")),f=o<=n.ss&&["s",o]||o<n.s&&["ss",o]||a<=1&&["m"]||a<n.m&&["mm",a]||s<=1&&["h"]||s<n.h&&["hh",s]||u<=1&&["d"]||u<n.d&&["dd",u];return null!=n.w&&(f=f||h<=1&&["w"]||h<n.w&&["ww",h]),(f=f||l<=1&&["M"]||l<n.M&&["MM",l]||c<=1&&["y"]||["yy",c])[2]=e,f[3]=+t>0,f[4]=r,Xn.apply(null,f)}(this,!i,o,n),i&&(r=n.pastFuture(+this,r)),n.postformat(r)},Jn.toISOString=Qn,Jn.toString=Qn,Jn.toJSON=Qn,Jn.locale=Ke,Jn.localeData=en,Jn.toIsoString=k("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",Qn),Jn.lang=tn,N("X",0,0,"unix"),N("x",0,0,"valueOf"),pt("x",ht),pt("X",/[+-]?\d+(\.\d{1,3})?/),_t("X",(function(t,e,n){n._d=new Date(1e3*parseFloat(t))})),_t("x",(function(t,e,n){n._d=new Date(Z(t))})),r.version="2.26.0",e=Te,r.fn=yn,r.min=function(){var t=[].slice.call(arguments,0);return Ee("isBefore",t)},r.max=function(){var t=[].slice.call(arguments,0);return Ee("isAfter",t)},r.now=function(){return Date.now?Date.now():+new Date},r.utc=p,r.unix=function(t){return Te(1e3*t)},r.months=function(t,e){return bn(t,e,"months")},r.isDate=c,r.locale=ae,r.invalid=y,r.duration=Ge,r.isMoment=x,r.weekdays=function(t,e,n){return xn(t,e,n,"weekdays")},r.parseZone=function(){return Te.apply(null,arguments).parseZone()},r.localeData=ue,r.isDuration=Pe,r.monthsShort=function(t,e){return bn(t,e,"monthsShort")},r.weekdaysMin=function(t,e,n){return xn(t,e,n,"weekdaysMin")},r.defineLocale=se,r.updateLocale=function(t,e){if(null!=e){var n,r,i=te;null!=ee[t]&&null!=ee[t].parentLocale?ee[t].set(E(ee[t]._config,e)):(null!=(r=oe(t))&&(i=r._config),e=E(i,e),null==r&&(e.abbr=t),(n=new C(e)).parentLocale=ee[t],ee[t]=n),ae(t)}else null!=ee[t]&&(null!=ee[t].parentLocale?(ee[t]=ee[t].parentLocale,t===ae()&&ae(t)):null!=ee[t]&&delete ee[t]);return ee[t]},r.locales=function(){return D(ee)},r.weekdaysShort=function(t,e,n){return xn(t,e,n,"weekdaysShort")},r.normalizeUnits=F,r.relativeTimeRounding=function(t){return void 0===t?Hn:"function"==typeof t&&(Hn=t,!0)},r.relativeTimeThreshold=function(t,e){return void 0!==Zn[t]&&(void 0===e?Zn[t]:(Zn[t]=e,"s"===t&&(Zn.ss=e-1),!0))},r.calendarFormat=function(t,e){var n=t.diff(e,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},r.prototype=yn,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()}));function Fs(t,e){var n=mr(t);if(ur){var r=ur(t);e&&(r=si(r).call(r,(function(e){return sr(t,e).enumerable}))),n.push.apply(n,r)}return n}function Gs(t){var e=function(){if("undefined"==typeof Reflect||!Jo)return!1;if(Jo.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Jo(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var n,r=Ca(t);if(e){var i=Ca(this).constructor;n=Jo(r,arguments,i)}else n=r.apply(this,arguments);return Ma(this,n)}}function Vs(t){if(void 0===Gn||null==Re(t)){if(Ui(t)||(t=function(t,e){var n;if(!t)return;if("string"==typeof t)return Us(t,e);var r=Pi(n=Object.prototype.toString.call(t)).call(n,8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Kn(t);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return Us(t,e)}(t))){var e=0,n=function(){};return{s:n,n:function(){return e>=t.length?{done:!0}:{done:!1,value:t[e++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,i,o=!0,a=!1;return{s:function(){r=Le(t)},n:function(){var t=r.next();return o=t.done,t},e:function(t){a=!0,i=t},f:function(){try{o||null==r.return||r.return()}finally{if(a)throw i}}}}function Us(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r}var Bs=function(){function t(e,n,r){var i,o,a;As(this,t),this._source=e,this._transformers=n,this._target=r,this._listeners={add:Cs(i=this._add).call(i,this),remove:Cs(o=this._remove).call(o,this),update:Cs(a=this._update).call(a,this)}}return Ls(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return Os(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),Hs=function(){function t(e){As(this,t),this._source=e,this._transformers=[]}return Ls(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return si(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Hr(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return ws(e).call(e,t)})),this}},{key:"to",value:function(t){return new Bs(this._source,this._transformers,t)}}]),t}(),Zs=/^\/?Date\((-?\d+)/i;function Xs(t){return Ws.isMoment(t)}function qs(t,e){var n;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return mo(t)&&!isNaN(Date.parse(t))?Ws(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(vo(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(Xs(t))return new Date(t.valueOf());if(mo(t))return(n=Zs.exec(t))?new Date(Number(n[1])):Ws(new Date(t)).toDate();throw new Error("Cannot convert object of type "+xo(t)+" to type Date");case"Moment":if(vo(t))return Ws(t);if(t instanceof Date)return Ws(t.valueOf());if(Xs(t))return Ws(t);if(mo(t))return n=Zs.exec(t),Ws(n?Number(n[1]):t);throw new Error("Cannot convert object of type "+xo(t)+" to type Date");case"ISODate":if(vo(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(Xs(t))return t.toDate().toISOString();if(mo(t))return(n=Zs.exec(t))?new Date(Number(n[1])).toISOString():Ws(t).format();throw new Error("Cannot convert object of type "+xo(t)+" to type ISODate");case"ASPDate":if(vo(t))return"/Date("+t+")/";if(t instanceof Date||Xs(t))return"/Date("+t.valueOf()+")/";if(mo(t))return"/Date("+((n=Zs.exec(t))?new Date(Number(n[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+xo(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function $s(t){return"string"==typeof t||"number"==typeof t}var Qs=function(){function t(e){As(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return Ls(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,n=0;n<e.length;n++){var r=e[n];r.original?t[r.name]=r.original:delete t[r.name]}this._extended=null}}},{key:"replace",value:function(t,e){var n=this,r=t[e];if(!r)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];n.queue({args:e,fn:r,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=vs((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Wr(t=cs(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,n){var r=new t(n);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){r.flush()};var i=[{name:"flush",original:void 0}];if(n&&n.replace)for(var o=0;o<n.replace.length;o++){var a=n.replace[o];i.push({name:a,original:e[a]}),r.replace(e,a)}return r._extended={object:e,methods:i},r}}]),t}(),Js=function(){function t(){As(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return Ls(t,[{key:"_trigger",value:function(t,e,n){var r,i;if("*"===t)throw new Error("Cannot trigger event *");Wr(r=hi(i=[]).call(i,Ai(this._subscribers[t]),Ai(this._subscribers["*"]))).call(r,(function(r){r(t,e,null!=n?n:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var n;this._subscribers[t]=si(n=this._subscribers[t]).call(n,(function(t){return t!==e}))}}]),t}(),Ks=function(){function t(e){As(this,t),this._pairs=e}return Ls(t,[{key:is,value:rs.mark((function t(){var e,n,r,i,o;return rs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Vs(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=eo(n.value,2),i=r[0],o=r[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:rs.mark((function t(){var e,n,r,i,o;return rs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Vs(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=eo(n.value,2),i=r[0],o=r[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:rs.mark((function t(){var e,n,r,i;return rs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Vs(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=eo(n.value,1),i=r[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:rs.mark((function t(){var e,n,r,i;return rs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Vs(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=eo(n.value,2),i=r[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Hr(t=Ai(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Hr(t=Ai(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Ai(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=cr(null),n=Vs(this._pairs);try{for(n.s();!(t=n.n()).done;){var r=eo(t.value,2),i=r[0],o=r[1];e[i]=o}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"toMap",value:function(){return new ns(this._pairs)}},{key:"toIdSet",value:function(){return new es(this.toIdArray())}},{key:"toItemSet",value:function(){return new es(this.toItemArray())}},{key:"cache",value:function(){return new t(Ai(this._pairs))}},{key:"distinct",value:function(t){var e,n=new es,r=Vs(this._pairs);try{for(r.s();!(e=r.n()).done;){var i=eo(e.value,2),o=i[0],a=i[1];n.add(t(a,o))}}catch(t){r.e(t)}finally{r.f()}return n}},{key:"filter",value:function(e){var n=this._pairs;return new t(dr({},is,rs.mark((function t(){var r,i,o,a,s;return rs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=Vs(n),t.prev=1,r.s();case 3:if((i=r.n()).done){t.next=10;break}if(o=eo(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),r.e(t.t0);case 15:return t.prev=15,r.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,n=Vs(this._pairs);try{for(n.s();!(e=n.n()).done;){var r=eo(e.value,2),i=r[0];t(r[1],i)}}catch(t){n.e(t)}finally{n.f()}}},{key:"map",value:function(e){var n=this._pairs;return new t(dr({},is,rs.mark((function t(){var r,i,o,a,s;return rs.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=Vs(n),t.prev=1,r.s();case 3:if((i=r.n()).done){t.next=9;break}return o=eo(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),r.e(t.t0);case 14:return t.prev=14,r.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Le(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=eo(n.value,2),a=o[0],s=o[1],u=t(s,a);u>i&&(i=u,r=s)}return r}},{key:"min",value:function(t){var e=Le(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=eo(n.value,2),a=o[0],s=o[1],u=t(s,a);u<i&&(i=u,r=s)}return r}},{key:"reduce",value:function(t,e){var n,r=Vs(this._pairs);try{for(r.s();!(n=r.n()).done;){var i=eo(n.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"sort",value:function(e){var n=this;return new t(dr({},is,(function(){var t;return Le(ja(t=Ai(n._pairs)).call(t,(function(t,n){var r=eo(t,2),i=r[0],o=r[1],a=eo(n,2),s=a[0],u=a[1];return e(o,u,i,s)})))})))}}]),t}(),tu=function(){console.warn("Type coercion has been deprecated. Please, use data pipes instead. See https://visjs.github.io/vis-data/data/datapipe.html#TypeCoercion for more details with working migration example.")},eu=function(t){Oa(n,t);var e=Gs(n);function n(t,r){var i;if(As(this,n),i=e.call(this),t&&!Ui(t)&&(r=t,t=[]),i._options=r||{},i._data=new ns,i.length=0,i._idProp=i._options.fieldId||"id",i._type={},i._options.type){tu();for(var o=mr(i._options.type),a=0,s=o.length;a<s;a++){var u=o[a],l=i._options.type[u];i._type[u]="Date"==l||"ISODate"==l||"ASPDate"==l?"Date":l}}return t&&t.length&&i.add(t),i.setOptions(r),i}return Ls(n,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=Qs.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Qi(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var n,r=this,i=[];if(Ui(t)){var o=Hr(t).call(t,(function(t){return t[r._idProp]}));if(Sa(o).call(o,(function(t){return r._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)n=this._addItem(t[a]),i.push(n)}else{if(!t||"object"!==Qi(t))throw new Error("Unknown dataType");n=this._addItem(t),i.push(n)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var n=this,r=[],i=[],o=[],a=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&n._data.has(e)){var u=t,l=Xi({},n._data.get(e)),h=n._updateItem(u);i.push(h),a.push(u),o.push(l)}else{var c=n._addItem(t);r.push(c)}};if(Ui(t))for(var l=0,h=t.length;l<h;l++)t[l]&&"object"===Qi(t[l])?u(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==Qi(t))throw new Error("Unknown dataType");u(t)}if(r.length&&this._trigger("add",{items:r},e),i.length){var c={items:i,oldData:o,data:a};this._trigger("update",c,e)}return hi(r).call(r,i)}},{key:"updateOnly",value:function(t,e){var n,r=this;Ui(t)||(t=[t]);var i=Hr(n=Hr(t).call(t,(function(t){var e=r._data.get(t[r._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(n,(function(t){var e=t.oldData,n=t.update,i=e[r._idProp],o=bo(bo({},e),n);return r._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:Hr(i).call(i,(function(t){return t.id})),oldData:Hr(i).call(i,(function(t){return t.oldData})),data:Hr(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var n=void 0,r=void 0,i=void 0;$s(t)?(n=t,i=e):Ui(t)?(r=t,i=e):i=t;var o=i&&"Object"===i.returnType?"Object":"Array",a=i&&i.type||this._options.type,s=i&&si(i),u=[],l=null,h=null,c=null;if(null!=n)(l=this._getItem(n,a))&&s&&!s(l)&&(l=null);else if(null!=r)for(var f=0,d=r.length;f<d;f++)null==(l=this._getItem(r[f],a))||s&&!s(l)||u.push(l);else for(var p,v=0,m=(h=Ai(ya(p=this._data).call(p))).length;v<m;v++)c=h[v],null==(l=this._getItem(c,a))||s&&!s(l)||u.push(l);if(i&&i.order&&null==n&&this._sort(u,i.order),i&&i.fields){var y=i.fields;if(null!=n&&null!=l)l=this._filterFields(l,y);else for(var g=0,_=u.length;g<_;g++)u[g]=this._filterFields(u[g],y)}if("Object"==o){for(var w={},b=0,x=u.length;b<x;b++){var S=u[b];w[S[this._idProp]]=S}return w}return null!=n?l:u}},{key:"getIds",value:function(t){var e,n,r=this._data,i=t&&si(t),o=t&&t.order,a=t&&t.type||this._options.type,s=Ai(ya(r).call(r)),u=[];if(i)if(o){n=[];for(var l=0,h=s.length;l<h;l++){var c=s[l];i(e=this._getItem(c,a))&&n.push(e)}this._sort(n,o);for(var f=0,d=n.length;f<d;f++)u.push(n[f][this._idProp])}else for(var p=0,v=s.length;p<v;p++){var m=s[p];i(e=this._getItem(m,a))&&u.push(e[this._idProp])}else if(o){n=[];for(var y=0,g=s.length;y<g;y++){var _=s[y];n.push(r.get(_))}this._sort(n,o);for(var w=0,b=n.length;w<b;w++)u.push(n[w][this._idProp])}else for(var x=0,S=s.length;x<S;x++){var k=s[x];e=r.get(k),u.push(e[this._idProp])}return u}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var n=e&&si(e),r=e&&e.type||this._options.type,i=this._data,o=Ai(ya(i).call(i));if(e&&e.order)for(var a=this.get(e),s=0,u=a.length;s<u;s++){var l=a[s];t(l,l[this._idProp])}else for(var h=0,c=o.length;h<c;h++){var f=o[h],d=this._getItem(f,r);n&&!n(d)||t(d,f)}}},{key:"map",value:function(t,e){for(var n=e&&si(e),r=e&&e.type||this._options.type,i=[],o=this._data,a=Ai(ya(o).call(o)),s=0,u=a.length;s<u;s++){var l=a[s],h=this._getItem(l,r);n&&!n(h)||i.push(t(h,l))}return e&&e.order&&this._sort(i,e.order),i}},{key:"_filterFields",value:function(t,e){var n;return t?Os(n=Ui(e)?e:mr(e)).call(n,(function(e,n){return e[n]=t[n],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var n=e;ja(t).call(t,(function(t,e){var r=t[n],i=e[n];return r>i?1:r<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");ja(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var n=[],r=[],i=Ui(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var u=s[this._idProp];null!=u&&(n.push(u),r.push(s))}}return n.length&&this._trigger("remove",{items:n,oldData:r},e),n}},{key:"_remove",value:function(t){var e;if($s(t)?e=t:t&&"object"===Qi(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var n=this._data.get(e)||null;return this._data.delete(e),--this.length,n}return null}},{key:"clear",value:function(t){for(var e,n=Ai(ya(e=this._data).call(e)),r=[],i=0,o=n.length;i<o;i++)r.push(this._data.get(n[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:n,oldData:r},t),n}},{key:"max",value:function(t){var e,n,r=null,i=null,o=Vs(da(e=this._data).call(e));try{for(o.s();!(n=o.n()).done;){var a=n.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(r=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return r||null}},{key:"min",value:function(t){var e,n,r=null,i=null,o=Vs(da(e=this._data).call(e));try{for(o.s();!(n=o.n()).done;){var a=n.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(r=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return r||null}},{key:"distinct",value:function(t){for(var e=this._data,n=Ai(ya(e).call(e)),r=[],i=this._options.type&&this._options.type[t]||null,o=0,a=0,s=n.length;a<s;a++){for(var u=n[a],l=e.get(u)[t],h=!1,c=0;c<o;c++)if(r[c]==l){h=!0;break}h||void 0===l||(r[o]=l,o++)}if(i)for(var f=0,d=r.length;f<d;f++)r[f]=qs(r[f],i);return r}},{key:"_addItem",value:function(t){var e=t[this._idProp];if(null!=e){if(this._data.has(e))throw new Error("Cannot add item: item with id "+e+" already exists")}else e=zs(),t[this._idProp]=e;for(var n={},r=mr(t),i=0,o=r.length;i<o;i++){var a=r[i],s=this._type[a];n[a]=qs(t[a],s)}return this._data.set(e,n),++this.length,e}},{key:"_getItem",value:function(t,e){var n,r=this._data.get(t);if(!r)return null;var i=mr(r);if(e){tu(),n={};for(var o=0,a=i.length;o<a;o++){var s=i[o],u=r[s];n[s]=qs(u,e[s])}}else n=function(t){for(var e=1;e<arguments.length;e++){var n,r=null!=arguments[e]?arguments[e]:{};if(e%2)Wr(n=Fs(Object(r),!0)).call(n,(function(e){dr(t,e,r[e])}));else if(ir)nr(t,ir(r));else{var i;Wr(i=Fs(Object(r))).call(i,(function(e){er(t,e,sr(r,e))}))}}return t}({},r);return null==n[this._idProp]&&(n[this._idProp]=r.id),n}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+la(t)+")");var n=this._data.get(e);if(!n)throw new Error("Cannot update item: no item with id "+e+" found");for(var r=mr(t),i=0,o=r.length;i<o;i++){var a=r[i],s=this._type[a];n[a]=qs(t[a],s)}return e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Ks(dr({},is,rs.mark((function n(){var r,i,o,a;return rs.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:r=Vs(t),n.prev=1,r.s();case 3:if((i=r.n()).done){n.next=11;break}if(o=i.value,null==(a=e.get(o))){n.next=9;break}return n.next=9,[o,a];case 9:n.next=3;break;case 11:n.next=16;break;case 13:n.prev=13,n.t0=n.catch(1),r.e(n.t0);case 16:return n.prev=16,r.f(),n.finish(16);case 19:case"end":return n.stop()}}),n,null,[[1,13,16,19]])}))))}var n;return new Ks(dr({},is,Cs(n=na(this._data)).call(n,this._data)))}}]),n}(Js),nu=function(t){Oa(n,t);var e=Gs(n);function n(t,r){var i,o;return As(this,n),(o=e.call(this)).length=0,o._ids=new es,o._options=r||{},o._listener=Cs(i=o._onEvent).call(i,Vo(o)),o.setData(t),o}return Ls(n,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:si(this._options)}),n=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:n})}if(null!=t){this._data=t;for(var r=this._data.getIds({filter:si(this._options)}),i=0,o=r.length;i<o;i++){var a=r[i];this._ids.add(a)}this.length=r.length,this._trigger("add",{items:r})}else this._data=new eu;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:si(this._options)}),e=Ai(this._ids),n={},r=[],i=[],o=[],a=0,s=t.length;a<s;a++){var u=t[a];n[u]=!0,this._ids.has(u)||(r.push(u),this._ids.add(u))}for(var l=0,h=e.length;l<h;l++){var c=e[l],f=this._data.get(c);null==f?console.error("If you see this, report it please."):n[c]||(i.push(c),o.push(f),this._ids.delete(c))}this.length+=r.length-i.length,r.length&&this._trigger("add",{items:r}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var n,r=null;$s(t)||Ui(t)?(r=t,n=e):n=t;var i=Xi({},this._options,n),o=si(this._options),a=n&&si(n);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==r?this._data.get(i):this._data.get(r,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,n=si(this._options),r=null!=t?si(t):null;return e=r?n?function(t){return n(t)&&r(t)}:r:n,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var n,r,i=si(this._options),o=e&&si(e);r=o?i?function(t){return i(t)&&o(t)}:o:i,Wr(n=this._data).call(n,t,{filter:r,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var n,r,i=si(this._options),o=e&&si(e);return r=o?i?function(t){return i(t)&&o(t)}:o:i,Hr(n=this._data).call(n,t,{filter:r,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||dr({},is,Cs(e=ya(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;(null===(t=this._data)||void 0===t?void 0:t.off)&&this._data.off("*",this._listener);var e="This data view has already been disposed of.";er(this,"_data",{get:function(){throw new Error(e)},set:function(){throw new Error(e)},configurable:!1})}},{key:"_onEvent",value:function(t,e,n){if(e&&e.items&&this._data){var r=e.items,i=[],o=[],a=[],s=[],u=[],l=[];switch(t){case"add":for(var h=0,c=r.length;h<c;h++){var f=r[h];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var d=0,p=r.length;d<p;d++){var v=r[d];this.get(v)?this._ids.has(v)?(o.push(v),u.push(e.data[d]),s.push(e.oldData[d])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),l.push(e.oldData[d]))}break;case"remove":for(var m=0,y=r.length;m<y;m++){var g=r[m];this._ids.has(g)&&(this._ids.delete(g),a.push(g),l.push(e.oldData[m]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},n),o.length&&this._trigger("update",{items:o,oldData:s,data:u},n),a.length&&this._trigger("remove",{items:a,oldData:l},n)}}}]),n}(Js),ru=Object.freeze({__proto__:null,DataSet:eu,DataStream:Ks,DataView:nu,Queue:Qs,createNewDataPipeFrom:function(t){return new Hs(t)}});yt({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var iu=ft.Number.isNaN;yt({target:"Array",proto:!0},{fill:function(t){for(var e=gt(this),n=Nt(e.length),r=arguments.length,i=zt(r>1?arguments[1]:void 0,n),o=r>2?arguments[2]:void 0,a=void 0===o?n:zt(o,n);a>i;)e[i++]=t;return e}});var ou=kr("Array").fill,au=Array.prototype,su=function(t){var e=t.fill;return t===au||t instanceof Array&&e===au.fill?ou:e},uu=xr.trim,lu=p.parseFloat,hu=1/lu(yr+"-0")!=-1/0?function(t){var e=uu(String(t)),n=lu(e);return 0===n&&"-"==e.charAt(0)?-0:n}:lu;yt({global:!0,forced:parseFloat!=hu},{parseFloat:hu});var cu=ft.parseFloat,fu=c((function(t){function e(t){if(t)return function(t){for(var n in e.prototype)t[n]=e.prototype[n];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function n(){this.off(t,n),e.apply(this,arguments)}return n.fn=e,this.on(t,n),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var n,r=this._callbacks["$"+t];if(!r)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<r.length;i++)if((n=r[i])===e||n.fn===e){r.splice(i,1);break}return 0===r.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),n=this._callbacks["$"+t],r=1;r<arguments.length;r++)e[r-1]=arguments[r];if(n){r=0;for(var i=(n=n.slice(0)).length;r<i;++r)n[r].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));function du(t,e,n){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==n?n:0}du.subtract=function(t,e){var n=new du;return n.x=t.x-e.x,n.y=t.y-e.y,n.z=t.z-e.z,n},du.add=function(t,e){var n=new du;return n.x=t.x+e.x,n.y=t.y+e.y,n.z=t.z+e.z,n},du.avg=function(t,e){return new du((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},du.scalarProduct=function(t,e){return new du(t.x*e,t.y*e,t.z*e)},du.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},du.crossProduct=function(t,e){var n=new du;return n.x=t.y*e.z-t.z*e.y,n.y=t.z*e.x-t.x*e.z,n.z=t.x*e.y-t.y*e.x,n},du.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},du.prototype.normalize=function(){return du.scalarProduct(this,1/this.length())};var pu=du;var vu=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function mu(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var n=this;this.frame.slide.onmousedown=function(t){n._onMouseDown(t)},this.frame.prev.onclick=function(t){n.prev(t)},this.frame.play.onclick=function(t){n.togglePlay(t)},this.frame.next.onclick=function(t){n.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}mu.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},mu.prototype.next=function(){var t=this.getIndex();t<da(this).length-1&&(t++,this.setIndex(t))},mu.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<da(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var n=new Date-t,r=Math.max(this.playInterval-n,0),i=this;this.playTimeout=vs((function(){i.playNext()}),r)},mu.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},mu.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},mu.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},mu.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},mu.prototype.setPlayInterval=function(t){this.playInterval=t},mu.prototype.getPlayInterval=function(){return this.playInterval},mu.prototype.setPlayLoop=function(t){this.playLoop=t},mu.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},mu.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},mu.prototype.setValues=function(t){this.values=t,da(this).length>0?this.setIndex(0):this.index=void 0},mu.prototype.setIndex=function(t){if(!(t<da(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},mu.prototype.getIndex=function(){return this.index},mu.prototype.get=function(){return da(this)[this.index]},mu.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=cu(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},To(document,"mousemove",this.onmousemove),To(document,"mouseup",this.onmouseup),Mo(t)}},mu.prototype.leftToIndex=function(t){var e=cu(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,n=t-3,r=Math.round(n/e*(da(this).length-1));return r<0&&(r=0),r>da(this).length-1&&(r=da(this).length-1),r},mu.prototype.indexToLeft=function(t){var e=cu(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(da(this).length-1)*e+3},mu.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,n=this.startSlideX+e,r=this.leftToIndex(n);this.setIndex(r),Mo()},mu.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",Oo(document,"mousemove",this.onmousemove),Oo(document,"mouseup",this.onmouseup),Mo()};var yu=Object.freeze({__proto__:null,default:mu});function gu(t,e,n,r){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,n,r)}gu.prototype.isNumeric=function(t){return!isNaN(cu(t))&&isFinite(t)},gu.prototype.setRange=function(t,e,n,r){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(n))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(n,r)},gu.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=gu.calculatePrettyStep(t):this._step=t)},gu.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},n=Math.pow(10,Math.round(e(t))),r=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=n;return Math.abs(r-t)<=Math.abs(o-t)&&(o=r),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},gu.prototype.getCurrent=function(){return cu(this._current.toPrecision(this.precision))},gu.prototype.getStep=function(){return this._step},gu.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},gu.prototype.next=function(){this._current+=this._step},gu.prototype.end=function(){return this._current>this._end};var _u=gu,wu=[].reverse,bu=[1,2];yt({target:"Array",proto:!0,forced:String(bu)===String(bu.reverse())},{reverse:function(){return Ye(this)&&(this.length=this.length),wu.call(this)}});var xu=kr("Array").reverse,Su=Array.prototype,ku=function(t){var e=t.reverse;return t===Su||t instanceof Array&&e===Su.reverse?xu:e},Du=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};yt({target:"Math",stat:!0},{sign:Du});var Tu=ft.Math.sign;function Ou(){this.armLocation=new pu,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new pu,this.offsetMultiplier=.6,this.cameraLocation=new pu,this.cameraRotation=new pu(.5*Math.PI,0,0),this.calculateCameraOrientation()}Ou.prototype.setOffset=function(t,e){var n=Math.abs,r=Tu,i=this.offsetMultiplier,o=this.armLength*i;n(t)>o&&(t=r(t)*o),n(e)>o&&(e=r(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},Ou.prototype.getOffset=function(){return this.cameraOffset},Ou.prototype.setArmLocation=function(t,e,n){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=n,this.calculateCameraOrientation()},Ou.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},Ou.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},Ou.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},Ou.prototype.getArmLength=function(){return this.armLength},Ou.prototype.getCameraLocation=function(){return this.cameraLocation},Ou.prototype.getCameraRotation=function(){return this.cameraRotation},Ou.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,n=this.cameraOffset.x,r=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+n*o(e)+r*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+n*i(e)+r*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+r*i(t)};var Mu=Object.freeze({__proto__:null,default:Ou}),Eu={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},Cu={dot:Eu.DOT,"dot-line":Eu.DOTLINE,"dot-color":Eu.DOTCOLOR,"dot-size":Eu.DOTSIZE,line:Eu.LINE,grid:Eu.GRID,surface:Eu.SURFACE,bar:Eu.BAR,"bar-color":Eu.BARCOLOR,"bar-size":Eu.BARSIZE},Au=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],Pu=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],Lu=void 0;function Ru(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function Yu(t,e){return void 0===t||""===t?e:t+(void 0===(n=e)||""===n||"string"!=typeof n?n:n.charAt(0).toUpperCase()+Pi(n).call(n,1));var n}function Nu(t,e,n,r){for(var i,o=0;o<n.length;++o)e[Yu(r,i=n[o])]=t[i]}function Iu(t,e,n,r){for(var i,o=0;o<n.length;++o)void 0!==t[i=n[o]]&&(e[Yu(r,i)]=t[i])}function ju(t,e){if(void 0!==t.backgroundColor&&function(t,e){var n="white",r="gray",i=1;if("string"==typeof t)n=t,r="none",i=0;else{if("object"!==Qi(t))throw new Error("Unsupported type of backgroundColor");void 0!==su(t)&&(n=su(t)),void 0!==t.stroke&&(r=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=n,e.frame.style.borderColor=r,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(su(t)&&(e.dataColor.fill=su(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var n;if("string"==typeof t){if(-1===(n=function(t){var e=Cu[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var n in Eu)if(Eu[n]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");n=t}e.style=n}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var n;if(Ui(t))n=zu(t);else{if("object"!==Qi(t))throw new Error("Unsupported type of surfaceColors");n=Wu(t.hue)}ku(n).call(n),e.colormap=n}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var n;if(Ui(t))n=zu(t);else if("object"===Qi(t))n=Wu(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");n=t}e.colormap=n}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===Lu.showLegend){var n=e.style===Eu.DOTCOLOR||e.style===Eu.DOTSIZE;e.showLegend=n}}else e.showLegend=t}(t.showLegend,e),Fu(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&wo(["tooltipStyle"],e,t)}function zu(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return Hr(t).call(t,(function(t){if(!jo(t))throw new Error("Invalid hex color code supplied to colormap.");return Co(t)}))}function Wu(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),n=[],r=0;r<t.colorStops;++r){var i=(t.start+e*r)%360/360;n.push(Yo(i<0?i+1:i,t.saturation/100,t.brightness/100))}return n}function Fu(t,e){var n=t;void 0!==n&&(void 0===e.camera&&(e.camera=new Ou),e.camera.setArmRotation(n.horizontal,n.vertical),e.camera.setArmLength(n.distance))}var Gu,Vu=!1,Uu="background: #FFeeee; color: #dd0000",Bu=function(){function t(){As(this,t)}return Ls(t,null,[{key:"validate",value:function(e,n,r){Vu=!1,Gu=n;var i=n;return void 0!==r&&(i=n[r]),t.parse(e,i,[]),Vu}},{key:"parse",value:function(e,n,r){for(var i in e)e.hasOwnProperty(i)&&t.check(i,e,n,r)}},{key:"check",value:function(e,n,r,i){if(void 0!==r[e]||void 0!==r.__any__){var o=e,a=!0;void 0===r[e]&&void 0!==r.__any__&&(o="__any__",a="object"===t.getType(n[e]));var s=r[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,n,r,o,s,i)}else t.getSuggestion(e,r,i)}},{key:"checkFields",value:function(e,n,r,i,o,a){var s=function(n){console.log("%c"+n+t.printLocation(a,e),Uu)},u=t.getType(n[e]),l=o[u];void 0!==l?"array"===t.getType(l)&&-1===Vi(l).call(l,n[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+n[e]+'". '),Vu=!0):"object"===u&&"__any__"!==i&&(a=So(a,e),t.parse(n[e],r[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(mr(o))+". Received ["+u+'] "'+n[e]+'"'),Vu=!0)}},{key:"getType",value:function(t){var e=Qi(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Ui(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,n,r){var i,o=t.findInOptions(e,n,r,!1),a=t.findInOptions(e,Gu,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(mr(n))+t.printLocation(r,e),console.log('%cUnknown option detected: "'+e+'"'+i,Uu),Vu=!0}},{key:"findInOptions",value:function(e,n,r){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],u=e.toLowerCase(),l=void 0;for(var h in n){var c=void 0;if(void 0!==n[h].__type__&&!0===i){var f=t.findInOptions(e,n[h],So(r,h));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,l=f.indexMatch)}else{var d;-1!==Vi(d=h.toLowerCase()).call(d,u)&&(l=h),o>(c=t.levenshteinDistance(e,h))&&(a=h,s=ko(r),o=c)}}return{closestMatch:a,path:s,distance:o,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",r="\n\n"+n+"options = {\n",i=0;i<t.length;i++){for(var o=0;o<i+1;o++)r+="  ";r+=t[i]+": {\n"}for(var a=0;a<t.length+1;a++)r+="  ";r+=e+"\n";for(var s=0;s<t.length+1;s++){for(var u=0;u<t.length-s;u++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return la(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var n,r,i=[];for(n=0;n<=e.length;n++)i[n]=[n];for(r=0;r<=t.length;r++)i[0][r]=r;for(n=1;n<=e.length;n++)for(r=1;r<=t.length;r++)e.charAt(n-1)==t.charAt(r-1)?i[n][r]=i[n-1][r-1]:i[n][r]=Math.min(i[n-1][r-1]+1,Math.min(i[n][r-1]+1,i[n-1][r]+1));return i[e.length][t.length]}}]),t}(),Hu="string",Zu="boolean",Xu="number",qu="object",$u={fill:{string:Hu},stroke:{string:Hu},strokeWidth:{number:Xu},__type__:{string:Hu,object:qu,undefined:"undefined"}},Qu={animationAutoStart:{boolean:Zu,undefined:"undefined"},animationInterval:{number:Xu},animationPreload:{boolean:Zu},axisColor:{string:Hu},axisFontSize:{number:Xu},axisFontType:{string:Hu},backgroundColor:$u,xBarWidth:{number:Xu,undefined:"undefined"},yBarWidth:{number:Xu,undefined:"undefined"},cameraPosition:{distance:{number:Xu},horizontal:{number:Xu},vertical:{number:Xu},__type__:{object:qu}},zoomable:{boolean:Zu},ctrlToZoom:{boolean:Zu},xCenter:{string:Hu},yCenter:{string:Hu},colormap:{hue:{start:{number:Xu},end:{number:Xu},saturation:{number:Xu},brightness:{number:Xu},colorStops:{number:Xu},__type__:{object:qu}},__type__:{array:"array",object:qu,function:"function",undefined:"undefined"}},dataColor:$u,dotSizeMinFraction:{number:Xu},dotSizeMaxFraction:{number:Xu},dotSizeRatio:{number:Xu},filterLabel:{string:Hu},gridColor:{string:Hu},onclick:{function:"function"},keepAspectRatio:{boolean:Zu},xLabel:{string:Hu},yLabel:{string:Hu},zLabel:{string:Hu},legendLabel:{string:Hu},xMin:{number:Xu,undefined:"undefined"},yMin:{number:Xu,undefined:"undefined"},zMin:{number:Xu,undefined:"undefined"},xMax:{number:Xu,undefined:"undefined"},yMax:{number:Xu,undefined:"undefined"},zMax:{number:Xu,undefined:"undefined"},showAnimationControls:{boolean:Zu,undefined:"undefined"},showGrayBottom:{boolean:Zu},showGrid:{boolean:Zu},showLegend:{boolean:Zu,undefined:"undefined"},showPerspective:{boolean:Zu},showShadow:{boolean:Zu},showSurfaceGrid:{boolean:Zu},showXAxis:{boolean:Zu},showYAxis:{boolean:Zu},showZAxis:{boolean:Zu},rotateAxisLabels:{boolean:Zu},surfaceColors:{hue:{start:{number:Xu},end:{number:Xu},saturation:{number:Xu},brightness:{number:Xu},colorStops:{number:Xu},__type__:{object:qu}},__type__:{boolean:Zu,array:"array",object:qu,undefined:"undefined"}},xStep:{number:Xu,undefined:"undefined"},yStep:{number:Xu,undefined:"undefined"},zStep:{number:Xu,undefined:"undefined"},style:{number:Xu,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:Zu,function:"function"},tooltipDelay:{number:Xu},tooltipStyle:{content:{color:{string:Hu},background:{string:Hu},border:{string:Hu},borderRadius:{string:Hu},boxShadow:{string:Hu},padding:{string:Hu},__type__:{object:qu}},line:{borderLeft:{string:Hu},height:{string:Hu},width:{string:Hu},pointerEvents:{string:Hu},__type__:{object:qu}},dot:{border:{string:Hu},borderRadius:{string:Hu},height:{string:Hu},width:{string:Hu},pointerEvents:{string:Hu},__type__:{object:qu}},__type__:{object:qu}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:Xu,undefined:"undefined"},valueMin:{number:Xu,undefined:"undefined"},verticalRatio:{number:Xu},height:{string:Hu},width:{string:Hu},__type__:{object:qu}};function Ju(){this.min=void 0,this.max=void 0}Ju.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},Ju.prototype.combine=function(t){this.add(t.min),this.add(t.max)},Ju.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,n=this.max+t;if(e>n)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=n}},Ju.prototype.range=function(){return this.max-this.min},Ju.prototype.center=function(){return(this.min+this.max)/2};var Ku=Ju;function tl(t,e,n){this.dataGroup=t,this.column=e,this.graph=n,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),da(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,n.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}tl.prototype.isLoaded=function(){return this.loaded},tl.prototype.getLoadedProgress=function(){for(var t=da(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},tl.prototype.getLabel=function(){return this.graph.filterLabel},tl.prototype.getColumn=function(){return this.column},tl.prototype.getSelectedValue=function(){if(void 0!==this.index)return da(this)[this.index]},tl.prototype.getValues=function(){return da(this)},tl.prototype.getValue=function(t){if(t>=da(this).length)throw new Error("Index out of range");return da(this)[t]},tl.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var n={};n.column=this.column,n.value=da(this)[t];var r=new nu(this.dataGroup.getDataSet(),{filter:function(t){return t[n.column]==n.value}}).get();e=this.dataGroup._getDataPoints(r),this.dataPoints[t]=e}return e},tl.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},tl.prototype.selectValue=function(t){if(t>=da(this).length)throw new Error("Index out of range");this.index=t,this.value=da(this)[t]},tl.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<da(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var n=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+n+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var r=this;vs((function(){r.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()};var el=Object.freeze({__proto__:null,default:tl});function nl(){this.dataTable=null}nl.prototype.initializeData=function(t,e,n){if(void 0!==e){var r;if(Ui(e)&&(e=new eu(e)),!(e instanceof eu||e instanceof nu))throw new Error("Array, DataSet, or DataView expected");if(0!=(r=e.get()).length){this.style=n,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=r;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(n);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(r,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(r,this.colY)||1),this._initializeRange(r,this.colX,t,o),this._initializeRange(r,this.colY,t,o),this._initializeRange(r,this.colZ,t,!1),r[0].hasOwnProperty("style")){this.colValue="style";var a=this.getColumnRange(r,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new tl(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},nl.prototype._collectRangeSettings=function(t,e){var n;if(-1==Vi(n=["x","y","z"]).call(n,t))throw new Error("Column '"+t+"' invalid");var r=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+r+"Min"],max:e["default"+r+"Max"],step:e["default"+r+"Step"],range_label:t+"Range",step_label:t+"Step"}},nl.prototype._initializeRange=function(t,e,n,r){var i=this._collectRangeSettings(e,n),o=this.getColumnRange(t,e);r&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},nl.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var n=[],r=0;r<e.length;r++){var i=e[r][t]||0;-1===Vi(n).call(n,i)&&n.push(i)}return ja(n).call(n,(function(t,e){return t-e}))},nl.prototype.getSmallestDifference=function(t,e){for(var n=this.getDistinctValues(t,e),r=null,i=1;i<n.length;i++){var o=n[i]-n[i-1];(null==r||r>o)&&(r=o)}return r},nl.prototype.getColumnRange=function(t,e){for(var n=new Ku,r=0;r<t.length;r++){var i=t[r][e];n.adjust(i)}return n},nl.prototype.getNumberOfRows=function(){return this.dataTable.length},nl.prototype._setRangeDefaults=function(t,e,n){void 0!==e&&(t.min=e),void 0!==n&&(t.max=n),t.max<=t.min&&(t.max=t.min+1)},nl.prototype.getDataTable=function(){return this.dataTable},nl.prototype.getDataSet=function(){return this.dataSet},nl.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new pu;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],r.value=t[n][this.colValue]||0;var i={};i.point=r,i.bottom=new pu(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},nl.prototype.initDataAsMatrix=function(t){var e,n,r,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),u=[];for(r=0;r<s.length;r++){i=s[r];var l=Vi(o).call(o,i.point.x),h=Vi(a).call(a,i.point.y);void 0===u[l]&&(u[l]=[]),u[l][h]=i}for(e=0;e<u.length;e++)for(n=0;n<u[e].length;n++)u[e][n]&&(u[e][n].pointRight=e<u.length-1?u[e+1][n]:void 0,u[e][n].pointTop=n<u[e].length-1?u[e][n+1]:void 0,u[e][n].pointCross=e<u.length-1&&n<u[e].length-1?u[e+1][n+1]:void 0);return s},nl.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},nl.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},nl.prototype._getDataPoints=function(t){var e=[];if(this.style===Eu.GRID||this.style===Eu.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===Eu.LINE)for(var n=0;n<e.length;n++)n>0&&(e[n-1].pointNext=e[n]);return e},rl.STYLE=Eu;function rl(t,e,n){if(!(this instanceof rl))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new nl,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||Ru(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");Lu=t,Nu(t,e,Au),Nu(t,e,Pu,"default"),ju(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new pu(0,0,-1)}(rl.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(n),this.setData(e)}function il(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function ol(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}rl.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:void 0,animationInterval:1e3,animationPreload:!1,animationAutoStart:void 0,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:rl.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:void 0,colormap:void 0,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:void 0,backgroundColor:void 0,xBarWidth:void 0,yBarWidth:void 0,valueMin:void 0,valueMax:void 0,xMin:void 0,xMax:void 0,xStep:void 0,yMin:void 0,yMax:void 0,yStep:void 0,zMin:void 0,zMax:void 0,zStep:void 0},fu(rl.prototype),rl.prototype._setScale=function(){this.scale=new pu(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,n=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,n)},rl.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},rl.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),n=this.camera.getCameraRotation(),r=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,u=e.z,l=Math.sin(n.x),h=Math.cos(n.x),c=Math.sin(n.y),f=Math.cos(n.y),d=Math.sin(n.z),p=Math.cos(n.z);return new pu(f*(d*(i-s)+p*(r-a))-c*(o-u),l*(f*(o-u)+c*(d*(i-s)+p*(r-a)))+h*(p*(i-s)-d*(r-a)),h*(f*(o-u)+c*(d*(i-s)+p*(r-a)))-l*(p*(i-s)-d*(r-a)))},rl.prototype._convertTranslationToScreen=function(t){var e,n,r=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,u=t.z;return this.showPerspective?(e=o/u*(a-r),n=o/u*(s-i)):(e=a*(-o/this.camera.getArmLength()),n=s*(-o/this.camera.getArmLength())),new vu(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-n*this.frame.canvas.clientWidth)},rl.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var n=t[e];n.trans=this._convertPointToTranslation(n.point),n.screen=this._convertTranslationToScreen(n.trans);var r=this._convertPointToTranslation(n.bottom);n.dist=this.showPerspective?r.length():-r.z}ja(t).call(t,(function(t,e){return e.dist-t.dist}))},rl.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},rl.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new pu;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],r.value=t[n][this.colValue]||0;var i={};i.point=r,i.bottom=new pu(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},rl.prototype._getDataPoints=function(t){var e,n,r,i,o=[];if(this.style===rl.STYLE.GRID||this.style===rl.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var u=[];for(r=0;r<o.length;r++){i=o[r];var l=Vi(a).call(a,i.point.x),h=Vi(s).call(s,i.point.y);void 0===u[l]&&(u[l]=[]),u[l][h]=i}for(e=0;e<u.length;e++)for(n=0;n<u[e].length;n++)u[e][n]&&(u[e][n].pointRight=e<u.length-1?u[e+1][n]:void 0,u[e][n].pointTop=n<u[e].length-1?u[e][n+1]:void 0,u[e][n].pointCross=e<u.length-1&&n<u[e].length-1?u[e+1][n+1]:void 0)}else if(o=this.getDataPoints(t),this.style===rl.STYLE.LINE)for(r=0;r<o.length;r++)r>0&&(o[r-1].pointNext=o[r]);return o},rl.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),si(this.frame).style.position="absolute",si(this.frame).style.bottom="0px",si(this.frame).style.left="0px",si(this.frame).style.width="100%",this.frame.appendChild(si(this.frame));var e=this;To(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),To(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),To(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),To(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),To(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},rl.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},rl.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,si(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},rl.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!si(this.frame)||!si(this.frame).slider)throw new Error("No animation available");si(this.frame).slider.play()}},rl.prototype.animationStop=function(){si(this.frame)&&si(this.frame).slider&&si(this.frame).slider.stop()},rl.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=cu(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=cu(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=cu(this.yCenter)/100*(this.frame.canvas.clientHeight-si(this.frame).clientHeight):this.currentYCenter=cu(this.yCenter)},rl.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},rl.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},rl.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},rl.prototype.setOptions=function(t){void 0!==t&&(!0===Bu.validate(t,Qu)&&console.log("%cErrors have been found in the supplied options object.",Uu),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===Lu||Ru(Lu))throw new Error("DEFAULTS not set for module Settings");Iu(t,e,Au),Iu(t,e,Pu,"default"),ju(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},rl.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case rl.STYLE.BAR:t=this._redrawBarGraphPoint;break;case rl.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case rl.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case rl.STYLE.DOT:t=this._redrawDotGraphPoint;break;case rl.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case rl.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case rl.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case rl.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case rl.STYLE.GRID:t=this._redrawGridGraphPoint;break;case rl.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},rl.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},rl.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},rl.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},rl.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},rl.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},rl.prototype._getLegendWidth=function(){var t;this.style===rl.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===rl.STYLE.BARSIZE?this.xBarWidth:20;return t},rl.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==rl.STYLE.LINE&&this.style!==rl.STYLE.BARSIZE){var t=this.style===rl.STYLE.BARSIZE||this.style===rl.STYLE.DOTSIZE,e=this.style===rl.STYLE.DOTSIZE||this.style===rl.STYLE.DOTCOLOR||this.style===rl.STYLE.SURFACE||this.style===rl.STYLE.BARCOLOR,n=Math.max(.25*this.frame.clientHeight,100),r=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=r+n,u=this._getContext();if(u.lineWidth=1,u.font="14px arial",!1===t){var l,h=n;for(l=0;l<h;l++){var c=1-(l-0)/(h-0),f=this._colormap(c,1);u.strokeStyle=f,u.beginPath(),u.moveTo(a,r+l),u.lineTo(o,r+l),u.stroke()}u.strokeStyle=this.axisColor,u.strokeRect(a,r,i,n)}else{var d;this.style===rl.STYLE.DOTSIZE?d=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,rl.STYLE.BARSIZE),u.strokeStyle=this.axisColor,u.fillStyle=su(this.dataColor),u.beginPath(),u.moveTo(a,r),u.lineTo(o,r),u.lineTo(a+d,s),u.lineTo(a,s),u.closePath(),su(u).call(u),u.stroke()}var p,v,m=e?this.valueRange.min:this.zRange.min,y=e?this.valueRange.max:this.zRange.max,g=new _u(m,y,(y-m)/5,!0);for(g.start(!0);!g.end();)l=s-(g.getCurrent()-m)/(y-m)*n,p=new vu(a-5,l),v=new vu(a,l),this._line(u,p,v),u.textAlign="right",u.textBaseline="middle",u.fillStyle=this.axisColor,u.fillText(g.getCurrent(),a-10,l),g.next();u.textAlign="right",u.textBaseline="top";var _=this.legendLabel;u.fillText(_,o,s+this.margin)}},rl.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=si(this.frame);if(e.innerHTML="",t){var n=new mu(e,{visible:this.showAnimationControls});e.slider=n,e.style.padding="10px",n.setValues(da(t)),n.setPlayInterval(this.animationInterval);var r=this;n.setOnChangeCallback((function(){var t=r.dataGroup.dataFilter,e=n.getIndex();t.selectValue(e),r.dataPoints=t._getDataPoints(),r.redraw()}))}else e.slider=void 0},rl.prototype._redrawSlider=function(){void 0!==si(this.frame).slider&&si(this.frame).slider.redraw()},rl.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var n=this.margin,r=this.margin;e.fillText(t,n,r)}},rl.prototype._line=function(t,e,n,r){void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(n.x,n.y),t.stroke()},rl.prototype.drawAxisLabelX=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},rl.prototype.drawAxisLabelY=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},rl.prototype.drawAxisLabelZ=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},rl.prototype.drawAxisLabelXRotate=function(t,e,n,r,i){var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,0,0),t.restore()):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},rl.prototype.drawAxisLabelYRotate=function(t,e,n,r,i){var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,0,0),t.restore()):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},rl.prototype.drawAxisLabelZRotate=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},rl.prototype._line3d=function(t,e,n,r){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(n);this._line(t,i,o,r)},rl.prototype._redrawAxis=function(){var t,e,n,r,i,o,a,s,u,l,h=this._getContext();h.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var c,f,d,p=.025/this.scale.x,v=.025/this.scale.y,m=5/this.camera.getArmLength(),y=this.camera.getArmRotation().horizontal,g=new vu(Math.cos(y),Math.sin(y)),_=this.xRange,w=this.yRange,b=this.zRange;for(h.lineWidth=1,r=void 0===this.defaultXStep,(n=new _u(_.min,_.max,this.xStep,r)).start(!0);!n.end();){var x=n.getCurrent();if(this.showGrid?(t=new pu(x,w.min,b.min),e=new pu(x,w.max,b.min),this._line3d(h,t,e,this.gridColor)):this.showXAxis&&(t=new pu(x,w.min,b.min),e=new pu(x,w.min+p,b.min),this._line3d(h,t,e,this.axisColor),t=new pu(x,w.max,b.min),e=new pu(x,w.max-p,b.min),this._line3d(h,t,e,this.axisColor)),this.showXAxis){a=g.x>0?w.min:w.max,c=new pu(x,a,b.min);var S="  "+this.xValueLabel(x)+"  ";this._drawAxisLabelX.call(this,h,c,S,y,m)}n.next()}for(h.lineWidth=1,r=void 0===this.defaultYStep,(n=new _u(w.min,w.max,this.yStep,r)).start(!0);!n.end();){var k=n.getCurrent();if(this.showGrid?(t=new pu(_.min,k,b.min),e=new pu(_.max,k,b.min),this._line3d(h,t,e,this.gridColor)):this.showYAxis&&(t=new pu(_.min,k,b.min),e=new pu(_.min+v,k,b.min),this._line3d(h,t,e,this.axisColor),t=new pu(_.max,k,b.min),e=new pu(_.max-v,k,b.min),this._line3d(h,t,e,this.axisColor)),this.showYAxis){o=g.y>0?_.min:_.max,c=new pu(o,k,b.min);var D="  "+this.yValueLabel(k)+"  ";this._drawAxisLabelY.call(this,h,c,D,y,m)}n.next()}if(this.showZAxis){for(h.lineWidth=1,r=void 0===this.defaultZStep,(n=new _u(b.min,b.max,this.zStep,r)).start(!0),o=g.x>0?_.min:_.max,a=g.y<0?w.min:w.max;!n.end();){var T=n.getCurrent(),O=new pu(o,a,T),M=this._convert3Dto2D(O);e=new vu(M.x-m,M.y),this._line(h,M,e,this.axisColor);var E=this.zValueLabel(T)+" ";this._drawAxisLabelZ.call(this,h,O,E,5),n.next()}h.lineWidth=1,t=new pu(o,a,b.min),e=new pu(o,a,b.max),this._line3d(h,t,e,this.axisColor)}this.showXAxis&&(h.lineWidth=1,f=new pu(_.min,w.min,b.min),d=new pu(_.max,w.min,b.min),this._line3d(h,f,d,this.axisColor),f=new pu(_.min,w.max,b.min),d=new pu(_.max,w.max,b.min),this._line3d(h,f,d,this.axisColor));this.showYAxis&&(h.lineWidth=1,t=new pu(_.min,w.min,b.min),e=new pu(_.min,w.max,b.min),this._line3d(h,t,e,this.axisColor),t=new pu(_.max,w.min,b.min),e=new pu(_.max,w.max,b.min),this._line3d(h,t,e,this.axisColor));var C=this.xLabel;C.length>0&&this.showXAxis&&(l=.1/this.scale.y,o=(_.max+3*_.min)/4,a=g.x>0?w.min-l:w.max+l,i=new pu(o,a,b.min),this.drawAxisLabelX(h,i,C,y));var A=this.yLabel;A.length>0&&this.showYAxis&&(u=.1/this.scale.x,o=g.y>0?_.min-u:_.max+u,a=(w.max+3*w.min)/4,i=new pu(o,a,b.min),this.drawAxisLabelY(h,i,A,y));var P=this.zLabel;P.length>0&&this.showZAxis&&(30,o=g.x>0?_.min:_.max,a=g.y<0?w.min:w.max,s=(b.max+3*b.min)/4,i=new pu(o,a,s),this.drawAxisLabelZ(h,i,P,30))},rl.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},rl.prototype._redrawBar=function(t,e,n,r,i,o){var a,s=this,u=e.point,l=this.zRange.min,h=[{point:new pu(u.x-n,u.y-r,u.z)},{point:new pu(u.x+n,u.y-r,u.z)},{point:new pu(u.x+n,u.y+r,u.z)},{point:new pu(u.x-n,u.y+r,u.z)}],c=[{point:new pu(u.x-n,u.y-r,l)},{point:new pu(u.x+n,u.y-r,l)},{point:new pu(u.x+n,u.y+r,l)},{point:new pu(u.x-n,u.y+r,l)}];Wr(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)})),Wr(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:h,center:pu.avg(c[0].point,c[2].point)},{corners:[h[0],h[1],c[1],c[0]],center:pu.avg(c[1].point,c[0].point)},{corners:[h[1],h[2],c[2],c[1]],center:pu.avg(c[2].point,c[1].point)},{corners:[h[2],h[3],c[3],c[2]],center:pu.avg(c[3].point,c[2].point)},{corners:[h[3],h[0],c[0],c[3]],center:pu.avg(c[0].point,c[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}ja(f).call(f,(function(t,e){var n=e.dist-t.dist;return n||(t.corners===h?1:e.corners===h?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},rl.prototype._polygon=function(t,e,n,r){if(!(e.length<2)){void 0!==n&&(t.fillStyle=n),void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),su(t).call(t),t.stroke()}},rl.prototype._drawCircle=function(t,e,n,r,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=r,t.fillStyle=n,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),su(t).call(t),t.stroke()},rl.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},rl.prototype._getColorsColor=function(t){var e,n,r;if(t&&t.point&&t.point.data&&t.point.data.style&&(r=t.point.data.style),r&&"object"===Qi(r)&&su(r)&&r.stroke)return{fill:su(r),border:r.stroke};if("string"==typeof t.point.value)e=t.point.value,n=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),n=this._colormap(i,.8)}return{fill:e,border:n}},rl.prototype._getColorsSize=function(){return{fill:su(this.dataColor),border:this.dataColor.stroke}},rl.prototype._colormap=function(t){var e,n,r,i,o,a,s,u,l,h=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,c=this.colormap;if(Ui(c)){var f=c.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),v=t*f-d,m=c[d],y=c[p];e=m.r+v*(y.r-m.r),n=m.g+v*(y.g-m.g),r=m.b+v*(y.b-m.b)}else if("function"==typeof c){var g=c(t);e=g.r,n=g.g,r=g.b,i=g.a}else{var _=240*(1-t),w=Yo(_/360,1,1);e=w.r,n=w.g,r=w.b}return"number"!=typeof i||iu(i)?hi(o=hi(a="RGB(".concat(Math.round(e*h),", ")).call(a,Math.round(n*h),", ")).call(o,Math.round(r*h),")"):hi(s=hi(u=hi(l="RGBA(".concat(Math.round(e*h),", ")).call(l,Math.round(n*h),", ")).call(u,Math.round(r*h),", ")).call(s,i,")")},rl.prototype._calcRadius=function(t,e){var n;return void 0===e&&(e=this._dotSize()),(n=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(n=0),n},rl.prototype._redrawBarGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,n,r,su(i),i.border)},rl.prototype._redrawBarColorGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,n,r,su(i),i.border)},rl.prototype._redrawBarSizeGraphPoint=function(t,e){var n=(e.point.value-this.valueRange.min)/this.valueRange.range(),r=this.xBarWidth/2*(.8*n+.2),i=this.yBarWidth/2*(.8*n+.2),o=this._getColorsSize();this._redrawBar(t,e,r,i,su(o),o.border)},rl.prototype._redrawDotGraphPoint=function(t,e){var n=this._getColorsRegular(e);this._drawCircle(t,e,su(n),n.border)},rl.prototype._redrawDotLineGraphPoint=function(t,e){var n=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,n,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},rl.prototype._redrawDotColorGraphPoint=function(t,e){var n=this._getColorsColor(e);this._drawCircle(t,e,su(n),n.border)},rl.prototype._redrawDotSizeGraphPoint=function(t,e){var n=this._dotSize(),r=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=n*this.dotSizeMinFraction,o=i+(n*this.dotSizeMaxFraction-i)*r,a=this._getColorsSize();this._drawCircle(t,e,su(a),a.border,o)},rl.prototype._redrawSurfaceGraphPoint=function(t,e){var n=e.pointRight,r=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==n&&void 0!==r&&void 0!==i){var o,a,s,u=!0;if(this.showGrayBottom||this.showShadow){var l=pu.subtract(i.trans,e.trans),h=pu.subtract(r.trans,n.trans),c=pu.crossProduct(l,h);if(this.showPerspective){var f=pu.avg(pu.avg(e.trans,i.trans),pu.avg(n.trans,r.trans));s=-pu.dotProduct(c.normalize(),f.normalize())}else s=c.z/c.length();u=s>0}if(u||!this.showGrayBottom){var d=((e.point.value+n.point.value+r.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,n,i,r];this._polygon(t,v,o,a)}},rl.prototype._drawGridLine=function(t,e,n){if(void 0!==e&&void 0!==n){var r=((e.point.value+n.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(r,1),this._line(t,e.screen,n.screen)}},rl.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},rl.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},rl.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var n=this.dataPoints[t];this._pointDrawingMethod.call(this,e,n)}},rl.prototype._storeMousePosition=function(t){this.startMouseX=il(t),this.startMouseY=ol(t),this._startCameraOffset=this.camera.getOffset()},rl.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},To(document,"mousemove",e.onmousemove),To(document,"mouseup",e.onmouseup),Mo(t)}},rl.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=cu(il(t))-this.startMouseX,n=cu(ol(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var r=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/r*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+n/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,u=this.startArmRotation.vertical+n/200,l=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<l&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<l&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(u))<l&&(u=Math.round(u/Math.PI)*Math.PI),Math.abs(Math.cos(u))<l&&(u=(Math.round(u/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,u)}this.redraw();var h=this.getCameraPosition();this.emit("cameraPositionChange",h),Mo(t)},rl.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,Oo(document,"mousemove",this.onmousemove),Oo(document,"mouseup",this.onmouseup),Mo(t)},rl.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),n=il(t)-e.left,r=ol(t)-e.top,i=this._dataPointFromXY(n,r);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}Mo(t)}},rl.prototype._onTooltip=function(t){var e=this.tooltipDelay,n=this.frame.getBoundingClientRect(),r=il(t)-n.left,i=ol(t)-n.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(r,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=vs((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(r,i);t&&a._showTooltip(t)}),e)}},rl.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},To(document,"touchmove",e.ontouchmove),To(document,"touchend",e.ontouchend),this._onMouseDown(t)},rl.prototype._onTouchMove=function(t){this._onMouseMove(t)},rl.prototype._onTouchEnd=function(t){this.touchDown=!1,Oo(document,"touchmove",this.ontouchmove),Oo(document,"touchend",this.ontouchend),this._onMouseUp(t)},rl.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var n=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(n),this.redraw(),this._hideTooltip()}var r=this.getCameraPosition();this.emit("cameraPositionChange",r),Mo(t)}},rl.prototype._insideTriangle=function(t,e){var n=e[0],r=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((r.x-n.x)*(t.y-n.y)-(r.y-n.y)*(t.x-n.x)),s=o((i.x-r.x)*(t.y-r.y)-(i.y-r.y)*(t.x-r.x)),u=o((n.x-i.x)*(t.y-i.y)-(n.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=u&&s!=u||0!=a&&0!=u&&a!=u)},rl.prototype._dataPointFromXY=function(t,e){var n,r=null,i=null,o=null,a=new vu(t,e);if(this.style===rl.STYLE.BAR||this.style===rl.STYLE.BARCOLOR||this.style===rl.STYLE.BARSIZE)for(n=this.dataPoints.length-1;n>=0;n--){var s=(r=this.dataPoints[n]).surfaces;if(s)for(var u=s.length-1;u>=0;u--){var l=s[u].corners,h=[l[0].screen,l[1].screen,l[2].screen],c=[l[2].screen,l[3].screen,l[0].screen];if(this._insideTriangle(a,h)||this._insideTriangle(a,c))return r}}else for(n=0;n<this.dataPoints.length;n++){var f=(r=this.dataPoints[n]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),v=Math.sqrt(d*d+p*p);(null===o||v<o)&&v<100&&(o=v,i=r)}}return i},rl.prototype.hasBars=function(t){return t==rl.STYLE.BAR||t==rl.STYLE.BARCOLOR||t==rl.STYLE.BARSIZE},rl.prototype._showTooltip=function(t){var e,n,r;this.tooltip?(e=this.tooltip.dom.content,n=this.tooltip.dom.line,r=this.tooltip.dom.dot):(e=document.createElement("div"),Xi(e.style,{},this.tooltipStyle.content),e.style.position="absolute",n=document.createElement("div"),Xi(n.style,{},this.tooltipStyle.line),n.style.position="absolute",r=document.createElement("div"),Xi(r.style,{},this.tooltipStyle.dot),r.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:n,dot:r}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(n),this.frame.appendChild(r);var i=e.offsetWidth,o=e.offsetHeight,a=n.offsetHeight,s=r.offsetWidth,u=r.offsetHeight,l=t.screen.x-i/2;l=Math.min(Math.max(l,10),this.frame.clientWidth-10-i),n.style.left=t.screen.x+"px",n.style.top=t.screen.y-a+"px",e.style.left=l+"px",e.style.top=t.screen.y-a-o+"px",r.style.left=t.screen.x-s/2+"px",r.style.top=t.screen.y-u/2+"px"},rl.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},rl.prototype.setCameraPosition=function(t){Fu(t,this),this.redraw()},rl.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};var al,sl=Object.freeze({__proto__:null,default:rl}),ul="undefined"!=typeof window&&window.moment||Ws,ll=Object.freeze({__proto__:null,default:ul}),hl=c((function(t,e){var n;t.exports=(n=null,function t(e,r){var i=r||{preventDefault:!1};if(e.Manager){var o=e,a=function(e,n){var r=Object.create(i);return n&&o.assign(r,n),t(new o(e,r),r)};return o.assign(a,o),a.Manager=function(e,n){var r=Object.create(i);return n&&o.assign(r,n),t(new o.Manager(e,r),r)},a}var s=Object.create(e),u=e.element;function l(t){return t.match(/[^ ]+/g)}function h(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var r=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof r&&(t.srcEvent.stopPropagation=function(){r(),t.stopPropagation()}),t.firstTarget=n;for(var i=n;i&&!e;){var o=i.hammer;if(o)for(var a,s=0;s<o.length;s++)if(a=o[s]._handlers[t.type])for(var u=0;u<a.length&&!e;u++)a[u](t);i=i.parentNode}}return u.hammer||(u.hammer=[]),u.hammer.push(s),e.on("hammer.input",(function(t){!0!==i.preventDefault&&i.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(n=t.target)})),s._handlers={},s.on=function(t,n){return l(t).forEach((function(t){var r=s._handlers[t];r||(s._handlers[t]=r=[],e.on(t,h)),r.push(n)})),s},s.off=function(t,n){return l(t).forEach((function(t){var r=s._handlers[t];r&&((r=n?r.filter((function(t){return t!==n})):[]).length>0?s._handlers[t]=r:(e.off(t,h),delete s._handlers[t]))})),s},s.emit=function(t,r){n=r.target,e.emit(t,r)},s.destroy=function(){var t=e.element.hammer,n=t.indexOf(s);-1!==n&&t.splice(n,1),t.length||delete e.element.hammer,s._handlers={},e.destroy()},s})})),cl=c((function(t){!function(e,n,r,i){var o,a=["","webkit","Moz","MS","ms","o"],s=n.createElement("div"),u=Math.round,l=Math.abs,h=Date.now;function c(t,e,n){return setTimeout(g(t,n),e)}function f(t,e,n){return!!Array.isArray(t)&&(d(t,n[e],n),!0)}function d(t,e,n){var r;if(t)if(t.forEach)t.forEach(e,n);else if(void 0!==t.length)for(r=0;r<t.length;)e.call(n,t[r],r,t),r++;else for(r in t)t.hasOwnProperty(r)&&e.call(n,t[r],r,t)}function p(t,n,r){var i="DEPRECATED METHOD: "+n+"\n"+r+" AT \n";return function(){var n=new Error("get-stack-trace"),r=n&&n.stack?n.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=e.console&&(e.console.warn||e.console.log);return o&&o.call(e.console,i,r),t.apply(this,arguments)}}o="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),n=1;n<arguments.length;n++){var r=arguments[n];if(null!=r)for(var i in r)r.hasOwnProperty(i)&&(e[i]=r[i])}return e}:Object.assign;var v=p((function(t,e,n){for(var r=Object.keys(e),i=0;i<r.length;)(!n||n&&void 0===t[r[i]])&&(t[r[i]]=e[r[i]]),i++;return t}),"extend","Use `assign`."),m=p((function(t,e){return v(t,e,!0)}),"merge","Use `assign`.");function y(t,e,n){var r,i=e.prototype;(r=t.prototype=Object.create(i)).constructor=t,r._super=i,n&&o(r,n)}function g(t,e){return function(){return t.apply(e,arguments)}}function _(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function w(t,e){return void 0===t?e:t}function b(t,e,n){d(D(e),(function(e){t.addEventListener(e,n,!1)}))}function x(t,e,n){d(D(e),(function(e){t.removeEventListener(e,n,!1)}))}function S(t,e){for(;t;){if(t==e)return!0;t=t.parentNode}return!1}function k(t,e){return t.indexOf(e)>-1}function D(t){return t.trim().split(/\s+/g)}function T(t,e,n){if(t.indexOf&&!n)return t.indexOf(e);for(var r=0;r<t.length;){if(n&&t[r][n]==e||!n&&t[r]===e)return r;r++}return-1}function O(t){return Array.prototype.slice.call(t,0)}function M(t,e,n){for(var r=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];T(i,a)<0&&r.push(t[o]),i[o]=a,o++}return n&&(r=e?r.sort((function(t,n){return t[e]>n[e]})):r.sort()),r}function E(t,e){for(var n,r,i=e[0].toUpperCase()+e.slice(1),o=0;o<a.length;){if((r=(n=a[o])?n+i:e)in t)return r;o++}}var C=1;function A(t){var n=t.ownerDocument||t;return n.defaultView||n.parentWindow||e}var P="ontouchstart"in e,L=void 0!==E(e,"PointerEvent"),R=P&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Y=["x","y"],N=["clientX","clientY"];function I(t,e){var n=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){_(t.options.enable,[t])&&n.handler(e)},this.init()}function j(t,e,n){var r=n.pointers.length,i=n.changedPointers.length,o=1&e&&r-i==0,a=12&e&&r-i==0;n.isFirst=!!o,n.isFinal=!!a,o&&(t.session={}),n.eventType=e,function(t,e){var n=t.session,r=e.pointers,i=r.length;n.firstInput||(n.firstInput=z(e));i>1&&!n.firstMultiple?n.firstMultiple=z(e):1===i&&(n.firstMultiple=!1);var o=n.firstInput,a=n.firstMultiple,s=a?a.center:o.center,u=e.center=W(r);e.timeStamp=h(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=U(s,u),e.distance=V(s,u),function(t,e){var n=e.center,r=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};1!==e.eventType&&4!==o.eventType||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},r=t.offsetDelta={x:n.x,y:n.y});e.deltaX=i.x+(n.x-r.x),e.deltaY=i.y+(n.y-r.y)}(n,e),e.offsetDirection=G(e.deltaX,e.deltaY);var c=F(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=c.x,e.overallVelocityY=c.y,e.overallVelocity=l(c.x)>l(c.y)?c.x:c.y,e.scale=a?(f=a.pointers,d=r,V(d[0],d[1],N)/V(f[0],f[1],N)):1,e.rotation=a?function(t,e){return U(e[1],e[0],N)+U(t[1],t[0],N)}(a.pointers,r):0,e.maxPointers=n.prevInput?e.pointers.length>n.prevInput.maxPointers?e.pointers.length:n.prevInput.maxPointers:e.pointers.length,function(t,e){var n,r,i,o,a=t.lastInterval||e,s=e.timeStamp-a.timeStamp;if(8!=e.eventType&&(s>25||void 0===a.velocity)){var u=e.deltaX-a.deltaX,h=e.deltaY-a.deltaY,c=F(s,u,h);r=c.x,i=c.y,n=l(c.x)>l(c.y)?c.x:c.y,o=G(u,h),t.lastInterval=e}else n=a.velocity,r=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=n,e.velocityX=r,e.velocityY=i,e.direction=o}(n,e);var f,d;var p=t.element;S(e.srcEvent.target,p)&&(p=e.srcEvent.target);e.target=p}(t,n),t.emit("hammer.input",n),t.recognize(n),t.session.prevInput=n}function z(t){for(var e=[],n=0;n<t.pointers.length;)e[n]={clientX:u(t.pointers[n].clientX),clientY:u(t.pointers[n].clientY)},n++;return{timeStamp:h(),pointers:e,center:W(e),deltaX:t.deltaX,deltaY:t.deltaY}}function W(t){var e=t.length;if(1===e)return{x:u(t[0].clientX),y:u(t[0].clientY)};for(var n=0,r=0,i=0;i<e;)n+=t[i].clientX,r+=t[i].clientY,i++;return{x:u(n/e),y:u(r/e)}}function F(t,e,n){return{x:e/t||0,y:n/t||0}}function G(t,e){return t===e?1:l(t)>=l(e)?t<0?2:4:e<0?8:16}function V(t,e,n){n||(n=Y);var r=e[n[0]]-t[n[0]],i=e[n[1]]-t[n[1]];return Math.sqrt(r*r+i*i)}function U(t,e,n){n||(n=Y);var r=e[n[0]]-t[n[0]],i=e[n[1]]-t[n[1]];return 180*Math.atan2(i,r)/Math.PI}I.prototype={handler:function(){},init:function(){this.evEl&&b(this.element,this.evEl,this.domHandler),this.evTarget&&b(this.target,this.evTarget,this.domHandler),this.evWin&&b(A(this.element),this.evWin,this.domHandler)},destroy:function(){this.evEl&&x(this.element,this.evEl,this.domHandler),this.evTarget&&x(this.target,this.evTarget,this.domHandler),this.evWin&&x(A(this.element),this.evWin,this.domHandler)}};var B={mousedown:1,mousemove:2,mouseup:4};function H(){this.evEl="mousedown",this.evWin="mousemove mouseup",this.pressed=!1,I.apply(this,arguments)}y(H,I,{handler:function(t){var e=B[t.type];1&e&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=4),this.pressed&&(4&e&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:"mouse",srcEvent:t}))}});var Z={pointerdown:1,pointermove:2,pointerup:4,pointercancel:8,pointerout:8},X={2:"touch",3:"pen",4:"mouse",5:"kinect"},q="pointerdown",$="pointermove pointerup pointercancel";function Q(){this.evEl=q,this.evWin=$,I.apply(this,arguments),this.store=this.manager.session.pointerEvents=[]}e.MSPointerEvent&&!e.PointerEvent&&(q="MSPointerDown",$="MSPointerMove MSPointerUp MSPointerCancel"),y(Q,I,{handler:function(t){var e=this.store,n=!1,r=t.type.toLowerCase().replace("ms",""),i=Z[r],o=X[t.pointerType]||t.pointerType,a="touch"==o,s=T(e,t.pointerId,"pointerId");1&i&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):12&i&&(n=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),n&&e.splice(s,1))}});var J={touchstart:1,touchmove:2,touchend:4,touchcancel:8};function K(){this.evTarget="touchstart",this.evWin="touchstart touchmove touchend touchcancel",this.started=!1,I.apply(this,arguments)}function tt(t,e){var n=O(t.touches),r=O(t.changedTouches);return 12&e&&(n=M(n.concat(r),"identifier",!0)),[n,r]}y(K,I,{handler:function(t){var e=J[t.type];if(1===e&&(this.started=!0),this.started){var n=tt.call(this,t,e);12&e&&n[0].length-n[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:n[0],changedPointers:n[1],pointerType:"touch",srcEvent:t})}}});var et={touchstart:1,touchmove:2,touchend:4,touchcancel:8};function nt(){this.evTarget="touchstart touchmove touchend touchcancel",this.targetIds={},I.apply(this,arguments)}function rt(t,e){var n=O(t.touches),r=this.targetIds;if(3&e&&1===n.length)return r[n[0].identifier]=!0,[n,n];var i,o,a=O(t.changedTouches),s=[],u=this.target;if(o=n.filter((function(t){return S(t.target,u)})),1===e)for(i=0;i<o.length;)r[o[i].identifier]=!0,i++;for(i=0;i<a.length;)r[a[i].identifier]&&s.push(a[i]),12&e&&delete r[a[i].identifier],i++;return s.length?[M(o.concat(s),"identifier",!0),s]:void 0}y(nt,I,{handler:function(t){var e=et[t.type],n=rt.call(this,t,e);n&&this.callback(this.manager,e,{pointers:n[0],changedPointers:n[1],pointerType:"touch",srcEvent:t})}});function it(){I.apply(this,arguments);var t=g(this.handler,this);this.touch=new nt(this.manager,t),this.mouse=new H(this.manager,t),this.primaryTouch=null,this.lastTouches=[]}function ot(t,e){1&t?(this.primaryTouch=e.changedPointers[0].identifier,at.call(this,e)):12&t&&at.call(this,e)}function at(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var n={x:e.clientX,y:e.clientY};this.lastTouches.push(n);var r=this.lastTouches;setTimeout((function(){var t=r.indexOf(n);t>-1&&r.splice(t,1)}),2500)}}function st(t){for(var e=t.srcEvent.clientX,n=t.srcEvent.clientY,r=0;r<this.lastTouches.length;r++){var i=this.lastTouches[r],o=Math.abs(e-i.x),a=Math.abs(n-i.y);if(o<=25&&a<=25)return!0}return!1}y(it,I,{handler:function(t,e,n){var r="touch"==n.pointerType,i="mouse"==n.pointerType;if(!(i&&n.sourceCapabilities&&n.sourceCapabilities.firesTouchEvents)){if(r)ot.call(this,e,n);else if(i&&st.call(this,n))return;this.callback(t,e,n)}},destroy:function(){this.touch.destroy(),this.mouse.destroy()}});var ut=E(s.style,"touchAction"),lt=void 0!==ut,ht=function(){if(!lt)return!1;var t={},n=e.CSS&&e.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){t[r]=!n||e.CSS.supports("touch-action",r)})),t}();function ct(t,e){this.manager=t,this.set(e)}ct.prototype={set:function(t){"compute"==t&&(t=this.compute()),lt&&this.manager.element.style&&ht[t]&&(this.manager.element.style[ut]=t),this.actions=t.toLowerCase().trim()},update:function(){this.set(this.manager.options.touchAction)},compute:function(){var t=[];return d(this.manager.recognizers,(function(e){_(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(k(t,"none"))return"none";var e=k(t,"pan-x"),n=k(t,"pan-y");if(e&&n)return"none";if(e||n)return e?"pan-x":"pan-y";if(k(t,"manipulation"))return"manipulation";return"auto"}(t.join(" "))},preventDefaults:function(t){var e=t.srcEvent,n=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var r=this.actions,i=k(r,"none")&&!ht.none,o=k(r,"pan-y")&&!ht["pan-y"],a=k(r,"pan-x")&&!ht["pan-x"];if(i){var s=1===t.pointers.length,u=t.distance<2,l=t.deltaTime<250;if(s&&u&&l)return}if(!a||!o)return i||o&&6&n||a&&24&n?this.preventSrc(e):void 0}},preventSrc:function(t){this.manager.session.prevented=!0,t.preventDefault()}};function ft(t){this.options=o({},this.defaults,t||{}),this.id=C++,this.manager=null,this.options.enable=w(this.options.enable,!0),this.state=1,this.simultaneous={},this.requireFail=[]}function dt(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}function pt(t){return 16==t?"down":8==t?"up":2==t?"left":4==t?"right":""}function vt(t,e){var n=e.manager;return n?n.get(t):t}function mt(){ft.apply(this,arguments)}function yt(){mt.apply(this,arguments),this.pX=null,this.pY=null}function gt(){mt.apply(this,arguments)}function _t(){ft.apply(this,arguments),this._timer=null,this._input=null}function wt(){mt.apply(this,arguments)}function bt(){mt.apply(this,arguments)}function xt(){ft.apply(this,arguments),this.pTime=!1,this.pCenter=!1,this._timer=null,this._input=null,this.count=0}function St(t,e){return(e=e||{}).recognizers=w(e.recognizers,St.defaults.preset),new kt(t,e)}ft.prototype={defaults:{},set:function(t){return o(this.options,t),this.manager&&this.manager.touchAction.update(),this},recognizeWith:function(t){if(f(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=vt(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},dropRecognizeWith:function(t){return f(t,"dropRecognizeWith",this)||(t=vt(t,this),delete this.simultaneous[t.id]),this},requireFailure:function(t){if(f(t,"requireFailure",this))return this;var e=this.requireFail;return-1===T(e,t=vt(t,this))&&(e.push(t),t.requireFailure(this)),this},dropRequireFailure:function(t){if(f(t,"dropRequireFailure",this))return this;t=vt(t,this);var e=T(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},hasRequireFailures:function(){return this.requireFail.length>0},canRecognizeWith:function(t){return!!this.simultaneous[t.id]},emit:function(t){var e=this,n=this.state;function r(n){e.manager.emit(n,t)}n<8&&r(e.options.event+dt(n)),r(e.options.event),t.additionalEvent&&r(t.additionalEvent),n>=8&&r(e.options.event+dt(n))},tryEmit:function(t){if(this.canEmit())return this.emit(t);this.state=32},canEmit:function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},recognize:function(t){var e=o({},t);if(!_(this.options.enable,[this,e]))return this.reset(),void(this.state=32);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},process:function(t){},getTouchAction:function(){},reset:function(){}},y(mt,ft,{defaults:{pointers:1},attrTest:function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},process:function(t){var e=this.state,n=t.eventType,r=6&e,i=this.attrTest(t);return r&&(8&n||!i)?16|e:r||i?4&n?8|e:2&e?4|e:2:32}}),y(yt,mt,{defaults:{event:"pan",threshold:10,pointers:1,direction:30},getTouchAction:function(){var t=this.options.direction,e=[];return 6&t&&e.push("pan-y"),24&t&&e.push("pan-x"),e},directionTest:function(t){var e=this.options,n=!0,r=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(6&e.direction?(i=0===o?1:o<0?2:4,n=o!=this.pX,r=Math.abs(t.deltaX)):(i=0===a?1:a<0?8:16,n=a!=this.pY,r=Math.abs(t.deltaY))),t.direction=i,n&&r>e.threshold&&i&e.direction},attrTest:function(t){return mt.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},emit:function(t){this.pX=t.deltaX,this.pY=t.deltaY;var e=pt(t.direction);e&&(t.additionalEvent=this.options.event+e),this._super.emit.call(this,t)}}),y(gt,mt,{defaults:{event:"pinch",threshold:0,pointers:2},getTouchAction:function(){return["none"]},attrTest:function(t){return this._super.attrTest.call(this,t)&&(Math.abs(t.scale-1)>this.options.threshold||2&this.state)},emit:function(t){if(1!==t.scale){var e=t.scale<1?"in":"out";t.additionalEvent=this.options.event+e}this._super.emit.call(this,t)}}),y(_t,ft,{defaults:{event:"press",pointers:1,time:251,threshold:9},getTouchAction:function(){return["auto"]},process:function(t){var e=this.options,n=t.pointers.length===e.pointers,r=t.distance<e.threshold,i=t.deltaTime>e.time;if(this._input=t,!r||!n||12&t.eventType&&!i)this.reset();else if(1&t.eventType)this.reset(),this._timer=c((function(){this.state=8,this.tryEmit()}),e.time,this);else if(4&t.eventType)return 8;return 32},reset:function(){clearTimeout(this._timer)},emit:function(t){8===this.state&&(t&&4&t.eventType?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=h(),this.manager.emit(this.options.event,this._input)))}}),y(wt,mt,{defaults:{event:"rotate",threshold:0,pointers:2},getTouchAction:function(){return["none"]},attrTest:function(t){return this._super.attrTest.call(this,t)&&(Math.abs(t.rotation)>this.options.threshold||2&this.state)}}),y(bt,mt,{defaults:{event:"swipe",threshold:10,velocity:.3,direction:30,pointers:1},getTouchAction:function(){return yt.prototype.getTouchAction.call(this)},attrTest:function(t){var e,n=this.options.direction;return 30&n?e=t.overallVelocity:6&n?e=t.overallVelocityX:24&n&&(e=t.overallVelocityY),this._super.attrTest.call(this,t)&&n&t.offsetDirection&&t.distance>this.options.threshold&&t.maxPointers==this.options.pointers&&l(e)>this.options.velocity&&4&t.eventType},emit:function(t){var e=pt(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)}}),y(xt,ft,{defaults:{event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},getTouchAction:function(){return["manipulation"]},process:function(t){var e=this.options,n=t.pointers.length===e.pointers,r=t.distance<e.threshold,i=t.deltaTime<e.time;if(this.reset(),1&t.eventType&&0===this.count)return this.failTimeout();if(r&&i&&n){if(4!=t.eventType)return this.failTimeout();var o=!this.pTime||t.timeStamp-this.pTime<e.interval,a=!this.pCenter||V(this.pCenter,t.center)<e.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&o?this.count+=1:this.count=1,this._input=t,0===this.count%e.taps)return this.hasRequireFailures()?(this._timer=c((function(){this.state=8,this.tryEmit()}),e.interval,this),2):8}return 32},failTimeout:function(){return this._timer=c((function(){this.state=32}),this.options.interval,this),32},reset:function(){clearTimeout(this._timer)},emit:function(){8==this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))}}),St.VERSION="2.0.7",St.defaults={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,preset:[[wt,{enable:!1}],[gt,{enable:!1},["rotate"]],[bt,{direction:6}],[yt,{direction:6},["swipe"]],[xt],[xt,{event:"doubletap",taps:2},["tap"]],[_t]],cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}};function kt(t,e){var n;this.options=o({},St.defaults,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((n=this).options.inputClass||(L?Q:R?nt:P?it:H))(n,j),this.touchAction=new ct(this,this.options.touchAction),Dt(this,!0),d(this.options.recognizers,(function(t){var e=this.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}function Dt(t,e){var n,r=t.element;r.style&&(d(t.options.cssProps,(function(i,o){n=E(r.style,o),e?(t.oldCssProps[n]=r.style[n],r.style[n]=i):r.style[n]=t.oldCssProps[n]||""})),e||(t.oldCssProps={}))}kt.prototype={set:function(t){return o(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},stop:function(t){this.session.stopped=t?2:1},recognize:function(t){var e=this.session;if(!e.stopped){var n;this.touchAction.preventDefaults(t);var r=this.recognizers,i=e.curRecognizer;(!i||i&&8&i.state)&&(i=e.curRecognizer=null);for(var o=0;o<r.length;)n=r[o],2===e.stopped||i&&n!=i&&!n.canRecognizeWith(i)?n.reset():n.recognize(t),!i&&14&n.state&&(i=e.curRecognizer=n),o++}},get:function(t){if(t instanceof ft)return t;for(var e=this.recognizers,n=0;n<e.length;n++)if(e[n].options.event==t)return e[n];return null},add:function(t){if(f(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},remove:function(t){if(f(t,"remove",this))return this;if(t=this.get(t)){var e=this.recognizers,n=T(e,t);-1!==n&&(e.splice(n,1),this.touchAction.update())}return this},on:function(t,e){if(void 0!==t&&void 0!==e){var n=this.handlers;return d(D(t),(function(t){n[t]=n[t]||[],n[t].push(e)})),this}},off:function(t,e){if(void 0!==t){var n=this.handlers;return d(D(t),(function(t){e?n[t]&&n[t].splice(T(n[t],e),1):delete n[t]})),this}},emit:function(t,e){this.options.domEvents&&function(t,e){var r=n.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var i=0;i<r.length;)r[i](e),i++}},destroy:function(){this.element&&Dt(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null}},o(St,{INPUT_START:1,INPUT_MOVE:2,INPUT_END:4,INPUT_CANCEL:8,STATE_POSSIBLE:1,STATE_BEGAN:2,STATE_CHANGED:4,STATE_ENDED:8,STATE_RECOGNIZED:8,STATE_CANCELLED:16,STATE_FAILED:32,DIRECTION_NONE:1,DIRECTION_LEFT:2,DIRECTION_RIGHT:4,DIRECTION_UP:8,DIRECTION_DOWN:16,DIRECTION_HORIZONTAL:6,DIRECTION_VERTICAL:24,DIRECTION_ALL:30,Manager:kt,Input:I,TouchAction:ct,TouchInput:nt,MouseInput:H,PointerEventInput:Q,TouchMouseInput:it,SingleTouchInput:K,Recognizer:ft,AttrRecognizer:mt,Tap:xt,Pan:yt,Swipe:bt,Pinch:gt,Rotate:wt,Press:_t,on:b,off:x,each:d,merge:m,extend:v,assign:o,inherit:y,bindFn:g,prefixed:E}),(void 0!==e?e:"undefined"!=typeof self?self:{}).Hammer=St,t.exports?t.exports=St:e.Hammer=St}(window,document)}));"undefined"!=typeof window?al=hl(window.Hammer||cl,{preventDefault:"mouse"}):al=function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(e){return{set:t}}};var t};var fl=al,dl=Object.freeze({__proto__:null,default:fl}),pl=c((function(t,e){t.exports=function(t){var e,n=t&&t.preventDefault||!1,r=t&&t.container||window,i={},o={keydown:{},keyup:{}},a={};for(e=97;e<=122;e++)a[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)a[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)a[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)a["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)a["num"+e]={code:96+e,shift:!1};a["num*"]={code:106,shift:!1},a["num+"]={code:107,shift:!1},a["num-"]={code:109,shift:!1},a["num/"]={code:111,shift:!1},a["num."]={code:110,shift:!1},a.left={code:37,shift:!1},a.up={code:38,shift:!1},a.right={code:39,shift:!1},a.down={code:40,shift:!1},a.space={code:32,shift:!1},a.enter={code:13,shift:!1},a.shift={code:16,shift:void 0},a.esc={code:27,shift:!1},a.backspace={code:8,shift:!1},a.tab={code:9,shift:!1},a.ctrl={code:17,shift:!1},a.alt={code:18,shift:!1},a.delete={code:46,shift:!1},a.pageup={code:33,shift:!1},a.pagedown={code:34,shift:!1},a["="]={code:187,shift:!1},a["-"]={code:189,shift:!1},a["]"]={code:221,shift:!1},a["["]={code:219,shift:!1};var s=function(t){l(t,"keydown")},u=function(t){l(t,"keyup")},l=function(t,e){if(void 0!==o[e][t.keyCode]){for(var r=o[e][t.keyCode],i=0;i<r.length;i++)(void 0===r[i].shift||1==r[i].shift&&1==t.shiftKey||0==r[i].shift&&0==t.shiftKey)&&r[i].fn(t);1==n&&t.preventDefault()}};return i.bind=function(t,e,n){if(void 0===n&&(n="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);void 0===o[n][a[t].code]&&(o[n][a[t].code]=[]),o[n][a[t].code].push({fn:e,shift:a[t].shift})},i.bindAll=function(t,e){for(var n in void 0===e&&(e="keydown"),a)a.hasOwnProperty(n)&&i.bind(n,t,e)},i.getKey=function(t){for(var e in a)if(a.hasOwnProperty(e)){if(1==t.shiftKey&&1==a[e].shift&&t.keyCode==a[e].code)return e;if(0==t.shiftKey&&0==a[e].shift&&t.keyCode==a[e].code)return e;if(t.keyCode==a[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},i.unbind=function(t,e,n){if(void 0===n&&(n="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);if(void 0!==e){var r=[],i=o[n][a[t].code];if(void 0!==i)for(var s=0;s<i.length;s++)i[s].fn==e&&i[s].shift==a[t].shift||r.push(o[n][a[t].code][s]);o[n][a[t].code]=r}else o[n][a[t].code]=[]},i.reset=function(){o={keydown:{},keyup:{}}},i.destroy=function(){o={keydown:{},keyup:{}},r.removeEventListener("keydown",s,!0),r.removeEventListener("keyup",u,!0)},r.addEventListener("keydown",s,!0),r.addEventListener("keyup",u,!0),i}})),vl=f(Fo),ml=f(ru),yl=f(sl),gl=f(Mu),_l=f(el),wl=f(yu),bl=f(ll),xl=f(dl),Sl=vl,kl=Go,Dl=ml.DataSet,Tl=ml.DataView,Ol=ml.Queue,Ml=yl,El={Camera:gl,Filter:_l,Point2d:vu,Point3d:pu,Slider:wl,StepNumber:_u},Cl=bl,Al=xl,Pl=pl,Ll={util:Sl,DOMutil:kl,DataSet:Dl,DataView:Tl,Queue:Ol,Graph3d:Ml,graph3d:El,moment:Cl,Hammer:Al,keycharm:Pl};t.DOMutil=kl,t.DataSet=Dl,t.DataView=Tl,t.Graph3d=Ml,t.Hammer=Al,t.Queue=Ol,t.default=Ll,t.graph3d=El,t.keycharm=Pl,t.moment=Cl,t.util=Sl,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
