/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 5.9.6
 * @date    2020-05-21T07:27:07.768Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("vis-data/peer/umd/vis-data.js")):"function"==typeof define&&define.amd?define(["exports","vis-data/peer/umd/vis-data.js"],e):e((t=t||self).vis=t.vis||{},t.vis)}(this,(function(t,e){var i="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e,i){return t(i={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&i.path)}},i.exports),i.exports}function n(t){return t&&t.default||t}var o=function(t){return t&&t.Math==Math&&t},a=o("object"==typeof globalThis&&globalThis)||o("object"==typeof window&&window)||o("object"==typeof self&&self)||o("object"==typeof i&&i)||Function("return this")(),s=function(t){try{return!!t()}catch(t){return!0}},l=!s((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),h={}.propertyIsEnumerable,c=Object.getOwnPropertyDescriptor,u={f:c&&!h.call({1:2},1)?function(t){var e=c(this,t);return!!e&&e.enumerable}:h},f=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},d={}.toString,p=function(t){return d.call(t).slice(8,-1)},v="".split,y=s((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==p(t)?v.call(t,""):Object(t)}:Object,m=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},g=function(t){return y(m(t))},b=function(t){return"object"==typeof t?null!==t:"function"==typeof t},x=function(t,e){if(!b(t))return t;var i,r;if(e&&"function"==typeof(i=t.toString)&&!b(r=i.call(t)))return r;if("function"==typeof(i=t.valueOf)&&!b(r=i.call(t)))return r;if(!e&&"function"==typeof(i=t.toString)&&!b(r=i.call(t)))return r;throw TypeError("Can't convert object to primitive value")},w={}.hasOwnProperty,_=function(t,e){return w.call(t,e)},S=a.document,L=b(S)&&b(S.createElement),C=function(t){return L?S.createElement(t):{}},A=!l&&!s((function(){return 7!=Object.defineProperty(C("div"),"a",{get:function(){return 7}}).a})),T=Object.getOwnPropertyDescriptor,O={f:l?T:function(t,e){if(t=g(t),e=x(e,!0),A)try{return T(t,e)}catch(t){}if(_(t,e))return f(!u.f.call(t,e),t[e])}},M=/#|\.prototype\./,P=function(t,e){var i=E[R(t)];return i==k||i!=D&&("function"==typeof e?s(e):!!e)},R=P.normalize=function(t){return String(t).replace(M,".").toLowerCase()},E=P.data={},D=P.NATIVE="N",k=P.POLYFILL="P",z=P,I={},j=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},B=function(t,e,i){if(j(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,r){return t.call(e,i,r)};case 3:return function(i,r,n){return t.call(e,i,r,n)}}return function(){return t.apply(e,arguments)}},F=function(t){if(!b(t))throw TypeError(String(t)+" is not an object");return t},W=Object.defineProperty,G={f:l?W:function(t,e,i){if(F(t),e=x(e,!0),F(i),A)try{return W(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},N=l?function(t,e,i){return G.f(t,e,f(1,i))}:function(t,e,i){return t[e]=i,t},Y=O.f,V=function(t){var e=function(e,i,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,i)}return new t(e,i,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},X=function(t,e){var i,r,n,o,s,l,h,c,u=t.target,f=t.global,d=t.stat,p=t.proto,v=f?a:d?a[u]:(a[u]||{}).prototype,y=f?I:I[u]||(I[u]={}),m=y.prototype;for(n in e)i=!z(f?n:u+(d?".":"#")+n,t.forced)&&v&&_(v,n),s=y[n],i&&(l=t.noTargetGet?(c=Y(v,n))&&c.value:v[n]),o=i&&l?l:e[n],i&&typeof s==typeof o||(h=t.bind&&i?B(o,a):t.wrap&&i?V(o):p&&"function"==typeof o?B(Function.call,o):o,(t.sham||o&&o.sham||s&&s.sham)&&N(h,"sham",!0),y[n]=h,p&&(_(I,r=u+"Prototype")||N(I,r,{}),I[r][n]=o,t.real&&m&&!m[n]&&N(m,n,o)))},Z=Math.ceil,U=Math.floor,H=function(t){return isNaN(t=+t)?0:(t>0?U:Z)(t)},$=Math.min,J=function(t){return t>0?$(H(t),9007199254740991):0},q=Math.max,K=Math.min,Q=function(t,e){var i=H(t);return i<0?q(i+e,0):K(i,e)},tt=function(t){return function(e,i,r){var n,o=g(e),a=J(o.length),s=Q(r,a);if(t&&i!=i){for(;a>s;)if((n=o[s++])!=n)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===i)return t||s||0;return!t&&-1}},et={includes:tt(!0),indexOf:tt(!1)},it={},rt=et.indexOf,nt=function(t,e){var i,r=g(t),n=0,o=[];for(i in r)!_(it,i)&&_(r,i)&&o.push(i);for(;e.length>n;)_(r,i=e[n++])&&(~rt(o,i)||o.push(i));return o},ot=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],at=Object.keys||function(t){return nt(t,ot)},st={f:Object.getOwnPropertySymbols},lt=function(t){return Object(m(t))},ht=Object.assign,ct=Object.defineProperty,ut=!ht||s((function(){if(l&&1!==ht({b:1},ht(ct({},"a",{enumerable:!0,get:function(){ct(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol();return t[i]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=ht({},t)[i]||"abcdefghijklmnopqrst"!=at(ht({},e)).join("")}))?function(t,e){for(var i=lt(t),r=arguments.length,n=1,o=st.f,a=u.f;r>n;)for(var s,h=y(arguments[n++]),c=o?at(h).concat(o(h)):at(h),f=c.length,d=0;f>d;)s=c[d++],l&&!a.call(h,s)||(i[s]=h[s]);return i}:ht;X({target:"Object",stat:!0,forced:Object.assign!==ut},{assign:ut});var ft=I.Object.assign,dt=function(t){return"function"==typeof t?t:void 0},pt=function(t,e){return arguments.length<2?dt(I[t])||dt(a[t]):I[t]&&I[t][e]||a[t]&&a[t][e]},vt=pt("navigator","userAgent")||"",yt=[].slice,mt=/MSIE .\./.test(vt),gt=function(t){return function(e,i){var r=arguments.length>2,n=r?yt.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,n)}:e,i)}};X({global:!0,bind:!0,forced:mt},{setTimeout:gt(a.setTimeout),setInterval:gt(a.setInterval)});var bt,xt,wt=I.setTimeout,_t=Array.isArray||function(t){return"Array"==p(t)},St=function(t,e,i){var r=x(e);r in t?G.f(t,r,f(0,i)):t[r]=i},Lt=a["__core-js_shared__"]||function(t,e){try{N(a,t,e)}catch(i){a[t]=e}return e}("__core-js_shared__",{}),Ct=r((function(t){(t.exports=function(t,e){return Lt[t]||(Lt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),At=0,Tt=Math.random(),Ot=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++At+Tt).toString(36)},Mt=!!Object.getOwnPropertySymbols&&!s((function(){return!String(Symbol())})),Pt=Mt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Rt=Ct("wks"),Et=a.Symbol,Dt=Pt?Et:Et&&Et.withoutSetter||Ot,kt=function(t){return _(Rt,t)||(Mt&&_(Et,t)?Rt[t]=Et[t]:Rt[t]=Dt("Symbol."+t)),Rt[t]},zt=kt("species"),It=function(t,e){var i;return _t(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!_t(i.prototype)?b(i)&&null===(i=i[zt])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},jt=a.process,Bt=jt&&jt.versions,Ft=Bt&&Bt.v8;Ft?xt=(bt=Ft.split("."))[0]+bt[1]:vt&&(!(bt=vt.match(/Edge\/(\d+)/))||bt[1]>=74)&&(bt=vt.match(/Chrome\/(\d+)/))&&(xt=bt[1]);var Wt=xt&&+xt,Gt=kt("species"),Nt=function(t){return Wt>=51||!s((function(){var e=[];return(e.constructor={})[Gt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Yt=kt("isConcatSpreadable"),Vt=Wt>=51||!s((function(){var t=[];return t[Yt]=!1,t.concat()[0]!==t})),Xt=Nt("concat"),Zt=function(t){if(!b(t))return!1;var e=t[Yt];return void 0!==e?!!e:_t(t)};X({target:"Array",proto:!0,forced:!Vt||!Xt},{concat:function(t){var e,i,r,n,o,a=lt(this),s=It(a,0),l=0;for(e=-1,r=arguments.length;e<r;e++)if(o=-1===e?a:arguments[e],Zt(o)){if(l+(n=J(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<n;i++,l++)i in o&&St(s,l,o[i])}else{if(l>=9007199254740991)throw TypeError("Maximum allowed index exceeded");St(s,l++,o)}return s.length=l,s}});var Ut=function(t){return I[t+"Prototype"]},Ht=Ut("Array").concat,$t=Array.prototype,Jt=function(t){var e=t.concat;return t===$t||t instanceof Array&&e===$t.concat?Ht:e};X({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var qt=I.Number.isNaN;X({target:"Array",stat:!0},{isArray:_t});var Kt=I.Array.isArray,Qt=Kt,te={f:kt},ee=G.f,ie=function(t){var e=I.Symbol||(I.Symbol={});_(e,t)||ee(e,t,{value:te.f(t)})};ie("iterator");var re=function(t){return function(e,i){var r,n,o=String(m(e)),a=H(i),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(n=o.charCodeAt(a+1))<56320||n>57343?t?o.charAt(a):r:t?o.slice(a,a+2):n-56320+(r-55296<<10)+65536}},ne={codeAt:re(!1),charAt:re(!0)},oe=Function.toString;"function"!=typeof Lt.inspectSource&&(Lt.inspectSource=function(t){return oe.call(t)});var ae,se,le,he=Lt.inspectSource,ce=a.WeakMap,ue="function"==typeof ce&&/native code/.test(he(ce)),fe=Ct("keys"),de=function(t){return fe[t]||(fe[t]=Ot(t))},pe=a.WeakMap;if(ue){var ve=new pe,ye=ve.get,me=ve.has,ge=ve.set;ae=function(t,e){return ge.call(ve,t,e),e},se=function(t){return ye.call(ve,t)||{}},le=function(t){return me.call(ve,t)}}else{var be=de("state");it[be]=!0,ae=function(t,e){return N(t,be,e),e},se=function(t){return _(t,be)?t[be]:{}},le=function(t){return _(t,be)}}var xe,we,_e,Se={set:ae,get:se,has:le,enforce:function(t){return le(t)?se(t):ae(t,{})},getterFor:function(t){return function(e){var i;if(!b(e)||(i=se(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},Le=!s((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Ce=de("IE_PROTO"),Ae=Object.prototype,Te=Le?Object.getPrototypeOf:function(t){return t=lt(t),_(t,Ce)?t[Ce]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Ae:null},Oe=(kt("iterator"),!1);[].keys&&("next"in(_e=[].keys())?(we=Te(Te(_e)))!==Object.prototype&&(xe=we):Oe=!0),null==xe&&(xe={});var Me,Pe={IteratorPrototype:xe,BUGGY_SAFARI_ITERATORS:Oe},Re=l?Object.defineProperties:function(t,e){F(t);for(var i,r=at(e),n=r.length,o=0;n>o;)G.f(t,i=r[o++],e[i]);return t},Ee=pt("document","documentElement"),De=de("IE_PROTO"),ke=function(){},ze=function(t){return"<script>"+t+"<\/script>"},Ie=function(){try{Me=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Ie=Me?function(t){t.write(ze("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Me):((e=C("iframe")).style.display="none",Ee.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(ze("document.F=Object")),t.close(),t.F);for(var i=ot.length;i--;)delete Ie.prototype[ot[i]];return Ie()};it[De]=!0;var je=Object.create||function(t,e){var i;return null!==t?(ke.prototype=F(t),i=new ke,ke.prototype=null,i[De]=t):i=Ie(),void 0===e?i:Re(i,e)},Be={};Be[kt("toStringTag")]="z";var Fe="[object z]"===String(Be),We=kt("toStringTag"),Ge="Arguments"==p(function(){return arguments}()),Ne=Fe?p:function(t){var e,i,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),We))?i:Ge?p(e):"Object"==(r=p(e))&&"function"==typeof e.callee?"Arguments":r},Ye=Fe?{}.toString:function(){return"[object "+Ne(this)+"]"},Ve=G.f,Xe=kt("toStringTag"),Ze=function(t,e,i,r){if(t){var n=i?t:t.prototype;_(n,Xe)||Ve(n,Xe,{configurable:!0,value:e}),r&&!Fe&&N(n,"toString",Ye)}},Ue={},He=Pe.IteratorPrototype,$e=function(){return this},Je=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t,e=!1,i={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),e=i instanceof Array}catch(t){}}(),function(t,e,i,r){r&&r.enumerable?t[e]=i:N(t,e,i)}),qe=Pe.IteratorPrototype,Ke=Pe.BUGGY_SAFARI_ITERATORS,Qe=kt("iterator"),ti=function(){return this},ei=function(t,e,i,r,n,o,a){!function(t,e,i){var r=e+" Iterator";t.prototype=je(He,{next:f(1,i)}),Ze(t,r,!1,!0),Ue[r]=$e}(i,e,r);var s,l,h,c=function(t){if(t===n&&y)return y;if(!Ke&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new i(this,t)}}return function(){return new i(this)}},u=e+" Iterator",d=!1,p=t.prototype,v=p[Qe]||p["@@iterator"]||n&&p[n],y=!Ke&&v||c(n),m="Array"==e&&p.entries||v;if(m&&(s=Te(m.call(new t)),qe!==Object.prototype&&s.next&&(Ze(s,u,!0,!0),Ue[u]=ti)),"values"==n&&v&&"values"!==v.name&&(d=!0,y=function(){return v.call(this)}),a&&p[Qe]!==y&&N(p,Qe,y),Ue[e]=y,n)if(l={values:c("values"),keys:o?y:c("keys"),entries:c("entries")},a)for(h in l)(Ke||d||!(h in p))&&Je(p,h,l[h]);else X({target:e,proto:!0,forced:Ke||d},l);return l},ii=ne.charAt,ri=Se.set,ni=Se.getterFor("String Iterator");ei(String,"String",(function(t){ri(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=ni(this),i=e.string,r=e.index;return r>=i.length?{value:void 0,done:!0}:(t=ii(i,r),e.index+=t.length,{value:t,done:!1})}));var oi=Se.set,ai=Se.getterFor("Array Iterator");ei(Array,"Array",(function(t,e){oi(this,{type:"Array Iterator",target:g(t),index:0,kind:e})}),(function(){var t=ai(this),e=t.target,i=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:r,done:!1}:"values"==i?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");Ue.Arguments=Ue.Array;var si=kt("toStringTag");for(var li in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var hi=a[li],ci=hi&&hi.prototype;ci&&Ne(ci)!==si&&N(ci,si,li),Ue[li]=Ue.Array}var ui=te.f("iterator"),fi=Object.freeze({__proto__:null}),di=ot.concat("length","prototype"),pi={f:Object.getOwnPropertyNames||function(t){return nt(t,di)}},vi=pi.f,yi={}.toString,mi="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],gi={f:function(t){return mi&&"[object Window]"==yi.call(t)?function(t){try{return vi(t)}catch(t){return mi.slice()}}(t):vi(g(t))}},bi=[].push,xi=function(t){var e=1==t,i=2==t,r=3==t,n=4==t,o=6==t,a=5==t||o;return function(s,l,h,c){for(var u,f,d=lt(s),p=y(d),v=B(l,h,3),m=J(p.length),g=0,b=c||It,x=e?b(s,m):i?b(s,0):void 0;m>g;g++)if((a||g in p)&&(f=v(u=p[g],g,d),t))if(e)x[g]=f;else if(f)switch(t){case 3:return!0;case 5:return u;case 6:return g;case 2:bi.call(x,u)}else if(n)return!1;return o?-1:r||n?n:x}},wi={forEach:xi(0),map:xi(1),filter:xi(2),some:xi(3),every:xi(4),find:xi(5),findIndex:xi(6)},_i=wi.forEach,Si=de("hidden"),Li=kt("toPrimitive"),Ci=Se.set,Ai=Se.getterFor("Symbol"),Ti=Object.prototype,Oi=a.Symbol,Mi=pt("JSON","stringify"),Pi=O.f,Ri=G.f,Ei=gi.f,Di=u.f,ki=Ct("symbols"),zi=Ct("op-symbols"),Ii=Ct("string-to-symbol-registry"),ji=Ct("symbol-to-string-registry"),Bi=Ct("wks"),Fi=a.QObject,Wi=!Fi||!Fi.prototype||!Fi.prototype.findChild,Gi=l&&s((function(){return 7!=je(Ri({},"a",{get:function(){return Ri(this,"a",{value:7}).a}})).a}))?function(t,e,i){var r=Pi(Ti,e);r&&delete Ti[e],Ri(t,e,i),r&&t!==Ti&&Ri(Ti,e,r)}:Ri,Ni=function(t,e){var i=ki[t]=je(Oi.prototype);return Ci(i,{type:"Symbol",tag:t,description:e}),l||(i.description=e),i},Yi=Pt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Oi},Vi=function(t,e,i){t===Ti&&Vi(zi,e,i),F(t);var r=x(e,!0);return F(i),_(ki,r)?(i.enumerable?(_(t,Si)&&t[Si][r]&&(t[Si][r]=!1),i=je(i,{enumerable:f(0,!1)})):(_(t,Si)||Ri(t,Si,f(1,{})),t[Si][r]=!0),Gi(t,r,i)):Ri(t,r,i)},Xi=function(t,e){F(t);var i=g(e),r=at(i).concat($i(i));return _i(r,(function(e){l&&!Zi.call(i,e)||Vi(t,e,i[e])})),t},Zi=function(t){var e=x(t,!0),i=Di.call(this,e);return!(this===Ti&&_(ki,e)&&!_(zi,e))&&(!(i||!_(this,e)||!_(ki,e)||_(this,Si)&&this[Si][e])||i)},Ui=function(t,e){var i=g(t),r=x(e,!0);if(i!==Ti||!_(ki,r)||_(zi,r)){var n=Pi(i,r);return!n||!_(ki,r)||_(i,Si)&&i[Si][r]||(n.enumerable=!0),n}},Hi=function(t){var e=Ei(g(t)),i=[];return _i(e,(function(t){_(ki,t)||_(it,t)||i.push(t)})),i},$i=function(t){var e=t===Ti,i=Ei(e?zi:g(t)),r=[];return _i(i,(function(t){!_(ki,t)||e&&!_(Ti,t)||r.push(ki[t])})),r};if(Mt||(Je((Oi=function(){if(this instanceof Oi)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Ot(t),i=function(t){this===Ti&&i.call(zi,t),_(this,Si)&&_(this[Si],e)&&(this[Si][e]=!1),Gi(this,e,f(1,t))};return l&&Wi&&Gi(Ti,e,{configurable:!0,set:i}),Ni(e,t)}).prototype,"toString",(function(){return Ai(this).tag})),Je(Oi,"withoutSetter",(function(t){return Ni(Ot(t),t)})),u.f=Zi,G.f=Vi,O.f=Ui,pi.f=gi.f=Hi,st.f=$i,te.f=function(t){return Ni(kt(t),t)},l&&Ri(Oi.prototype,"description",{configurable:!0,get:function(){return Ai(this).description}})),X({global:!0,wrap:!0,forced:!Mt,sham:!Mt},{Symbol:Oi}),_i(at(Bi),(function(t){ie(t)})),X({target:"Symbol",stat:!0,forced:!Mt},{for:function(t){var e=String(t);if(_(Ii,e))return Ii[e];var i=Oi(e);return Ii[e]=i,ji[i]=e,i},keyFor:function(t){if(!Yi(t))throw TypeError(t+" is not a symbol");if(_(ji,t))return ji[t]},useSetter:function(){Wi=!0},useSimple:function(){Wi=!1}}),X({target:"Object",stat:!0,forced:!Mt,sham:!l},{create:function(t,e){return void 0===e?je(t):Xi(je(t),e)},defineProperty:Vi,defineProperties:Xi,getOwnPropertyDescriptor:Ui}),X({target:"Object",stat:!0,forced:!Mt},{getOwnPropertyNames:Hi,getOwnPropertySymbols:$i}),X({target:"Object",stat:!0,forced:s((function(){st.f(1)}))},{getOwnPropertySymbols:function(t){return st.f(lt(t))}}),Mi){var Ji=!Mt||s((function(){var t=Oi();return"[null]"!=Mi([t])||"{}"!=Mi({a:t})||"{}"!=Mi(Object(t))}));X({target:"JSON",stat:!0,forced:Ji},{stringify:function(t,e,i){for(var r,n=[t],o=1;arguments.length>o;)n.push(arguments[o++]);if(r=e,(b(e)||void 0!==t)&&!Yi(t))return _t(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!Yi(e))return e}),n[1]=e,Mi.apply(null,n)}})}Oi.prototype[Li]||N(Oi.prototype,Li,Oi.prototype.valueOf),Ze(Oi,"Symbol"),it[Si]=!0,ie("asyncIterator");var qi=Object.freeze({__proto__:null});ie("hasInstance"),ie("isConcatSpreadable"),ie("match"),ie("matchAll"),ie("replace"),ie("search"),ie("species"),ie("split"),ie("toPrimitive"),ie("toStringTag"),ie("unscopables"),Ze(Math,"Math",!0),Ze(a.JSON,"JSON",!0),n(fi),n(qi);var Ki=I.Symbol;ie("asyncDispose"),ie("dispose"),ie("observable"),ie("patternMatch"),ie("replaceAll");var Qi=Ki,tr=r((function(t){function e(i){return t.exports=e="function"==typeof Qi&&"symbol"==typeof ui?function(t){return typeof t}:function(t){return t&&"function"==typeof Qi&&t.constructor===Qi&&t!==Qi.prototype?"symbol":typeof t},e(i)}t.exports=e})),er=function(t,e){var i=[][t];return!!i&&s((function(){i.call(null,e||function(){throw 1},1)}))},ir=Object.defineProperty,rr={},nr=function(t){throw t},or=function(t,e){if(_(rr,t))return rr[t];e||(e={});var i=[][t],r=!!_(e,"ACCESSORS")&&e.ACCESSORS,n=_(e,0)?e[0]:nr,o=_(e,1)?e[1]:void 0;return rr[t]=!!i&&!s((function(){if(r&&!l)return!0;var t={length:-1};r?ir(t,1,{enumerable:!0,get:nr}):t[1]=1,i.call(t,n,o)}))},ar=wi.forEach,sr=er("forEach"),lr=or("forEach"),hr=sr&&lr?[].forEach:function(t){return ar(this,t,arguments.length>1?arguments[1]:void 0)};X({target:"Array",proto:!0,forced:[].forEach!=hr},{forEach:hr});var cr=Ut("Array").forEach,ur=Array.prototype,fr={DOMTokenList:!0,NodeList:!0},dr=function(t){var e=t.forEach;return t===ur||t instanceof Array&&e===ur.forEach||fr.hasOwnProperty(Ne(t))?cr:e},pr=Ut("Array").values,vr=Array.prototype,yr={DOMTokenList:!0,NodeList:!0},mr=function(t){var e=t.values;return t===vr||t instanceof Array&&e===vr.values||yr.hasOwnProperty(Ne(t))?pr:e};X({target:"Array",proto:!0},{fill:function(t){for(var e=lt(this),i=J(e.length),r=arguments.length,n=Q(r>1?arguments[1]:void 0,i),o=r>2?arguments[2]:void 0,a=void 0===o?i:Q(o,i);a>n;)e[n++]=t;return e}});var gr=Ut("Array").fill,br=Array.prototype,xr=function(t){var e=t.fill;return t===br||t instanceof Array&&e===br.fill?gr:e},wr="\t\n\v\f\r                　\u2028\u2029\ufeff",_r="["+wr+"]",Sr=RegExp("^"+_r+_r+"*"),Lr=RegExp(_r+_r+"*$"),Cr=function(t){return function(e){var i=String(m(e));return 1&t&&(i=i.replace(Sr,"")),2&t&&(i=i.replace(Lr,"")),i}},Ar={start:Cr(1),end:Cr(2),trim:Cr(3)},Tr=Ar.trim,Or=a.parseFloat,Mr=1/Or(wr+"-0")!=-1/0?function(t){var e=Tr(String(t)),i=Or(e);return 0===i&&"-"==e.charAt(0)?-0:i}:Or;X({global:!0,forced:parseFloat!=Mr},{parseFloat:Mr});var Pr=I.parseFloat,Rr=wi.filter,Er=Nt("filter"),Dr=or("filter");X({target:"Array",proto:!0,forced:!Er||!Dr},{filter:function(t){return Rr(this,t,arguments.length>1?arguments[1]:void 0)}});var kr=Ut("Array").filter,zr=Array.prototype,Ir=function(t){var e=t.filter;return t===zr||t instanceof Array&&e===zr.filter?kr:e},jr=et.indexOf,Br=[].indexOf,Fr=!!Br&&1/[1].indexOf(1,-0)<0,Wr=er("indexOf"),Gr=or("indexOf",{ACCESSORS:!0,1:0});X({target:"Array",proto:!0,forced:Fr||!Wr||!Gr},{indexOf:function(t){return Fr?Br.apply(this,arguments)||0:jr(this,t,arguments.length>1?arguments[1]:void 0)}});var Nr=Ut("Array").indexOf,Yr=Array.prototype,Vr=function(t){var e=t.indexOf;return t===Yr||t instanceof Array&&e===Yr.indexOf?Nr:e},Xr=[],Zr=Xr.sort,Ur=s((function(){Xr.sort(void 0)})),Hr=s((function(){Xr.sort(null)})),$r=er("sort");X({target:"Array",proto:!0,forced:Ur||!Hr||!$r},{sort:function(t){return void 0===t?Zr.call(lt(this)):Zr.call(lt(this),j(t))}});var Jr=Ut("Array").sort,qr=Array.prototype,Kr=function(t){var e=t.sort;return t===qr||t instanceof Array&&e===qr.sort?Jr:e},Qr=r((function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,r=this._callbacks["$"+t];if(!r)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var n=0;n<r.length;n++)if((i=r[n])===e||i.fn===e){r.splice(n,1);break}return 0===r.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],r=1;r<arguments.length;r++)e[r-1]=arguments[r];if(i){r=0;for(var n=(i=i.slice(0)).length;r<n;++r)i[r].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}})),tn=kt("iterator"),en=function(t){if(null!=t)return t[tn]||t["@@iterator"]||Ue[Ne(t)]},rn=function(t,e,i,r){try{return r?e(F(i)[0],i[1]):e(i)}catch(e){var n=t.return;throw void 0!==n&&F(n.call(t)),e}},nn=kt("iterator"),on=Array.prototype,an=function(t){return void 0!==t&&(Ue.Array===t||on[nn]===t)},sn=kt("iterator"),ln=!1;try{var hn=0,cn={next:function(){return{done:!!hn++}},return:function(){ln=!0}};cn[sn]=function(){return this},Array.from(cn,(function(){throw 2}))}catch(t){}var un=!function(t,e){if(!e&&!ln)return!1;var i=!1;try{var r={};r[sn]=function(){return{next:function(){return{done:i=!0}}}},t(r)}catch(t){}return i}((function(t){Array.from(t)}));X({target:"Array",stat:!0,forced:un},{from:function(t){var e,i,r,n,o,a,s=lt(t),l="function"==typeof this?this:Array,h=arguments.length,c=h>1?arguments[1]:void 0,u=void 0!==c,f=en(s),d=0;if(u&&(c=B(c,h>2?arguments[2]:void 0,2)),null==f||l==Array&&an(f))for(i=new l(e=J(s.length));e>d;d++)a=u?c(s[d],d):s[d],St(i,d,a);else for(o=(n=f.call(s)).next,i=new l;!(r=o.call(n)).done;d++)a=u?rn(n,c,[r.value,d],!0):r.value,St(i,d,a);return i.length=d,i}});var fn=I.Array.from;X({target:"Object",stat:!0,forced:!l,sham:!l},{defineProperty:G.f});var dn=r((function(t){var e=I.Object,i=t.exports=function(t,i,r){return e.defineProperty(t,i,r)};e.defineProperty.sham&&(i.sham=!0)}));X({target:"Object",stat:!0,forced:!l,sham:!l},{defineProperties:Re});r((function(t){var e=I.Object,i=t.exports=function(t,i){return e.defineProperties(t,i)};e.defineProperties.sham&&(i.sham=!0)}));var pn=pt("Reflect","ownKeys")||function(t){var e=pi.f(F(t)),i=st.f;return i?e.concat(i(t)):e};X({target:"Object",stat:!0,sham:!l},{getOwnPropertyDescriptors:function(t){for(var e,i,r=g(t),n=O.f,o=pn(r),a={},s=0;o.length>s;)void 0!==(i=n(r,e=o[s++]))&&St(a,e,i);return a}});I.Object.getOwnPropertyDescriptors;var vn=O.f,yn=s((function(){vn(1)}));X({target:"Object",stat:!0,forced:!l||yn,sham:!l},{getOwnPropertyDescriptor:function(t,e){return vn(g(t),e)}});r((function(t){var e=I.Object,i=t.exports=function(t,i){return e.getOwnPropertyDescriptor(t,i)};e.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),I.Object.getOwnPropertySymbols;X({target:"Object",stat:!0,sham:!l},{create:je});var mn=dn,gn=s((function(){at(1)}));X({target:"Object",stat:!0,forced:gn},{keys:function(t){return at(lt(t))}});var bn,xn=I.Object.keys,wn=Ar.trim;X({target:"String",proto:!0,forced:(bn="trim",s((function(){return!!wr[bn]()||"​᠎"!="​᠎"[bn]()||wr[bn].name!==bn})))},{trim:function(){return wn(this)}});Ut("String").trim;var _n=wi.map,Sn=Nt("map"),Ln=or("map");X({target:"Array",proto:!0,forced:!Sn||!Ln},{map:function(t){return _n(this,t,arguments.length>1?arguments[1]:void 0)}});var Cn=Ut("Array").map,An=Array.prototype,Tn=function(t){var e=t.map;return t===An||t instanceof Array&&e===An.map?Cn:e},On=Ar.trim,Mn=a.parseInt,Pn=/^[+-]?0[Xx]/,Rn=8!==Mn(wr+"08")||22!==Mn(wr+"0x16")?function(t,e){var i=On(String(t));return Mn(i,e>>>0||(Pn.test(i)?16:10))}:Mn;X({global:!0,forced:parseInt!=Rn},{parseInt:Rn});var En=I.parseInt,Dn=u.f,kn=function(t){return function(e){for(var i,r=g(e),n=at(r),o=n.length,a=0,s=[];o>a;)i=n[a++],l&&!Dn.call(r,i)||s.push(t?[i,r[i]]:r[i]);return s}},zn={entries:kn(!0),values:kn(!1)}.values;X({target:"Object",stat:!0},{values:function(t){return zn(t)}});I.Object.values;var In=Kt;var jn=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,r=new Array(e);i<e;i++)r[i]=t[i];return r};var Bn=function(t){if(In(t))return jn(t)},Fn=fn,Wn=kt("iterator"),Gn=function(t){var e=Object(t);return void 0!==e[Wn]||"@@iterator"in e||Ue.hasOwnProperty(Ne(e))};var Nn=function(t){if(void 0!==Qi&&Gn(Object(t)))return Fn(t)},Yn=Nt("slice"),Vn=or("slice",{ACCESSORS:!0,0:0,1:2}),Xn=kt("species"),Zn=[].slice,Un=Math.max;X({target:"Array",proto:!0,forced:!Yn||!Vn},{slice:function(t,e){var i,r,n,o=g(this),a=J(o.length),s=Q(t,a),l=Q(void 0===e?a:e,a);if(_t(o)&&("function"!=typeof(i=o.constructor)||i!==Array&&!_t(i.prototype)?b(i)&&null===(i=i[Xn])&&(i=void 0):i=void 0,i===Array||void 0===i))return Zn.call(o,s,l);for(r=new(void 0===i?Array:i)(Un(l-s,0)),n=0;s<l;s++,n++)s in o&&St(r,n,o[s]);return r.length=n,r}});var Hn=Ut("Array").slice,$n=Array.prototype,Jn=function(t){var e=t.slice;return t===$n||t instanceof Array&&e===$n.slice?Hn:e},qn=Jn;var Kn=function(t,e){var i;if(t){if("string"==typeof t)return jn(t,e);var r=qn(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?Fn(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?jn(t,e):void 0}};var Qn=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var to=function(t){return Bn(t)||Nn(t)||Kn(t)||Qn()},eo=Jn,io=s((function(){Te(1)}));X({target:"Object",stat:!0,forced:io,sham:!Le},{getPrototypeOf:function(t){return Te(lt(t))}});var ro=I.Object.getPrototypeOf;X({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});I.Date.now;var no=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,oo=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function ao(t,e,i,r){var n=!1;!0===r&&(n=null===e[i]&&void 0!==t[i]),n?delete t[i]:t[i]=e[i]}function so(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)||!0===i)if("object"===tr(e[n])&&null!==e[n]&&ro(e[n])===Object.prototype)void 0===t[n]?t[n]=so({},e[n],i):"object"===tr(t[n])&&null!==t[n]&&ro(t[n])===Object.prototype?so(t[n],e[n],i):ao(t,e,n,r);else if(Qt(e[n])){var o;t[n]=eo(o=e[n]).call(o)}else ao(t,e,n,r);return t}function lo(t,e){var i;return Jt(i=[]).call(i,to(t),[e])}function ho(t){return eo(t).call(t)}function co(t,e,i,r){var n;t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Vr(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,i,r)):t.attachEvent("on"+e,i)}function uo(t,e,i,r){var n;t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Vr(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,i,r)):t.detachEvent("on"+e,i)}function fo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function po(t,e,i){var r,n,o,a=Math.floor(6*t),s=6*t-a,l=i*(1-e),h=i*(1-s*e),c=i*(1-(1-s)*e);switch(a%6){case 0:r=i,n=c,o=l;break;case 1:r=h,n=i,o=l;break;case 2:r=l,n=i,o=c;break;case 3:r=l,n=h,o=i;break;case 4:r=c,n=l,o=i;break;case 5:r=i,n=l,o=h}return{r:Math.floor(255*r),g:Math.floor(255*n),b:Math.floor(255*o)}}function vo(t,e,i){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==i?i:0}vo.subtract=function(t,e){var i=new vo;return i.x=t.x-e.x,i.y=t.y-e.y,i.z=t.z-e.z,i},vo.add=function(t,e){var i=new vo;return i.x=t.x+e.x,i.y=t.y+e.y,i.z=t.z+e.z,i},vo.avg=function(t,e){return new vo((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},vo.scalarProduct=function(t,e){return new vo(t.x*e,t.y*e,t.z*e)},vo.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},vo.crossProduct=function(t,e){var i=new vo;return i.x=t.y*e.z-t.z*e.y,i.y=t.z*e.x-t.x*e.z,i.z=t.x*e.y-t.y*e.x,i},vo.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},vo.prototype.normalize=function(){return vo.scalarProduct(this,1/this.length())};var yo=vo;var mo=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function go(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var i=this;this.frame.slide.onmousedown=function(t){i._onMouseDown(t)},this.frame.prev.onclick=function(t){i.prev(t)},this.frame.play.onclick=function(t){i.togglePlay(t)},this.frame.next.onclick=function(t){i.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function bo(t,e,i,r){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,i,r)}go.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},go.prototype.next=function(){var t=this.getIndex();t<mr(this).length-1&&(t++,this.setIndex(t))},go.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<mr(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var i=new Date-t,r=Math.max(this.playInterval-i,0),n=this;this.playTimeout=wt((function(){n.playNext()}),r)},go.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},go.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},go.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},go.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},go.prototype.setPlayInterval=function(t){this.playInterval=t},go.prototype.getPlayInterval=function(){return this.playInterval},go.prototype.setPlayLoop=function(t){this.playLoop=t},go.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},go.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},go.prototype.setValues=function(t){this.values=t,mr(this).length>0?this.setIndex(0):this.index=void 0},go.prototype.setIndex=function(t){if(!(t<mr(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},go.prototype.getIndex=function(){return this.index},go.prototype.get=function(){return mr(this)[this.index]},go.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Pr(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},co(document,"mousemove",this.onmousemove),co(document,"mouseup",this.onmouseup),fo(t)}},go.prototype.leftToIndex=function(t){var e=Pr(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,i=t-3,r=Math.round(i/e*(mr(this).length-1));return r<0&&(r=0),r>mr(this).length-1&&(r=mr(this).length-1),r},go.prototype.indexToLeft=function(t){var e=Pr(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(mr(this).length-1)*e+3},go.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,i=this.startSlideX+e,r=this.leftToIndex(i);this.setIndex(r),fo()},go.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",uo(document,"mousemove",this.onmousemove),uo(document,"mouseup",this.onmouseup),fo()},bo.prototype.isNumeric=function(t){return!isNaN(Pr(t))&&isFinite(t)},bo.prototype.setRange=function(t,e,i,r){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(i))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(i,r)},bo.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=bo.calculatePrettyStep(t):this._step=t)},bo.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},i=Math.pow(10,Math.round(e(t))),r=2*Math.pow(10,Math.round(e(t/2))),n=5*Math.pow(10,Math.round(e(t/5))),o=i;return Math.abs(r-t)<=Math.abs(o-t)&&(o=r),Math.abs(n-t)<=Math.abs(o-t)&&(o=n),o<=0&&(o=1),o},bo.prototype.getCurrent=function(){return Pr(this._current.toPrecision(this.precision))},bo.prototype.getStep=function(){return this._step},bo.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},bo.prototype.next=function(){this._current+=this._step},bo.prototype.end=function(){return this._current>this._end};var xo=bo,wo=[].reverse,_o=[1,2];X({target:"Array",proto:!0,forced:String(_o)===String(_o.reverse())},{reverse:function(){return _t(this)&&(this.length=this.length),wo.call(this)}});var So=Ut("Array").reverse,Lo=Array.prototype,Co=function(t){var e=t.reverse;return t===Lo||t instanceof Array&&e===Lo.reverse?So:e},Ao=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};X({target:"Math",stat:!0},{sign:Ao});var To=I.Math.sign;function Oo(){this.armLocation=new yo,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new yo,this.offsetMultiplier=.6,this.cameraLocation=new yo,this.cameraRotation=new yo(.5*Math.PI,0,0),this.calculateCameraOrientation()}Oo.prototype.setOffset=function(t,e){var i=Math.abs,r=To,n=this.offsetMultiplier,o=this.armLength*n;i(t)>o&&(t=r(t)*o),i(e)>o&&(e=r(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},Oo.prototype.getOffset=function(){return this.cameraOffset},Oo.prototype.setArmLocation=function(t,e,i){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=i,this.calculateCameraOrientation()},Oo.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},Oo.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},Oo.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},Oo.prototype.getArmLength=function(){return this.armLength},Oo.prototype.getCameraLocation=function(){return this.cameraLocation},Oo.prototype.getCameraRotation=function(){return this.cameraRotation},Oo.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,i=this.cameraOffset.x,r=this.cameraOffset.y,n=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+i*o(e)+r*-n(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+i*n(e)+r*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+r*n(t)};var Mo={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},Po={dot:Mo.DOT,"dot-line":Mo.DOTLINE,"dot-color":Mo.DOTCOLOR,"dot-size":Mo.DOTSIZE,line:Mo.LINE,grid:Mo.GRID,surface:Mo.SURFACE,bar:Mo.BAR,"bar-color":Mo.BARCOLOR,"bar-size":Mo.BARSIZE},Ro=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],Eo=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],Do=void 0;function ko(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function zo(t,e){return void 0===t||""===t?e:t+(void 0===(i=e)||""===i||"string"!=typeof i?i:i.charAt(0).toUpperCase()+eo(i).call(i,1));var i}function Io(t,e,i,r){for(var n,o=0;o<i.length;++o)e[zo(r,n=i[o])]=t[n]}function jo(t,e,i,r){for(var n,o=0;o<i.length;++o)void 0!==t[n=i[o]]&&(e[zo(r,n)]=t[n])}function Bo(t,e){if(void 0!==t.backgroundColor&&function(t,e){var i="white",r="gray",n=1;if("string"==typeof t)i=t,r="none",n=0;else{if("object"!==tr(t))throw new Error("Unsupported type of backgroundColor");void 0!==xr(t)&&(i=xr(t)),void 0!==t.stroke&&(r=t.stroke),void 0!==t.strokeWidth&&(n=t.strokeWidth)}e.frame.style.backgroundColor=i,e.frame.style.borderColor=r,e.frame.style.borderWidth=n+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(xr(t)&&(e.dataColor.fill=xr(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var i;if("string"==typeof t){if(-1===(i=function(t){var e=Po[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var i in Mo)if(Mo[i]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");i=t}e.style=i}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var i;if(Qt(t))i=Fo(t);else{if("object"!==tr(t))throw new Error("Unsupported type of surfaceColors");i=Wo(t.hue)}Co(i).call(i),e.colormap=i}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var i;if(Qt(t))i=Fo(t);else if("object"===tr(t))i=Wo(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");i=t}e.colormap=i}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===Do.showLegend){var i=e.style===Mo.DOTCOLOR||e.style===Mo.DOTSIZE;e.showLegend=i}}else e.showLegend=t}(t.showLegend,e),Go(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Qt(i))throw new TypeError("Arrays are not supported by deepExtend");for(var n=0;n<t.length;n++){var o=t[n];if(Object.prototype.hasOwnProperty.call(i,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?so(e[o],i[o],!1,r):ao(e,i,o,r);else{if(Qt(i[o]))throw new TypeError("Arrays are not supported by deepExtend");ao(e,i,o,r)}}}(["tooltipStyle"],e,t)}function Fo(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return Tn(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=oo.exec(t))?{r:En(e[1]+e[1],16),g:En(e[2]+e[2],16),b:En(e[3]+e[3],16)}:null;case 6:case 7:return(e=no.exec(t))?{r:En(e[1],16),g:En(e[2],16),b:En(e[3],16)}:null;default:return null}}(t)}))}function Wo(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),i=[],r=0;r<t.colorStops;++r){var n=(t.start+e*r)%360/360;i.push(po(n<0?n+1:n,t.saturation/100,t.brightness/100))}return i}function Go(t,e){var i=t;void 0!==i&&(void 0===e.camera&&(e.camera=new Oo),e.camera.setArmRotation(i.horizontal,i.vertical),e.camera.setArmLength(i.distance))}var No=pt("JSON","stringify"),Yo=/[\uD800-\uDFFF]/g,Vo=/^[\uD800-\uDBFF]$/,Xo=/^[\uDC00-\uDFFF]$/,Zo=function(t,e,i){var r=i.charAt(e-1),n=i.charAt(e+1);return Vo.test(t)&&!Xo.test(n)||Xo.test(t)&&!Vo.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},Uo=s((function(){return'"\\udf06\\ud834"'!==No("\udf06\ud834")||'"\\udead"'!==No("\udead")}));No&&X({target:"JSON",stat:!0,forced:Uo},{stringify:function(t,e,i){var r=No.apply(null,arguments);return"string"==typeof r?r.replace(Yo,Zo):r}}),I.JSON||(I.JSON={stringify:JSON.stringify});var Ho=function(t,e,i){return I.JSON.stringify.apply(null,arguments)};var $o=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Jo(t,e){for(var i=0;i<e.length;i++){var r=e[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),mn(t,r.key,r)}}var qo,Ko=function(t,e,i){return e&&Jo(t.prototype,e),i&&Jo(t,i),t},Qo=!1,ta="background: #FFeeee; color: #dd0000",ea=function(){function t(){$o(this,t)}return Ko(t,null,[{key:"validate",value:function(e,i,r){Qo=!1,qo=i;var n=i;return void 0!==r&&(n=i[r]),t.parse(e,n,[]),Qo}},{key:"parse",value:function(e,i,r){for(var n in e)e.hasOwnProperty(n)&&t.check(n,e,i,r)}},{key:"check",value:function(e,i,r,n){if(void 0!==r[e]||void 0!==r.__any__){var o=e,a=!0;void 0===r[e]&&void 0!==r.__any__&&(o="__any__",a="object"===t.getType(i[e]));var s=r[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,i,r,o,s,n)}else t.getSuggestion(e,r,n)}},{key:"checkFields",value:function(e,i,r,n,o,a){var s=function(i){console.log("%c"+i+t.printLocation(a,e),ta)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Vr(h).call(h,i[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),Qo=!0):"object"===l&&"__any__"!==n&&(a=lo(a,e),t.parse(i[e],r[n],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(xn(o))+". Received ["+l+'] "'+i[e]+'"'),Qo=!0)}},{key:"getType",value:function(t){var e=tr(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Qt(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,r){var n,o=t.findInOptions(e,i,r,!1),a=t.findInOptions(e,qo,[],!0);n=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(xn(i))+t.printLocation(r,e),console.log('%cUnknown option detected: "'+e+'"'+n,ta),Qo=!0}},{key:"findInOptions",value:function(e,i,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],l=e.toLowerCase(),h=void 0;for(var c in i){var u=void 0;if(void 0!==i[c].__type__&&!0===n){var f=t.findInOptions(e,i[c],lo(r,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,h=f.indexMatch)}else{var d;-1!==Vr(d=c.toLowerCase()).call(d,l)&&(h=c),o>(u=t.levenshteinDistance(e,c))&&(a=c,s=ho(r),o=u)}}return{closestMatch:a,path:s,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",r="\n\n"+i+"options = {\n",n=0;n<t.length;n++){for(var o=0;o<n+1;o++)r+="  ";r+=t[n]+": {\n"}for(var a=0;a<t.length+1;a++)r+="  ";r+=e+"\n";for(var s=0;s<t.length+1;s++){for(var l=0;l<t.length-s;l++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return Ho(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,r,n=[];for(i=0;i<=e.length;i++)n[i]=[i];for(r=0;r<=t.length;r++)n[0][r]=r;for(i=1;i<=e.length;i++)for(r=1;r<=t.length;r++)e.charAt(i-1)==t.charAt(r-1)?n[i][r]=n[i-1][r-1]:n[i][r]=Math.min(n[i-1][r-1]+1,Math.min(n[i][r-1]+1,n[i-1][r]+1));return n[e.length][t.length]}}]),t}(),ia="string",ra="boolean",na="number",oa="object",aa={fill:{string:ia},stroke:{string:ia},strokeWidth:{number:na},__type__:{string:ia,object:oa,undefined:"undefined"}},sa={animationAutoStart:{boolean:ra,undefined:"undefined"},animationInterval:{number:na},animationPreload:{boolean:ra},axisColor:{string:ia},axisFontSize:{number:na},axisFontType:{string:ia},backgroundColor:aa,xBarWidth:{number:na,undefined:"undefined"},yBarWidth:{number:na,undefined:"undefined"},cameraPosition:{distance:{number:na},horizontal:{number:na},vertical:{number:na},__type__:{object:oa}},zoomable:{boolean:ra},ctrlToZoom:{boolean:ra},xCenter:{string:ia},yCenter:{string:ia},colormap:{hue:{start:{number:na},end:{number:na},saturation:{number:na},brightness:{number:na},colorStops:{number:na},__type__:{object:oa}},__type__:{array:"array",object:oa,function:"function",undefined:"undefined"}},dataColor:aa,dotSizeMinFraction:{number:na},dotSizeMaxFraction:{number:na},dotSizeRatio:{number:na},filterLabel:{string:ia},gridColor:{string:ia},onclick:{function:"function"},keepAspectRatio:{boolean:ra},xLabel:{string:ia},yLabel:{string:ia},zLabel:{string:ia},legendLabel:{string:ia},xMin:{number:na,undefined:"undefined"},yMin:{number:na,undefined:"undefined"},zMin:{number:na,undefined:"undefined"},xMax:{number:na,undefined:"undefined"},yMax:{number:na,undefined:"undefined"},zMax:{number:na,undefined:"undefined"},showAnimationControls:{boolean:ra,undefined:"undefined"},showGrayBottom:{boolean:ra},showGrid:{boolean:ra},showLegend:{boolean:ra,undefined:"undefined"},showPerspective:{boolean:ra},showShadow:{boolean:ra},showSurfaceGrid:{boolean:ra},showXAxis:{boolean:ra},showYAxis:{boolean:ra},showZAxis:{boolean:ra},rotateAxisLabels:{boolean:ra},surfaceColors:{hue:{start:{number:na},end:{number:na},saturation:{number:na},brightness:{number:na},colorStops:{number:na},__type__:{object:oa}},__type__:{boolean:ra,array:"array",object:oa,undefined:"undefined"}},xStep:{number:na,undefined:"undefined"},yStep:{number:na,undefined:"undefined"},zStep:{number:na,undefined:"undefined"},style:{number:na,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:ra,function:"function"},tooltipDelay:{number:na},tooltipStyle:{content:{color:{string:ia},background:{string:ia},border:{string:ia},borderRadius:{string:ia},boxShadow:{string:ia},padding:{string:ia},__type__:{object:oa}},line:{borderLeft:{string:ia},height:{string:ia},width:{string:ia},pointerEvents:{string:ia},__type__:{object:oa}},dot:{border:{string:ia},borderRadius:{string:ia},height:{string:ia},width:{string:ia},pointerEvents:{string:ia},__type__:{object:oa}},__type__:{object:oa}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:na,undefined:"undefined"},valueMin:{number:na,undefined:"undefined"},verticalRatio:{number:na},height:{string:ia},width:{string:ia},__type__:{object:oa}};function la(){this.min=void 0,this.max=void 0}la.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},la.prototype.combine=function(t){this.add(t.min),this.add(t.max)},la.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,i=this.max+t;if(e>i)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=i}},la.prototype.range=function(){return this.max-this.min},la.prototype.center=function(){return(this.min+this.max)/2};var ha=la;function ca(t,e,i){this.dataGroup=t,this.column=e,this.graph=i,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),mr(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,i.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function ua(){this.dataTable=null}ca.prototype.isLoaded=function(){return this.loaded},ca.prototype.getLoadedProgress=function(){for(var t=mr(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},ca.prototype.getLabel=function(){return this.graph.filterLabel},ca.prototype.getColumn=function(){return this.column},ca.prototype.getSelectedValue=function(){if(void 0!==this.index)return mr(this)[this.index]},ca.prototype.getValues=function(){return mr(this)},ca.prototype.getValue=function(t){if(t>=mr(this).length)throw new Error("Index out of range");return mr(this)[t]},ca.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var i;if(this.dataPoints[t])i=this.dataPoints[t];else{var r={};r.column=this.column,r.value=mr(this)[t];var n=new e.DataView(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();i=this.dataGroup._getDataPoints(n),this.dataPoints[t]=i}return i},ca.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},ca.prototype.selectValue=function(t){if(t>=mr(this).length)throw new Error("Index out of range");this.index=t,this.value=mr(this)[t]},ca.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<mr(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var i=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+i+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var r=this;wt((function(){r.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},ua.prototype.initializeData=function(t,i,r){if(void 0!==i){var n;if(Qt(i)&&(i=new e.DataSet(i)),!(i instanceof e.DataSet||i instanceof e.DataView))throw new Error("Array, DataSet, or DataView expected");if(0!=(n=i.get()).length){this.style=r,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=i,this.dataTable=n;var o=this;this._onChange=function(){t.setData(o.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var a=t.hasBars(r);if(a&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(n,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(n,this.colY)||1),this._initializeRange(n,this.colX,t,a),this._initializeRange(n,this.colY,t,a),this._initializeRange(n,this.colZ,t,!1),n[0].hasOwnProperty("style")){this.colValue="style";var s=this.getColumnRange(n,this.colValue);this._setRangeDefaults(s,t.defaultValueMin,t.defaultValueMax),this.valueRange=s}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new ca(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},ua.prototype._collectRangeSettings=function(t,e){var i;if(-1==Vr(i=["x","y","z"]).call(i,t))throw new Error("Column '"+t+"' invalid");var r=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+r+"Min"],max:e["default"+r+"Max"],step:e["default"+r+"Step"],range_label:t+"Range",step_label:t+"Step"}},ua.prototype._initializeRange=function(t,e,i,r){var n=this._collectRangeSettings(e,i),o=this.getColumnRange(t,e);r&&"z"!=e&&o.expand(n.barWidth/2),this._setRangeDefaults(o,n.min,n.max),this[n.range_label]=o,this[n.step_label]=void 0!==n.step?n.step:o.range()/5},ua.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var i=[],r=0;r<e.length;r++){var n=e[r][t]||0;-1===Vr(i).call(i,n)&&i.push(n)}return Kr(i).call(i,(function(t,e){return t-e}))},ua.prototype.getSmallestDifference=function(t,e){for(var i=this.getDistinctValues(t,e),r=null,n=1;n<i.length;n++){var o=i[n]-i[n-1];(null==r||r>o)&&(r=o)}return r},ua.prototype.getColumnRange=function(t,e){for(var i=new ha,r=0;r<t.length;r++){var n=t[r][e];i.adjust(n)}return i},ua.prototype.getNumberOfRows=function(){return this.dataTable.length},ua.prototype._setRangeDefaults=function(t,e,i){void 0!==e&&(t.min=e),void 0!==i&&(t.max=i),t.max<=t.min&&(t.max=t.min+1)},ua.prototype.getDataTable=function(){return this.dataTable},ua.prototype.getDataSet=function(){return this.dataSet},ua.prototype.getDataPoints=function(t){for(var e=[],i=0;i<t.length;i++){var r=new yo;r.x=t[i][this.colX]||0,r.y=t[i][this.colY]||0,r.z=t[i][this.colZ]||0,r.data=t[i],r.value=t[i][this.colValue]||0;var n={};n.point=r,n.bottom=new yo(r.x,r.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},ua.prototype.initDataAsMatrix=function(t){var e,i,r,n,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),l=[];for(r=0;r<s.length;r++){n=s[r];var h=Vr(o).call(o,n.point.x),c=Vr(a).call(a,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(i=0;i<l[e].length;i++)l[e][i]&&(l[e][i].pointRight=e<l.length-1?l[e+1][i]:void 0,l[e][i].pointTop=i<l[e].length-1?l[e][i+1]:void 0,l[e][i].pointCross=e<l.length-1&&i<l[e].length-1?l[e+1][i+1]:void 0);return s},ua.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},ua.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},ua.prototype._getDataPoints=function(t){var e=[];if(this.style===Mo.GRID||this.style===Mo.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===Mo.LINE)for(var i=0;i<e.length;i++)i>0&&(e[i-1].pointNext=e[i]);return e},fa.STYLE=Mo;function fa(t,e,i){if(!(this instanceof fa))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new ua,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||ko(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");Do=t,Io(t,e,Ro),Io(t,e,Eo,"default"),Bo(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new yo(0,0,-1)}(fa.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(i),this.setData(e)}function da(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function pa(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}fa.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:void 0,animationInterval:1e3,animationPreload:!1,animationAutoStart:void 0,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:fa.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:void 0,colormap:void 0,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:void 0,backgroundColor:void 0,xBarWidth:void 0,yBarWidth:void 0,valueMin:void 0,valueMax:void 0,xMin:void 0,xMax:void 0,xStep:void 0,yMin:void 0,yMax:void 0,yStep:void 0,zMin:void 0,zMax:void 0,zStep:void 0},Qr(fa.prototype),fa.prototype._setScale=function(){this.scale=new yo(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,i=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,i)},fa.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},fa.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),i=this.camera.getCameraRotation(),r=t.x*this.scale.x,n=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,l=e.z,h=Math.sin(i.x),c=Math.cos(i.x),u=Math.sin(i.y),f=Math.cos(i.y),d=Math.sin(i.z),p=Math.cos(i.z);return new yo(f*(d*(n-s)+p*(r-a))-u*(o-l),h*(f*(o-l)+u*(d*(n-s)+p*(r-a)))+c*(p*(n-s)-d*(r-a)),c*(f*(o-l)+u*(d*(n-s)+p*(r-a)))-h*(p*(n-s)-d*(r-a)))},fa.prototype._convertTranslationToScreen=function(t){var e,i,r=this.eye.x,n=this.eye.y,o=this.eye.z,a=t.x,s=t.y,l=t.z;return this.showPerspective?(e=o/l*(a-r),i=o/l*(s-n)):(e=a*(-o/this.camera.getArmLength()),i=s*(-o/this.camera.getArmLength())),new mo(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-i*this.frame.canvas.clientWidth)},fa.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var i=t[e];i.trans=this._convertPointToTranslation(i.point),i.screen=this._convertTranslationToScreen(i.trans);var r=this._convertPointToTranslation(i.bottom);i.dist=this.showPerspective?r.length():-r.z}Kr(t).call(t,(function(t,e){return e.dist-t.dist}))},fa.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},fa.prototype.getDataPoints=function(t){for(var e=[],i=0;i<t.length;i++){var r=new yo;r.x=t[i][this.colX]||0,r.y=t[i][this.colY]||0,r.z=t[i][this.colZ]||0,r.data=t[i],r.value=t[i][this.colValue]||0;var n={};n.point=r,n.bottom=new yo(r.x,r.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},fa.prototype._getDataPoints=function(t){var e,i,r,n,o=[];if(this.style===fa.STYLE.GRID||this.style===fa.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var l=[];for(r=0;r<o.length;r++){n=o[r];var h=Vr(a).call(a,n.point.x),c=Vr(s).call(s,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(i=0;i<l[e].length;i++)l[e][i]&&(l[e][i].pointRight=e<l.length-1?l[e+1][i]:void 0,l[e][i].pointTop=i<l[e].length-1?l[e][i+1]:void 0,l[e][i].pointCross=e<l.length-1&&i<l[e].length-1?l[e+1][i+1]:void 0)}else if(o=this.getDataPoints(t),this.style===fa.STYLE.LINE)for(r=0;r<o.length;r++)r>0&&(o[r-1].pointNext=o[r]);return o},fa.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Ir(this.frame).style.position="absolute",Ir(this.frame).style.bottom="0px",Ir(this.frame).style.left="0px",Ir(this.frame).style.width="100%",this.frame.appendChild(Ir(this.frame));var e=this;co(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),co(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),co(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),co(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),co(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},fa.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},fa.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Ir(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},fa.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Ir(this.frame)||!Ir(this.frame).slider)throw new Error("No animation available");Ir(this.frame).slider.play()}},fa.prototype.animationStop=function(){Ir(this.frame)&&Ir(this.frame).slider&&Ir(this.frame).slider.stop()},fa.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Pr(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Pr(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Pr(this.yCenter)/100*(this.frame.canvas.clientHeight-Ir(this.frame).clientHeight):this.currentYCenter=Pr(this.yCenter)},fa.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},fa.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},fa.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},fa.prototype.setOptions=function(t){void 0!==t&&(!0===ea.validate(t,sa)&&console.log("%cErrors have been found in the supplied options object.",ta),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===Do||ko(Do))throw new Error("DEFAULTS not set for module Settings");jo(t,e,Ro),jo(t,e,Eo,"default"),Bo(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},fa.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case fa.STYLE.BAR:t=this._redrawBarGraphPoint;break;case fa.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case fa.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case fa.STYLE.DOT:t=this._redrawDotGraphPoint;break;case fa.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case fa.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case fa.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case fa.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case fa.STYLE.GRID:t=this._redrawGridGraphPoint;break;case fa.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},fa.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},fa.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},fa.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},fa.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},fa.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},fa.prototype._getLegendWidth=function(){var t;this.style===fa.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===fa.STYLE.BARSIZE?this.xBarWidth:20;return t},fa.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==fa.STYLE.LINE&&this.style!==fa.STYLE.BARSIZE){var t=this.style===fa.STYLE.BARSIZE||this.style===fa.STYLE.DOTSIZE,e=this.style===fa.STYLE.DOTSIZE||this.style===fa.STYLE.DOTCOLOR||this.style===fa.STYLE.SURFACE||this.style===fa.STYLE.BARCOLOR,i=Math.max(.25*this.frame.clientHeight,100),r=this.margin,n=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-n,s=r+i,l=this._getContext();if(l.lineWidth=1,l.font="14px arial",!1===t){var h,c=i;for(h=0;h<c;h++){var u=1-(h-0)/(c-0),f=this._colormap(u,1);l.strokeStyle=f,l.beginPath(),l.moveTo(a,r+h),l.lineTo(o,r+h),l.stroke()}l.strokeStyle=this.axisColor,l.strokeRect(a,r,n,i)}else{var d;this.style===fa.STYLE.DOTSIZE?d=n*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,fa.STYLE.BARSIZE),l.strokeStyle=this.axisColor,l.fillStyle=xr(this.dataColor),l.beginPath(),l.moveTo(a,r),l.lineTo(o,r),l.lineTo(a+d,s),l.lineTo(a,s),l.closePath(),xr(l).call(l),l.stroke()}var p,v,y=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new xo(y,m,(m-y)/5,!0);for(g.start(!0);!g.end();)h=s-(g.getCurrent()-y)/(m-y)*i,p=new mo(a-5,h),v=new mo(a,h),this._line(l,p,v),l.textAlign="right",l.textBaseline="middle",l.fillStyle=this.axisColor,l.fillText(g.getCurrent(),a-10,h),g.next();l.textAlign="right",l.textBaseline="top";var b=this.legendLabel;l.fillText(b,o,s+this.margin)}},fa.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Ir(this.frame);if(e.innerHTML="",t){var i=new go(e,{visible:this.showAnimationControls});e.slider=i,e.style.padding="10px",i.setValues(mr(t)),i.setPlayInterval(this.animationInterval);var r=this;i.setOnChangeCallback((function(){var t=r.dataGroup.dataFilter,e=i.getIndex();t.selectValue(e),r.dataPoints=t._getDataPoints(),r.redraw()}))}else e.slider=void 0},fa.prototype._redrawSlider=function(){void 0!==Ir(this.frame).slider&&Ir(this.frame).slider.redraw()},fa.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var i=this.margin,r=this.margin;e.fillText(t,i,r)}},fa.prototype._line=function(t,e,i,r){void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(i.x,i.y),t.stroke()},fa.prototype.drawAxisLabelX=function(t,e,i,r,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)},fa.prototype.drawAxisLabelY=function(t,e,i,r,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)},fa.prototype.drawAxisLabelZ=function(t,e,i,r){void 0===r&&(r=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,n.x-r,n.y)},fa.prototype.drawAxisLabelXRotate=function(t,e,i,r,n){var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,0,0),t.restore()):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y))},fa.prototype.drawAxisLabelYRotate=function(t,e,i,r,n){var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,0,0),t.restore()):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,o.x,o.y))},fa.prototype.drawAxisLabelZRotate=function(t,e,i,r){void 0===r&&(r=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(i,n.x-r,n.y)},fa.prototype._line3d=function(t,e,i,r){var n=this._convert3Dto2D(e),o=this._convert3Dto2D(i);this._line(t,n,o,r)},fa.prototype._redrawAxis=function(){var t,e,i,r,n,o,a,s,l,h,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var u,f,d,p=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new mo(Math.cos(m),Math.sin(m)),b=this.xRange,x=this.yRange,w=this.zRange;for(c.lineWidth=1,r=void 0===this.defaultXStep,(i=new xo(b.min,b.max,this.xStep,r)).start(!0);!i.end();){var _=i.getCurrent();if(this.showGrid?(t=new yo(_,x.min,w.min),e=new yo(_,x.max,w.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new yo(_,x.min,w.min),e=new yo(_,x.min+p,w.min),this._line3d(c,t,e,this.axisColor),t=new yo(_,x.max,w.min),e=new yo(_,x.max-p,w.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=g.x>0?x.min:x.max,u=new yo(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,c,u,S,m,y)}i.next()}for(c.lineWidth=1,r=void 0===this.defaultYStep,(i=new xo(x.min,x.max,this.yStep,r)).start(!0);!i.end();){var L=i.getCurrent();if(this.showGrid?(t=new yo(b.min,L,w.min),e=new yo(b.max,L,w.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new yo(b.min,L,w.min),e=new yo(b.min+v,L,w.min),this._line3d(c,t,e,this.axisColor),t=new yo(b.max,L,w.min),e=new yo(b.max-v,L,w.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=g.y>0?b.min:b.max,u=new yo(o,L,w.min);var C="  "+this.yValueLabel(L)+"  ";this._drawAxisLabelY.call(this,c,u,C,m,y)}i.next()}if(this.showZAxis){for(c.lineWidth=1,r=void 0===this.defaultZStep,(i=new xo(w.min,w.max,this.zStep,r)).start(!0),o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max;!i.end();){var A=i.getCurrent(),T=new yo(o,a,A),O=this._convert3Dto2D(T);e=new mo(O.x-y,O.y),this._line(c,O,e,this.axisColor);var M=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,c,T,M,5),i.next()}c.lineWidth=1,t=new yo(o,a,w.min),e=new yo(o,a,w.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new yo(b.min,x.min,w.min),d=new yo(b.max,x.min,w.min),this._line3d(c,f,d,this.axisColor),f=new yo(b.min,x.max,w.min),d=new yo(b.max,x.max,w.min),this._line3d(c,f,d,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new yo(b.min,x.min,w.min),e=new yo(b.min,x.max,w.min),this._line3d(c,t,e,this.axisColor),t=new yo(b.max,x.min,w.min),e=new yo(b.max,x.max,w.min),this._line3d(c,t,e,this.axisColor));var P=this.xLabel;P.length>0&&this.showXAxis&&(h=.1/this.scale.y,o=(b.max+3*b.min)/4,a=g.x>0?x.min-h:x.max+h,n=new yo(o,a,w.min),this.drawAxisLabelX(c,n,P,m));var R=this.yLabel;R.length>0&&this.showYAxis&&(l=.1/this.scale.x,o=g.y>0?b.min-l:b.max+l,a=(x.max+3*x.min)/4,n=new yo(o,a,w.min),this.drawAxisLabelY(c,n,R,m));var E=this.zLabel;E.length>0&&this.showZAxis&&(30,o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max,s=(w.max+3*w.min)/4,n=new yo(o,a,s),this.drawAxisLabelZ(c,n,E,30))},fa.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},fa.prototype._redrawBar=function(t,e,i,r,n,o){var a,s=this,l=e.point,h=this.zRange.min,c=[{point:new yo(l.x-i,l.y-r,l.z)},{point:new yo(l.x+i,l.y-r,l.z)},{point:new yo(l.x+i,l.y+r,l.z)},{point:new yo(l.x-i,l.y+r,l.z)}],u=[{point:new yo(l.x-i,l.y-r,h)},{point:new yo(l.x+i,l.y-r,h)},{point:new yo(l.x+i,l.y+r,h)},{point:new yo(l.x-i,l.y+r,h)}];dr(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),dr(u).call(u,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:yo.avg(u[0].point,u[2].point)},{corners:[c[0],c[1],u[1],u[0]],center:yo.avg(u[1].point,u[0].point)},{corners:[c[1],c[2],u[2],u[1]],center:yo.avg(u[2].point,u[1].point)},{corners:[c[2],c[3],u[3],u[2]],center:yo.avg(u[3].point,u[2].point)},{corners:[c[3],c[0],u[0],u[3]],center:yo.avg(u[0].point,u[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}Kr(f).call(f,(function(t,e){var i=e.dist-t.dist;return i||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=n;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},fa.prototype._polygon=function(t,e,i,r){if(!(e.length<2)){void 0!==i&&(t.fillStyle=i),void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var n=1;n<e.length;++n){var o=e[n];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),xr(t).call(t),t.stroke()}},fa.prototype._drawCircle=function(t,e,i,r,n){var o=this._calcRadius(e,n);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=r,t.fillStyle=i,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),xr(t).call(t),t.stroke()},fa.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},fa.prototype._getColorsColor=function(t){var e,i,r;if(t&&t.point&&t.point.data&&t.point.data.style&&(r=t.point.data.style),r&&"object"===tr(r)&&xr(r)&&r.stroke)return{fill:xr(r),border:r.stroke};if("string"==typeof t.point.value)e=t.point.value,i=t.point.value;else{var n=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(n,1),i=this._colormap(n,.8)}return{fill:e,border:i}},fa.prototype._getColorsSize=function(){return{fill:xr(this.dataColor),border:this.dataColor.stroke}},fa.prototype._colormap=function(t){var e,i,r,n,o,a,s,l,h,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,u=this.colormap;if(Qt(u)){var f=u.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),v=t*f-d,y=u[d],m=u[p];e=y.r+v*(m.r-y.r),i=y.g+v*(m.g-y.g),r=y.b+v*(m.b-y.b)}else if("function"==typeof u){var g=u(t);e=g.r,i=g.g,r=g.b,n=g.a}else{var b=240*(1-t),x=po(b/360,1,1);e=x.r,i=x.g,r=x.b}return"number"!=typeof n||qt(n)?Jt(o=Jt(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(i*c),", ")).call(o,Math.round(r*c),")"):Jt(s=Jt(l=Jt(h="RGBA(".concat(Math.round(e*c),", ")).call(h,Math.round(i*c),", ")).call(l,Math.round(r*c),", ")).call(s,n,")")},fa.prototype._calcRadius=function(t,e){var i;return void 0===e&&(e=this._dotSize()),(i=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(i=0),i},fa.prototype._redrawBarGraphPoint=function(t,e){var i=this.xBarWidth/2,r=this.yBarWidth/2,n=this._getColorsRegular(e);this._redrawBar(t,e,i,r,xr(n),n.border)},fa.prototype._redrawBarColorGraphPoint=function(t,e){var i=this.xBarWidth/2,r=this.yBarWidth/2,n=this._getColorsColor(e);this._redrawBar(t,e,i,r,xr(n),n.border)},fa.prototype._redrawBarSizeGraphPoint=function(t,e){var i=(e.point.value-this.valueRange.min)/this.valueRange.range(),r=this.xBarWidth/2*(.8*i+.2),n=this.yBarWidth/2*(.8*i+.2),o=this._getColorsSize();this._redrawBar(t,e,r,n,xr(o),o.border)},fa.prototype._redrawDotGraphPoint=function(t,e){var i=this._getColorsRegular(e);this._drawCircle(t,e,xr(i),i.border)},fa.prototype._redrawDotLineGraphPoint=function(t,e){var i=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,i,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},fa.prototype._redrawDotColorGraphPoint=function(t,e){var i=this._getColorsColor(e);this._drawCircle(t,e,xr(i),i.border)},fa.prototype._redrawDotSizeGraphPoint=function(t,e){var i=this._dotSize(),r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=i*this.dotSizeMinFraction,o=n+(i*this.dotSizeMaxFraction-n)*r,a=this._getColorsSize();this._drawCircle(t,e,xr(a),a.border,o)},fa.prototype._redrawSurfaceGraphPoint=function(t,e){var i=e.pointRight,r=e.pointTop,n=e.pointCross;if(void 0!==e&&void 0!==i&&void 0!==r&&void 0!==n){var o,a,s,l=!0;if(this.showGrayBottom||this.showShadow){var h=yo.subtract(n.trans,e.trans),c=yo.subtract(r.trans,i.trans),u=yo.crossProduct(h,c);if(this.showPerspective){var f=yo.avg(yo.avg(e.trans,n.trans),yo.avg(i.trans,r.trans));s=-yo.dotProduct(u.normalize(),f.normalize())}else s=u.z/u.length();l=s>0}if(l||!this.showGrayBottom){var d=((e.point.value+i.point.value+r.point.value+n.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,i,n,r];this._polygon(t,v,o,a)}},fa.prototype._drawGridLine=function(t,e,i){if(void 0!==e&&void 0!==i){var r=((e.point.value+i.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(r,1),this._line(t,e.screen,i.screen)}},fa.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},fa.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},fa.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var i=this.dataPoints[t];this._pointDrawingMethod.call(this,e,i)}},fa.prototype._storeMousePosition=function(t){this.startMouseX=da(t),this.startMouseY=pa(t),this._startCameraOffset=this.camera.getOffset()},fa.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},co(document,"mousemove",e.onmousemove),co(document,"mouseup",e.onmouseup),fo(t)}},fa.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Pr(da(t))-this.startMouseX,i=Pr(pa(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var r=.5*this.frame.clientWidth,n=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/r*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+i/n*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,l=this.startArmRotation.vertical+i/200,h=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<h&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<h&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(l))<h&&(l=Math.round(l/Math.PI)*Math.PI),Math.abs(Math.cos(l))<h&&(l=(Math.round(l/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,l)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),fo(t)},fa.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,uo(document,"mousemove",this.onmousemove),uo(document,"mouseup",this.onmouseup),fo(t)},fa.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),i=da(t)-e.left,r=pa(t)-e.top,n=this._dataPointFromXY(i,r);n&&(this.onclick_callback&&this.onclick_callback(n.point.data),this.emit("click",n.point.data))}fo(t)}},fa.prototype._onTooltip=function(t){var e=this.tooltipDelay,i=this.frame.getBoundingClientRect(),r=da(t)-i.left,n=pa(t)-i.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(r,n);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=wt((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(r,n);t&&a._showTooltip(t)}),e)}},fa.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},co(document,"touchmove",e.ontouchmove),co(document,"touchend",e.ontouchend),this._onMouseDown(t)},fa.prototype._onTouchMove=function(t){this._onMouseMove(t)},fa.prototype._onTouchEnd=function(t){this.touchDown=!1,uo(document,"touchmove",this.ontouchmove),uo(document,"touchend",this.ontouchend),this._onMouseUp(t)},fa.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var i=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(i),this.redraw(),this._hideTooltip()}var r=this.getCameraPosition();this.emit("cameraPositionChange",r),fo(t)}},fa.prototype._insideTriangle=function(t,e){var i=e[0],r=e[1],n=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x)),s=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),l=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=l&&s!=l||0!=a&&0!=l&&a!=l)},fa.prototype._dataPointFromXY=function(t,e){var i,r=null,n=null,o=null,a=new mo(t,e);if(this.style===fa.STYLE.BAR||this.style===fa.STYLE.BARCOLOR||this.style===fa.STYLE.BARSIZE)for(i=this.dataPoints.length-1;i>=0;i--){var s=(r=this.dataPoints[i]).surfaces;if(s)for(var l=s.length-1;l>=0;l--){var h=s[l].corners,c=[h[0].screen,h[1].screen,h[2].screen],u=[h[2].screen,h[3].screen,h[0].screen];if(this._insideTriangle(a,c)||this._insideTriangle(a,u))return r}}else for(i=0;i<this.dataPoints.length;i++){var f=(r=this.dataPoints[i]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),v=Math.sqrt(d*d+p*p);(null===o||v<o)&&v<100&&(o=v,n=r)}}return n},fa.prototype.hasBars=function(t){return t==fa.STYLE.BAR||t==fa.STYLE.BARCOLOR||t==fa.STYLE.BARSIZE},fa.prototype._showTooltip=function(t){var e,i,r;this.tooltip?(e=this.tooltip.dom.content,i=this.tooltip.dom.line,r=this.tooltip.dom.dot):(e=document.createElement("div"),ft(e.style,{},this.tooltipStyle.content),e.style.position="absolute",i=document.createElement("div"),ft(i.style,{},this.tooltipStyle.line),i.style.position="absolute",r=document.createElement("div"),ft(r.style,{},this.tooltipStyle.dot),r.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:i,dot:r}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(i),this.frame.appendChild(r);var n=e.offsetWidth,o=e.offsetHeight,a=i.offsetHeight,s=r.offsetWidth,l=r.offsetHeight,h=t.screen.x-n/2;h=Math.min(Math.max(h,10),this.frame.clientWidth-10-n),i.style.left=t.screen.x+"px",i.style.top=t.screen.y-a+"px",e.style.left=h+"px",e.style.top=t.screen.y-a-o+"px",r.style.left=t.screen.x-s/2+"px",r.style.top=t.screen.y-l/2+"px"},fa.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},fa.prototype.setCameraPosition=function(t){Go(t,this),this.redraw()},fa.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()},t.Graph3d=fa,t.Graph3dCamera=Oo,t.Graph3dFilter=ca,t.Graph3dPoint2d=mo,t.Graph3dPoint3d=yo,t.Graph3dSlider=go,t.Graph3dStepNumber=xo,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
